/**
 * Planck.js v1.0.0-beta.0
 * @license The MIT license
 * @copyright Copyright (c) 2021 Erin Catto, Ali Shakiba
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).planck={})}(this,(function(t){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */var e=function(t,i){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i])})(t,i)};function i(t,i){if("function"!=typeof i&&null!==i)throw new TypeError("Class extends value "+String(i)+" is not a constructor or null");function o(){this.constructor=t}e(t,i),t.prototype=null===i?Object.create(i):(o.prototype=i.prototype,new o)}var o=function(){return(o=Object.assign||function(t){for(var e,i=1,o=arguments.length;i<o;i++)for(var s in e=arguments[i])Object.prototype.hasOwnProperty.call(e,s)&&(t[s]=e[s]);return t}).apply(this,arguments)},s=function(t,e){null==t&&(t={});var i=o({},t);for(var s in e)e.hasOwnProperty(s)&&void 0===t[s]&&(i[s]=e[s]);if("function"==typeof Object.getOwnPropertySymbols)for(var n=Object.getOwnPropertySymbols(e),r=0;r<n.length;r++){var m=n[r];e.propertyIsEnumerable(m)&&void 0===t[m]&&(i[m]=e[m])}return i},n=Object.assign(Object.create(Math),{EPSILON:1e-9,isFinite:function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},assert:function(t){},nextPowerOfTwo:function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},isPowerOfTwo:function(t){return t>0&&0==(t&t-1)},mod:function(t,e,i){return void 0===e?(i=1,e=0):void 0===i&&(i=e,e=0),i>e?(t=(t-e)%(i-e))+(t<0?i:e):(t=(t-i)%(e-i))+(t<=0?e:i)},clamp:function(t,e,i){return t<e?e:t>i?i:t},random:function(t,e){return void 0===t?(e=1,t=0):void 0===e&&(e=t,t=0),t===e?t:Math.random()*(e-t)+t}}),r=function(){function t(e,i){if(!(this instanceof t))return new t(e,i);void 0===e?(this.x=0,this.y=0):"object"==typeof e?(this.x=e.x,this.y=e.y):(this.x=e,this.y=i)}return t.prototype._serialize=function(){return{x:this.x,y:this.y}},t._deserialize=function(e){var i=Object.create(t.prototype);return i.x=e.x,i.y=e.y,i},t.zero=function(){var e=Object.create(t.prototype);return e.x=0,e.y=0,e},t.neo=function(e,i){var o=Object.create(t.prototype);return o.x=e,o.y=i,o},t.clone=function(e){return t.neo(e.x,e.y)},t.prototype.toString=function(){return JSON.stringify(this)},t.isValid=function(t){return null!=t&&(n.isFinite(t.x)&&n.isFinite(t.y))},t.assert=function(t){},t.prototype.clone=function(){return t.clone(this)},t.prototype.setZero=function(){return this.x=0,this.y=0,this},t.prototype.set=function(t,e){return"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=e),this},t.prototype.setNum=function(t,e){return this.x=t,this.y=e,this},t.prototype.setVec2=function(t){return this.x=t.x,this.y=t.y,this},t.prototype.wSet=function(t,e,i,o){return void 0!==i||void 0!==o?this.setCombine(t,e,i,o):this.setMul(t,e)},t.prototype.setCombine=function(t,e,i,o){var s=t*e.x+i*o.x,n=t*e.y+i*o.y;return this.x=s,this.y=n,this},t.prototype.setMul=function(t,e){var i=t*e.x,o=t*e.y;return this.x=i,this.y=o,this},t.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this},t.prototype.wAdd=function(t,e,i,o){return void 0!==i||void 0!==o?this.addCombine(t,e,i,o):this.addMul(t,e)},t.prototype.addCombine=function(t,e,i,o){var s=t*e.x+i*o.x,n=t*e.y+i*o.y;return this.x+=s,this.y+=n,this},t.prototype.addMul=function(t,e){var i=t*e.x,o=t*e.y;return this.x+=i,this.y+=o,this},t.prototype.wSub=function(t,e,i,o){return void 0!==i||void 0!==o?this.subCombine(t,e,i,o):this.subMul(t,e)},t.prototype.subCombine=function(t,e,i,o){var s=t*e.x+i*o.x,n=t*e.y+i*o.y;return this.x-=s,this.y-=n,this},t.prototype.subMul=function(t,e){var i=t*e.x,o=t*e.y;return this.x-=i,this.y-=o,this},t.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this},t.prototype.mul=function(t){return this.x*=t,this.y*=t,this},t.prototype.length=function(){return t.lengthOf(this)},t.prototype.lengthSquared=function(){return t.lengthSquared(this)},t.prototype.normalize=function(){var t=this.length();if(t<n.EPSILON)return 0;var e=1/t;return this.x*=e,this.y*=e,t},t.lengthOf=function(t){return n.sqrt(t.x*t.x+t.y*t.y)},t.lengthSquared=function(t){return t.x*t.x+t.y*t.y},t.distance=function(t,e){var i=t.x-e.x,o=t.y-e.y;return n.sqrt(i*i+o*o)},t.distanceSquared=function(t,e){var i=t.x-e.x,o=t.y-e.y;return i*i+o*o},t.areEqual=function(t,e){return t===e||"object"==typeof e&&null!==e&&t.x===e.x&&t.y===e.y},t.skew=function(e){return t.neo(-e.y,e.x)},t.dot=function(t,e){return t.x*e.x+t.y*e.y},t.cross=function(e,i){return"number"==typeof i?t.neo(i*e.y,-i*e.x):"number"==typeof e?t.neo(-e*i.y,e*i.x):e.x*i.y-e.y*i.x},t.crossVec2Vec2=function(t,e){return t.x*e.y-t.y*e.x},t.crossVec2Num=function(e,i){return t.neo(i*e.y,-i*e.x)},t.crossNumVec2=function(e,i){return t.neo(-e*i.y,e*i.x)},t.addCross=function(e,i,o){return"number"==typeof o?t.neo(o*i.y+e.x,-o*i.x+e.y):"number"==typeof i?t.neo(-i*o.y+e.x,i*o.x+e.y):void 0},t.addCrossVec2Num=function(e,i,o){return t.neo(o*i.y+e.x,-o*i.x+e.y)},t.addCrossNumVec2=function(e,i,o){return t.neo(-i*o.y+e.x,i*o.x+e.y)},t.add=function(e,i){return t.neo(e.x+i.x,e.y+i.y)},t.wAdd=function(e,i,o,s){return void 0!==o||void 0!==s?t.combine(e,i,o,s):t.mulNumVec2(e,i)},t.combine=function(e,i,o,s){return t.zero().setCombine(e,i,o,s)},t.sub=function(e,i){return t.neo(e.x-i.x,e.y-i.y)},t.mul=function(e,i){return"object"==typeof e?t.neo(e.x*i,e.y*i):"object"==typeof i?t.neo(e*i.x,e*i.y):void 0},t.mulVec2Num=function(e,i){return t.neo(e.x*i,e.y*i)},t.mulNumVec2=function(e,i){return t.neo(e*i.x,e*i.y)},t.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},t.neg=function(e){return t.neo(-e.x,-e.y)},t.abs=function(e){return t.neo(n.abs(e.x),n.abs(e.y))},t.mid=function(e,i){return t.neo(.5*(e.x+i.x),.5*(e.y+i.y))},t.upper=function(e,i){return t.neo(n.max(e.x,i.x),n.max(e.y,i.y))},t.lower=function(e,i){return t.neo(n.min(e.x,i.x),n.min(e.y,i.y))},t.prototype.clamp=function(t){var e=this.x*this.x+this.y*this.y;if(e>t*t){var i=t/n.sqrt(e);this.x*=i,this.y*=i}return this},t.clamp=function(e,i){var o=t.neo(e.x,e.y);return o.clamp(i),o},t.scaleFn=function(e,i){return function(o){return t.neo(o.x*e,o.y*i)}},t.translateFn=function(e,i){return function(o){return t.neo(o.x+e,o.y+i)}},t}(),m=function(){function t(e,i){if(!(this instanceof t))return new t(e,i);this.lowerBound=r.zero(),this.upperBound=r.zero(),"object"==typeof e&&this.lowerBound.setVec2(e),"object"==typeof i?this.upperBound.setVec2(i):"object"==typeof e&&this.upperBound.setVec2(e)}return t.prototype.isValid=function(){return t.isValid(this)},t.isValid=function(t){return null!=t&&(r.isValid(t.lowerBound)&&r.isValid(t.upperBound)&&r.sub(t.upperBound,t.lowerBound).lengthSquared()>=0)},t.assert=function(t){},t.prototype.getCenter=function(){return r.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},t.prototype.getExtents=function(){return r.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},t.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},t.prototype.combine=function(t,e){e=e||this;var i=t.lowerBound,o=t.upperBound,s=e.lowerBound,r=e.upperBound,m=n.min(i.x,s.x),a=n.min(i.y,s.y),c=n.max(r.x,o.x),h=n.max(r.y,o.y);this.lowerBound.setNum(m,a),this.upperBound.setNum(c,h)},t.prototype.combinePoints=function(t,e){this.lowerBound.setNum(n.min(t.x,e.x),n.min(t.y,e.y)),this.upperBound.setNum(n.max(t.x,e.x),n.max(t.y,e.y))},t.prototype.set=function(t){this.lowerBound.setNum(t.lowerBound.x,t.lowerBound.y),this.upperBound.setNum(t.upperBound.x,t.upperBound.y)},t.prototype.contains=function(t){var e=!0;return e=(e=(e=(e=e&&this.lowerBound.x<=t.lowerBound.x)&&this.lowerBound.y<=t.lowerBound.y)&&t.upperBound.x<=this.upperBound.x)&&t.upperBound.y<=this.upperBound.y},t.prototype.extend=function(e){return t.extend(this,e),this},t.extend=function(t,e){t.lowerBound.x-=e,t.lowerBound.y-=e,t.upperBound.x+=e,t.upperBound.y+=e},t.testOverlap=function(t,e){var i=e.lowerBound.x-t.upperBound.x,o=t.lowerBound.x-e.upperBound.x,s=e.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-e.upperBound.y;return!(i>0||s>0||o>0||n>0)},t.areEqual=function(t,e){return r.areEqual(t.lowerBound,e.lowerBound)&&r.areEqual(t.upperBound,e.upperBound)},t.diff=function(t,e){var i=n.max(0,n.min(t.upperBound.x,e.upperBound.x)-n.max(e.lowerBound.x,t.lowerBound.x)),o=n.max(0,n.min(t.upperBound.y,e.upperBound.y)-n.max(e.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(e.upperBound.x-e.lowerBound.x)*(e.upperBound.y-e.lowerBound.y)-i*o},t.prototype.rayCast=function(t,e){for(var i=-1/0,o=1/0,s=e.p1,m=r.sub(e.p2,e.p1),a=r.abs(m),c=r.zero(),h="x";null!==h;h="x"===h?"y":null)if(a.x<n.EPSILON){if(s[h]<this.lowerBound[h]||this.upperBound[h]<s[h])return!1}else{var _=1/m[h],l=(this.lowerBound[h]-s[h])*_,u=(this.upperBound[h]-s[h])*_,p=-1;if(l>u){var y=l;l=u,u=y,p=1}if(l>i&&(c.setZero(),c[h]=p,i=l),i>(o=n.min(o,u)))return!1}return!(i<0||e.maxFraction<i)&&(t.fraction=i,t.normal=c,!0)},t.prototype.toString=function(){return JSON.stringify(this)},t}(),a=function(){function t(){}return Object.defineProperty(t,"linearSlopSquared",{get:function(){return t.linearSlop*t.linearSlop},enumerable:!1,configurable:!0}),Object.defineProperty(t,"polygonRadius",{get:function(){return 2*t.linearSlop},enumerable:!1,configurable:!0}),Object.defineProperty(t,"maxTranslationSquared",{get:function(){return t.maxTranslation*t.maxTranslation},enumerable:!1,configurable:!0}),Object.defineProperty(t,"maxRotationSquared",{get:function(){return t.maxRotation*t.maxRotation},enumerable:!1,configurable:!0}),Object.defineProperty(t,"linearSleepToleranceSqr",{get:function(){return Math.pow(t.linearSleepTolerance,2)},enumerable:!1,configurable:!0}),Object.defineProperty(t,"angularSleepToleranceSqr",{get:function(){return Math.pow(t.angularSleepTolerance,2)},enumerable:!1,configurable:!0}),t.maxManifoldPoints=2,t.maxPolygonVertices=12,t.aabbExtension=.1,t.aabbMultiplier=2,t.linearSlop=.005,t.angularSlop=2/180*Math.PI,t.maxSubSteps=8,t.maxTOIContacts=32,t.maxTOIIterations=20,t.maxDistnceIterations=20,t.velocityThreshold=1,t.maxLinearCorrection=.2,t.maxAngularCorrection=8/180*Math.PI,t.maxTranslation=2,t.maxRotation=.5*Math.PI,t.baumgarte=.2,t.toiBaugarte=.75,t.timeToSleep=.5,t.linearSleepTolerance=.01,t.angularSleepTolerance=2/180*Math.PI,t}(),c=function(){function t(t){this._list=[],this._max=1/0,this._createCount=0,this._outCount=0,this._inCount=0,this._discardCount=0,this._list=[],this._max=t.max||this._max,this._createFn=t.create,this._outFn=t.allocate,this._inFn=t.release,this._discardFn=t.discard}return t.prototype.max=function(t){return"number"==typeof t?(this._max=t,this):this._max},t.prototype.size=function(){return this._list.length},t.prototype.allocate=function(){var t;return this._list.length>0?t=this._list.shift():(this._createCount++,t="function"==typeof this._createFn?this._createFn():{}),this._outCount++,"function"==typeof this._outFn&&this._outFn(t),t},t.prototype.release=function(t){this._list.length<this._max?(this._inCount++,"function"==typeof this._inFn&&this._inFn(t),this._list.push(t)):(this._discardCount++,"function"==typeof this._discardFn&&(t=this._discardFn(t)))},t.prototype.toString=function(){return" +"+this._createCount+" >"+this._outCount+" <"+this._inCount+" -"+this._discardCount+" ="+this._list.length+"/"+this._max},t}(),h=function(){function t(t){this.aabb=new m,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.id=t}return t.prototype.toString=function(){return this.id+": "+this.userData},t.prototype.isLeaf=function(){return null==this.child1},t}(),_=function(){function t(){this.inputPool=new c({create:function(){return{}},release:function(t){}}),this.stackPool=new c({create:function(){return[]},release:function(t){t.length=0}}),this.iteratorPool=new c({create:function(){return new l},release:function(t){t.close()}}),this.m_root=null,this.m_nodes={},this.m_lastProxyId=0,this.m_pool=new c({create:function(){return new h}})}return t.prototype.getUserData=function(t){return this.m_nodes[t].userData},t.prototype.getFatAABB=function(t){return this.m_nodes[t].aabb},t.prototype.allocateNode=function(){var t=this.m_pool.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},t.prototype.freeNode=function(t){this.m_pool.release(t),t.height=-1,delete this.m_nodes[t.id]},t.prototype.createProxy=function(t,e){var i=this.allocateNode();return i.aabb.set(t),m.extend(i.aabb,a.aabbExtension),i.userData=e,i.height=0,this.insertLeaf(i),i.id},t.prototype.destroyProxy=function(t){var e=this.m_nodes[t];this.removeLeaf(e),this.freeNode(e)},t.prototype.moveProxy=function(t,e,i){var o=this.m_nodes[t];return!o.aabb.contains(e)&&(this.removeLeaf(o),o.aabb.set(e),e=o.aabb,m.extend(e,a.aabbExtension),i.x<0?e.lowerBound.x+=i.x*a.aabbMultiplier:e.upperBound.x+=i.x*a.aabbMultiplier,i.y<0?e.lowerBound.y+=i.y*a.aabbMultiplier:e.upperBound.y+=i.y*a.aabbMultiplier,this.insertLeaf(o),!0)},t.prototype.insertLeaf=function(t){if(null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var e=t.aabb,i=this.m_root;!i.isLeaf();){var o=i.child1,s=i.child2,r=i.aabb.getPerimeter(),a=new m;a.combine(i.aabb,e);var c=a.getPerimeter(),h=2*c,_=2*(c-r),l=void 0;if(o.isLeaf()){(y=new m).combine(e,o.aabb),l=y.getPerimeter()+_}else{(y=new m).combine(e,o.aabb);var u=o.aabb.getPerimeter();l=y.getPerimeter()-u+_}var p=void 0;if(s.isLeaf()){(y=new m).combine(e,s.aabb),p=y.getPerimeter()+_}else{var y;(y=new m).combine(e,s.aabb);u=s.aabb.getPerimeter();p=y.getPerimeter()-u+_}if(h<l&&h<p)break;i=l<p?o:s}var d=i,f=d.parent,v=this.allocateNode();for(v.parent=f,v.userData=null,v.aabb.combine(e,d.aabb),v.height=d.height+1,null!=f?(f.child1===d?f.child1=v:f.child2=v,v.child1=d,v.child2=t,d.parent=v,t.parent=v):(v.child1=d,v.child2=t,d.parent=v,t.parent=v,this.m_root=v),i=t.parent;null!=i;){o=(i=this.balance(i)).child1,s=i.child2;i.height=1+n.max(o.height,s.height),i.aabb.combine(o.aabb,s.aabb),i=i.parent}},t.prototype.removeLeaf=function(t){if(t!==this.m_root){var e,i=t.parent,o=i.parent;if(e=i.child1===t?i.child2:i.child1,null!=o){o.child1===i?o.child1=e:o.child2=e,e.parent=o,this.freeNode(i);for(var s=o;null!=s;){var r=(s=this.balance(s)).child1,m=s.child2;s.aabb.combine(r.aabb,m.aabb),s.height=1+n.max(r.height,m.height),s=s.parent}}else this.m_root=e,e.parent=null,this.freeNode(i)}else this.m_root=null},t.prototype.balance=function(t){var e=t;if(e.isLeaf()||e.height<2)return t;var i=e.child1,o=e.child2,s=o.height-i.height;if(s>1){var r=o.child1,m=o.child2;return o.child1=e,o.parent=e.parent,e.parent=o,null!=o.parent?o.parent.child1===t?o.parent.child1=o:o.parent.child2=o:this.m_root=o,r.height>m.height?(o.child2=r,e.child2=m,m.parent=e,e.aabb.combine(i.aabb,m.aabb),o.aabb.combine(e.aabb,r.aabb),e.height=1+n.max(i.height,m.height),o.height=1+n.max(e.height,r.height)):(o.child2=m,e.child2=r,r.parent=e,e.aabb.combine(i.aabb,r.aabb),o.aabb.combine(e.aabb,m.aabb),e.height=1+n.max(i.height,r.height),o.height=1+n.max(e.height,m.height)),o}if(s<-1){var a=i.child1,c=i.child2;return i.child1=e,i.parent=e.parent,e.parent=i,null!=i.parent?i.parent.child1===e?i.parent.child1=i:i.parent.child2=i:this.m_root=i,a.height>c.height?(i.child2=a,e.child1=c,c.parent=e,e.aabb.combine(o.aabb,c.aabb),i.aabb.combine(e.aabb,a.aabb),e.height=1+n.max(o.height,c.height),i.height=1+n.max(e.height,a.height)):(i.child2=c,e.child1=a,a.parent=e,e.aabb.combine(o.aabb,a.aabb),i.aabb.combine(e.aabb,c.aabb),e.height=1+n.max(o.height,a.height),i.height=1+n.max(e.height,c.height)),i}return e},t.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},t.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,e=this.m_root.aabb.getPerimeter(),i=0,o=this.iteratorPool.allocate().preorder(this.m_root);t=o.next();)t.height<0||(i+=t.aabb.getPerimeter());return this.iteratorPool.release(o),i/e},t.prototype.computeHeight=function(t){var e;if((e=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var i=this.computeHeight(e.child1.id),o=this.computeHeight(e.child2.id);return 1+n.max(i,o)},t.prototype.validateStructure=function(t){if(null!=t){this.m_root;var e=t.child1,i=t.child2;t.isLeaf()||(this.validateStructure(e),this.validateStructure(i))}},t.prototype.validateMetrics=function(t){if(null!=t){var e=t.child1,i=t.child2;if(!t.isLeaf()){var o=e.height,s=i.height;n.max(o,s),(new m).combine(e.aabb,i.aabb),this.validateMetrics(e),this.validateMetrics(i)}}},t.prototype.validate=function(){this.validateStructure(this.m_root),this.validateMetrics(this.m_root)},t.prototype.getMaxBalance=function(){for(var t,e=0,i=this.iteratorPool.allocate().preorder(this.m_root);t=i.next();)if(!(t.height<=1)){var o=n.abs(t.child2.height-t.child1.height);e=n.max(e,o)}return this.iteratorPool.release(i),e},t.prototype.rebuildBottomUp=function(){for(var t,e=[],i=0,o=this.iteratorPool.allocate().preorder(this.m_root);t=o.next();)t.height<0||(t.isLeaf()?(t.parent=null,e[i]=t,++i):this.freeNode(t));for(this.iteratorPool.release(o);i>1;){for(var s=1/0,r=-1,a=-1,c=0;c<i;++c)for(var h=e[c].aabb,_=c+1;_<i;++_){var l=e[_].aabb,u=new m;u.combine(h,l);var p=u.getPerimeter();p<s&&(r=c,a=_,s=p)}var y=e[r],d=e[a],f=this.allocateNode();f.child1=y,f.child2=d,f.height=1+n.max(y.height,d.height),f.aabb.combine(y.aabb,d.aabb),f.parent=null,y.parent=f,d.parent=f,e[a]=e[i-1],e[r]=f,--i}this.m_root=e[0]},t.prototype.shiftOrigin=function(t){for(var e,i=this.iteratorPool.allocate().preorder(this.m_root);e=i.next();){var o=e.aabb;o.lowerBound.x-=t.x,o.lowerBound.y-=t.y,o.upperBound.x-=t.x,o.upperBound.y-=t.y}this.iteratorPool.release(i)},t.prototype.query=function(t,e){var i=this.stackPool.allocate();for(i.push(this.m_root);i.length>0;){var o=i.pop();if(null!=o)if(m.testOverlap(o.aabb,t))if(o.isLeaf()){if(!1===e(o.id))return}else i.push(o.child1),i.push(o.child2)}this.stackPool.release(i)},t.prototype.rayCast=function(t,e){var i=t.p1,o=t.p2,s=r.sub(o,i);s.normalize();var a=r.crossNumVec2(1,s),c=r.abs(a),h=t.maxFraction,_=new m,l=r.combine(1-h,i,h,o);_.combinePoints(i,l);var u=this.stackPool.allocate(),p=this.inputPool.allocate();for(u.push(this.m_root);u.length>0;){var y=u.pop();if(null!=y&&!1!==m.testOverlap(y.aabb,_)){var d=y.aabb.getCenter(),f=y.aabb.getExtents();if(!(n.abs(r.dot(a,r.sub(i,d)))-r.dot(c,f)>0))if(y.isLeaf()){p.p1=r.clone(t.p1),p.p2=r.clone(t.p2),p.maxFraction=h;var v=e(p,y.id);if(0===v)return;v>0&&(h=v,l=r.combine(1-h,i,h,o),_.combinePoints(i,l))}else u.push(y.child1),u.push(y.child2)}}this.stackPool.release(u),this.inputPool.release(p)},t}(),l=function(){function t(){this.parents=[],this.states=[]}return t.prototype.preorder=function(t){return this.parents.length=0,this.parents.push(t),this.states.length=0,this.states.push(0),this},t.prototype.next=function(){for(;this.parents.length>0;){var t=this.parents.length-1,e=this.parents[t];if(0===this.states[t])return this.states[t]=1,e;if(1===this.states[t]&&(this.states[t]=2,e.child1))return this.parents.push(e.child1),this.states.push(1),e.child1;if(2===this.states[t]&&(this.states[t]=3,e.child2))return this.parents.push(e.child2),this.states.push(1),e.child2;this.parents.pop(),this.states.pop()}},t.prototype.close=function(){this.parents.length=0},t}(),u=function(){function t(){var t=this;this.m_tree=new _,this.m_proxyCount=0,this.m_moveBuffer=[],this.query=function(e,i){t.m_tree.query(e,i)},this.queryCallback=function(e){if(e===t.m_queryProxyId)return!0;var i=n.min(e,t.m_queryProxyId),o=n.max(e,t.m_queryProxyId),s=t.m_tree.getUserData(i),r=t.m_tree.getUserData(o);return t.m_callback(s,r),!0}}return t.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},t.prototype.testOverlap=function(t,e){var i=this.m_tree.getFatAABB(t),o=this.m_tree.getFatAABB(e);return m.testOverlap(i,o)},t.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},t.prototype.getProxyCount=function(){return this.m_proxyCount},t.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},t.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},t.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},t.prototype.rayCast=function(t,e){this.m_tree.rayCast(t,e)},t.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},t.prototype.createProxy=function(t,e){var i=this.m_tree.createProxy(t,e);return this.m_proxyCount++,this.bufferMove(i),i},t.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},t.prototype.moveProxy=function(t,e,i){this.m_tree.moveProxy(t,e,i)&&this.bufferMove(t)},t.prototype.touchProxy=function(t){this.bufferMove(t)},t.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},t.prototype.unbufferMove=function(t){for(var e=0;e<this.m_moveBuffer.length;++e)this.m_moveBuffer[e]===t&&(this.m_moveBuffer[e]=null)},t.prototype.updatePairs=function(t){for(this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var e=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(e,this.queryCallback)}},t}(),p=function(){function t(e){if(!(this instanceof t))return new t(e);"number"==typeof e?this.setAngle(e):"object"==typeof e?this.setRot(e):this.setIdentity()}return t.neo=function(e){var i=Object.create(t.prototype);return i.setAngle(e),i},t.clone=function(e){var i=Object.create(t.prototype);return i.s=e.s,i.c=e.c,i},t.identity=function(){var e=Object.create(t.prototype);return e.s=0,e.c=1,e},t.isValid=function(t){return null!=t&&(n.isFinite(t.s)&&n.isFinite(t.c))},t.assert=function(t){},t.prototype.setIdentity=function(){this.s=0,this.c=1},t.prototype.set=function(t){"object"==typeof t?(this.s=t.s,this.c=t.c):(this.s=n.sin(t),this.c=n.cos(t))},t.prototype.setRot=function(t){this.s=t.s,this.c=t.c},t.prototype.setAngle=function(t){this.s=n.sin(t),this.c=n.cos(t)},t.prototype.getAngle=function(){return n.atan2(this.s,this.c)},t.prototype.getXAxis=function(){return r.neo(this.c,this.s)},t.prototype.getYAxis=function(){return r.neo(-this.s,this.c)},t.mul=function(e,i){if("c"in i&&"s"in i){var o=t.identity();return o.s=e.s*i.c+e.c*i.s,o.c=e.c*i.c-e.s*i.s,o}if("x"in i&&"y"in i)return r.neo(e.c*i.x-e.s*i.y,e.s*i.x+e.c*i.y)},t.mulRot=function(e,i){var o=t.identity();return o.s=e.s*i.c+e.c*i.s,o.c=e.c*i.c-e.s*i.s,o},t.mulVec2=function(t,e){return r.neo(t.c*e.x-t.s*e.y,t.s*e.x+t.c*e.y)},t.mulSub=function(t,e,i){var o=t.c*(e.x-i.x)-t.s*(e.y-i.y),s=t.s*(e.x-i.x)+t.c*(e.y-i.y);return r.neo(o,s)},t.mulT=function(e,i){if("c"in i&&"s"in i){var o=t.identity();return o.s=e.c*i.s-e.s*i.c,o.c=e.c*i.c+e.s*i.s,o}if("x"in i&&"y"in i)return r.neo(e.c*i.x+e.s*i.y,-e.s*i.x+e.c*i.y)},t.mulTRot=function(e,i){var o=t.identity();return o.s=e.c*i.s-e.s*i.c,o.c=e.c*i.c+e.s*i.s,o},t.mulTVec2=function(t,e){return r.neo(t.c*e.x+t.s*e.y,-t.s*e.x+t.c*e.y)},t}(),y=function(){function t(e,i){if(!(this instanceof t))return new t(e,i);this.p=r.zero(),this.q=p.identity(),void 0!==e&&this.p.setVec2(e),void 0!==i&&this.q.setAngle(i)}return t.clone=function(e){var i=Object.create(t.prototype);return i.p=r.clone(e.p),i.q=p.clone(e.q),i},t.neo=function(e,i){var o=Object.create(t.prototype);return o.p=r.clone(e),o.q=p.clone(i),o},t.identity=function(){var e=Object.create(t.prototype);return e.p=r.zero(),e.q=p.identity(),e},t.prototype.setIdentity=function(){this.p.setZero(),this.q.setIdentity()},t.prototype.set=function(t,e){void 0===e?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(e))},t.prototype.setNum=function(t,e){this.p.setVec2(t),this.q.setAngle(e)},t.prototype.setTransform=function(t){this.p.setVec2(t.p),this.q.setRot(t.q)},t.isValid=function(t){return null!=t&&(r.isValid(t.p)&&p.isValid(t.q))},t.assert=function(t){},t.mul=function(e,i){if(Array.isArray(i)){for(var o=[],s=0;s<i.length;s++)o[s]=t.mul(e,i[s]);return o}return"x"in i&&"y"in i?t.mulVec2(e,i):"p"in i&&"q"in i?t.mulXf(e,i):void 0},t.mulAll=function(e,i){for(var o=[],s=0;s<i.length;s++)o[s]=t.mul(e,i[s]);return o},t.mulFn=function(e){return function(i){return t.mul(e,i)}},t.mulVec2=function(t,e){var i=t.q.c*e.x-t.q.s*e.y+t.p.x,o=t.q.s*e.x+t.q.c*e.y+t.p.y;return r.neo(i,o)},t.mulXf=function(e,i){var o=t.identity();return o.q=p.mulRot(e.q,i.q),o.p=r.add(p.mulVec2(e.q,i.p),e.p),o},t.mulT=function(e,i){return"x"in i&&"y"in i?t.mulTVec2(e,i):"p"in i&&"q"in i?t.mulTXf(e,i):void 0},t.mulTVec2=function(t,e){var i=e.x-t.p.x,o=e.y-t.p.y,s=t.q.c*i+t.q.s*o,n=-t.q.s*i+t.q.c*o;return r.neo(s,n)},t.mulTXf=function(e,i){var o=t.identity();return o.q.setRot(p.mulTRot(e.q,i.q)),o.p.setVec2(p.mulTVec2(e.q,r.sub(i.p,e.p))),o},t}(),d=function(){function t(t,e){this.localCenter=r.zero(),this.c=r.zero(),this.a=0,this.alpha0=0,this.c0=r.zero(),this.a0=0}return t.prototype.setTransform=function(t){var e=y.mulVec2(t,this.localCenter);this.c.setVec2(e),this.c0.setVec2(e),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},t.prototype.setLocalCenter=function(t,e){this.localCenter.setVec2(t);var i=y.mulVec2(e,this.localCenter);this.c.setVec2(i),this.c0.setVec2(i)},t.prototype.getTransform=function(t,e){void 0===e&&(e=0),t.q.setAngle((1-e)*this.a0+e*this.a),t.p.setCombine(1-e,this.c0,e,this.c),t.p.sub(p.mulVec2(t.q,this.localCenter))},t.prototype.advance=function(t){var e=(t-this.alpha0)/(1-this.alpha0);this.c0.setCombine(e,this.c,1-e,this.c0),this.a0=e*this.a+(1-e)*this.a0,this.alpha0=t},t.prototype.forward=function(){this.a0=this.a,this.c0.setVec2(this.c)},t.prototype.normalize=function(){var t=n.mod(this.a0,-n.PI,+n.PI);this.a-=this.a0-t,this.a0=t},t.prototype.clone=function(){var e=new t;return e.localCenter.setVec2(this.localCenter),e.alpha0=this.alpha0,e.a0=this.a0,e.a=this.a,e.c0.setVec2(this.c0),e.c.setVec2(this.c),e},t.prototype.set=function(t){this.localCenter.setVec2(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.setVec2(t.c0),this.c.setVec2(t.c)},t}(),f=function(){this.v=r.zero(),this.w=0},v=function(){function t(){this.c=r.zero(),this.a=0}return t.prototype.getTransform=function(t,e){return t.q.setAngle(this.a),t.p.setVec2(r.sub(this.c,p.mulVec2(t.q,e))),t},t}(),x=function(){function t(){}return t.isValid=function(t){return null!=t&&("string"==typeof t.m_type&&"number"==typeof t.m_radius)},t}(),A={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535},g=function(t,e){this.aabb=new m,this.fixture=t,this.childIndex=e,this.proxyId},b=function(){function t(t,e,i){e.shape?(i=e,e=e.shape):"number"==typeof i&&(i={density:i}),i=s(i,A),this.m_body=t,this.m_friction=i.friction,this.m_restitution=i.restitution,this.m_density=i.density,this.m_isSensor=i.isSensor,this.m_filterGroupIndex=i.filterGroupIndex,this.m_filterCategoryBits=i.filterCategoryBits,this.m_filterMaskBits=i.filterMaskBits,this.m_shape=e,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var o=this.m_shape.getChildCount(),n=0;n<o;++n)this.m_proxies[n]=new g(this,n);this.m_userData=i.userData}return t.prototype._reset=function(){var t=this.getBody(),e=t.m_world.m_broadPhase;this.destroyProxies(e),this.m_shape._reset&&this.m_shape._reset();for(var i=this.m_shape.getChildCount(),o=0;o<i;++o)this.m_proxies[o]=new g(this,o);this.createProxies(e,t.m_xf),t.resetMassData()},t.prototype._serialize=function(){return{friction:this.m_friction,restitution:this.m_restitution,density:this.m_density,isSensor:this.m_isSensor,filterGroupIndex:this.m_filterGroupIndex,filterCategoryBits:this.m_filterCategoryBits,filterMaskBits:this.m_filterMaskBits,shape:this.m_shape}},t._deserialize=function(e,i,o){var s=o(x,e.shape);return s&&new t(i,s,e)},t.prototype.getType=function(){return this.m_shape.getType()},t.prototype.getShape=function(){return this.m_shape},t.prototype.isSensor=function(){return this.m_isSensor},t.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},t.prototype.getUserData=function(){return this.m_userData},t.prototype.setUserData=function(t){this.m_userData=t},t.prototype.getBody=function(){return this.m_body},t.prototype.getNext=function(){return this.m_next},t.prototype.getDensity=function(){return this.m_density},t.prototype.setDensity=function(t){this.m_density=t},t.prototype.getFriction=function(){return this.m_friction},t.prototype.setFriction=function(t){this.m_friction=t},t.prototype.getRestitution=function(){return this.m_restitution},t.prototype.setRestitution=function(t){this.m_restitution=t},t.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},t.prototype.rayCast=function(t,e,i){return this.m_shape.rayCast(t,e,this.m_body.getTransform(),i)},t.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},t.prototype.getAABB=function(t){return this.m_proxies[t].aabb},t.prototype.createProxies=function(t,e){this.m_proxyCount=this.m_shape.getChildCount();for(var i=0;i<this.m_proxyCount;++i){var o=this.m_proxies[i];this.m_shape.computeAABB(o.aabb,e,i),o.proxyId=t.createProxy(o.aabb,o)}},t.prototype.destroyProxies=function(t){for(var e=0;e<this.m_proxyCount;++e){var i=this.m_proxies[e];t.destroyProxy(i.proxyId),i.proxyId=null}this.m_proxyCount=0},t.prototype.synchronize=function(t,e,i){for(var o=0;o<this.m_proxyCount;++o){var s=this.m_proxies[o],n=new m,a=new m;this.m_shape.computeAABB(n,e,s.childIndex),this.m_shape.computeAABB(a,i,s.childIndex),s.aabb.combine(n,a);var c=r.sub(i.p,e.p);t.moveProxy(s.proxyId,s.aabb,c)}},t.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},t.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},t.prototype.setFilterGroupIndex=function(t){this.m_filterGroupIndex=t},t.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},t.prototype.setFilterCategoryBits=function(t){this.m_filterCategoryBits=t},t.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},t.prototype.setFilterMaskBits=function(t){this.m_filterMaskBits=t},t.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var e=t.contact,i=e.getFixtureA(),o=e.getFixtureB();i!=this&&o!=this||e.flagForFiltering(),t=t.next}var s=this.m_body.getWorld();if(null!=s)for(var n=s.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},t.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex===this.m_filterGroupIndex&&0!==t.m_filterGroupIndex)return t.m_filterGroupIndex>0;var e=0!=(t.m_filterMaskBits&this.m_filterCategoryBits),i=0!=(t.m_filterCategoryBits&this.m_filterMaskBits);return e&&i},t}(),B="static",V="kinematic",w="dynamic",C={type:B,position:r.zero(),angle:0,linearVelocity:r.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null},M=function(){this.mass=0,this.center=r.zero(),this.I=0},I=function(){function t(t,e){e=s(e,C),this.m_world=t,this.m_awakeFlag=e.awake,this.m_autoSleepFlag=e.allowSleep,this.m_bulletFlag=e.bullet,this.m_fixedRotationFlag=e.fixedRotation,this.m_activeFlag=e.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=e.userData,this.m_type=e.type,this.m_type==w?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=y.identity(),this.m_xf.p=r.clone(e.position),this.m_xf.q.setAngle(e.angle),this.m_sweep=new d,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new f,this.c_position=new v,this.m_force=r.zero(),this.m_torque=0,this.m_linearVelocity=r.clone(e.linearVelocity),this.m_angularVelocity=e.angularVelocity,this.m_linearDamping=e.linearDamping,this.m_angularDamping=e.angularDamping,this.m_gravityScale=e.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null,this.m_destroyed=!1}return t.prototype._serialize=function(){for(var t=[],e=this.m_fixtureList;e;e=e.m_next)t.push(e);return{type:this.m_type,bullet:this.m_bulletFlag,position:this.m_xf.p,angle:this.m_xf.q.getAngle(),linearVelocity:this.m_linearVelocity,angularVelocity:this.m_angularVelocity,fixtures:t}},t._deserialize=function(e,i,o){var s=new t(i,e);if(e.fixtures)for(var n=e.fixtures.length-1;n>=0;n--){var r=o(b,e.fixtures[n],s);s._addFixture(r)}return s},t.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},t.prototype.getWorld=function(){return this.m_world},t.prototype.getNext=function(){return this.m_next},t.prototype.setUserData=function(t){this.m_userData=t},t.prototype.getUserData=function(){return this.m_userData},t.prototype.getFixtureList=function(){return this.m_fixtureList},t.prototype.getJointList=function(){return this.m_jointList},t.prototype.getContactList=function(){return this.m_contactList},t.prototype.isStatic=function(){return this.m_type==B},t.prototype.isDynamic=function(){return this.m_type==w},t.prototype.isKinematic=function(){return this.m_type==V},t.prototype.setStatic=function(){return this.setType(B),this},t.prototype.setDynamic=function(){return this.setType(w),this},t.prototype.setKinematic=function(){return this.setType(V),this},t.prototype.getType=function(){return this.m_type},t.prototype.setType=function(t){if(1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==B&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var e=this.m_contactList;e;){var i=e;e=e.next,this.m_world.destroyContact(i.contact)}this.m_contactList=null;for(var o=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)for(var n=s.m_proxyCount,r=0;r<n;++r)o.touchProxy(s.m_proxies[r].proxyId)}},t.prototype.isBullet=function(){return this.m_bulletFlag},t.prototype.setBullet=function(t){this.m_bulletFlag=!!t},t.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},t.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},t.prototype.isAwake=function(){return this.m_awakeFlag},t.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},t.prototype.isActive=function(){return this.m_activeFlag},t.prototype.setActive=function(t){if(t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var e=this.m_world.m_broadPhase,i=this.m_fixtureList;i;i=i.m_next)i.createProxies(e,this.m_xf);else{for(e=this.m_world.m_broadPhase,i=this.m_fixtureList;i;i=i.m_next)i.destroyProxies(e);for(var o=this.m_contactList;o;){var s=o;o=o.next,this.m_world.destroyContact(s.contact)}this.m_contactList=null}},t.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},t.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},t.prototype.getTransform=function(){return this.m_xf},t.prototype.setTransform=function(t,e){if(1!=this.isWorldLocked()){this.m_xf.setNum(t,e),this.m_sweep.setTransform(this.m_xf);for(var i=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.synchronize(i,this.m_xf,this.m_xf)}},t.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},t.prototype.synchronizeFixtures=function(){var t=y.identity();this.m_sweep.getTransform(t,0);for(var e=this.m_world.m_broadPhase,i=this.m_fixtureList;i;i=i.m_next)i.synchronize(e,t,this.m_xf)},t.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.setVec2(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},t.prototype.getPosition=function(){return this.m_xf.p},t.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},t.prototype.getAngle=function(){return this.m_sweep.a},t.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},t.prototype.getWorldCenter=function(){return this.m_sweep.c},t.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},t.prototype.getLinearVelocity=function(){return this.m_linearVelocity},t.prototype.getLinearVelocityFromWorldPoint=function(t){var e=r.sub(t,this.m_sweep.c);return r.add(this.m_linearVelocity,r.crossNumVec2(this.m_angularVelocity,e))},t.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},t.prototype.setLinearVelocity=function(t){this.m_type!=B&&(r.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.setVec2(t))},t.prototype.getAngularVelocity=function(){return this.m_angularVelocity},t.prototype.setAngularVelocity=function(t){this.m_type!=B&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},t.prototype.getLinearDamping=function(){return this.m_linearDamping},t.prototype.setLinearDamping=function(t){this.m_linearDamping=t},t.prototype.getAngularDamping=function(){return this.m_angularDamping},t.prototype.setAngularDamping=function(t){this.m_angularDamping=t},t.prototype.getGravityScale=function(){return this.m_gravityScale},t.prototype.setGravityScale=function(t){this.m_gravityScale=t},t.prototype.getMass=function(){return this.m_mass},t.prototype.getInertia=function(){return this.m_I+this.m_mass*r.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},t.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.setVec2(this.m_sweep.localCenter)},t.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.setVec2(this.m_xf.p),this.m_sweep.c.setVec2(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);for(var t=r.zero(),e=this.m_fixtureList;e;e=e.m_next)if(0!=e.m_density){var i=new M;e.getMassData(i),this.m_mass+=i.mass,t.addMul(i.mass,i.center),this.m_I+=i.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*r.dot(t,t),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var o=r.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(r.crossNumVec2(this.m_angularVelocity,r.sub(this.m_sweep.c,o)))},t.prototype.setMassData=function(t){if(1!=this.isWorldLocked()&&this.m_type==w){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*r.dot(t.center,t.center),this.m_invI=1/this.m_I);var e=r.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(r.crossNumVec2(this.m_angularVelocity,r.sub(this.m_sweep.c,e)))}},t.prototype.applyForce=function(t,e,i){void 0===i&&(i=!0),this.m_type==w&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=r.crossVec2Vec2(r.sub(e,this.m_sweep.c),t)))},t.prototype.applyForceToCenter=function(t,e){void 0===e&&(e=!0),this.m_type==w&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},t.prototype.applyTorque=function(t,e){void 0===e&&(e=!0),this.m_type==w&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},t.prototype.applyLinearImpulse=function(t,e,i){void 0===i&&(i=!0),this.m_type==w&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.addMul(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*r.crossVec2Vec2(r.sub(e,this.m_sweep.c),t)))},t.prototype.applyAngularImpulse=function(t,e){void 0===e&&(e=!0),this.m_type==w&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},t.prototype.shouldCollide=function(t){if(this.m_type!=w&&t.m_type!=w)return!1;for(var e=this.m_jointList;e;e=e.next)if(e.other==t&&0==e.joint.m_collideConnected)return!1;return!0},t.prototype._addFixture=function(t){if(1==this.isWorldLocked())return null;if(this.m_activeFlag){var e=this.m_world.m_broadPhase;t.createProxies(e,this.m_xf)}return t.m_next=this.m_fixtureList,this.m_fixtureList=t,t.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,t},t.prototype.createFixture=function(t,e){if(1==this.isWorldLocked())return null;var i=new b(this,t,e);return this._addFixture(i),i},t.prototype.destroyFixture=function(t){if(1!=this.isWorldLocked()){if(this.m_fixtureList===t)this.m_fixtureList=t.m_next;else for(var e=this.m_fixtureList;null!=e;){if(e.m_next===t){e.m_next=t.m_next;break}e=e.m_next}for(var i=this.m_contactList;i;){var o=i.contact;i=i.next;var s=o.getFixtureA(),n=o.getFixtureB();t!=s&&t!=n||this.m_world.destroyContact(o)}if(this.m_activeFlag){var r=this.m_world.m_broadPhase;t.destroyProxies(r)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},t.prototype.getWorldPoint=function(t){return y.mulVec2(this.m_xf,t)},t.prototype.getWorldVector=function(t){return p.mulVec2(this.m_xf.q,t)},t.prototype.getLocalPoint=function(t){return y.mulTVec2(this.m_xf,t)},t.prototype.getLocalVector=function(t){return p.mulTVec2(this.m_xf.q,t)},t.STATIC="static",t.KINEMATIC="kinematic",t.DYNAMIC="dynamic",t}(),S=function(){this.other=null,this.joint=null,this.prev=null,this.next=null},z=function(){function t(t,e,i){this.m_type="unknown-joint",this.m_prev=null,this.m_next=null,this.m_edgeA=new S,this.m_edgeB=new S,this.m_islandFlag=!1,e="bodyA"in t?t.bodyA:e,i="bodyB"in t?t.bodyB:i,this.m_bodyA=e,this.m_bodyB=i,this.m_collideConnected=!!t.collideConnected,this.m_userData=t.userData}return t.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},t.prototype.getType=function(){return this.m_type},t.prototype.getBodyA=function(){return this.m_bodyA},t.prototype.getBodyB=function(){return this.m_bodyB},t.prototype.getNext=function(){return this.m_next},t.prototype.getUserData=function(){return this.m_userData},t.prototype.setUserData=function(t){this.m_userData=t},t.prototype.getCollideConnected=function(){return this.m_collideConnected},t.prototype.shiftOrigin=function(t){},t}(),P={gjkCalls:0,gjkIters:0,gjkMaxIters:0,toiTime:0,toiMaxTime:0,toiCalls:0,toiIters:0,toiMaxIters:0,toiRootIters:0,toiMaxRootIters:0,toString:function(t){t="string"==typeof t?t:"\n";var e="";for(var i in this)"function"!=typeof this[i]&&"object"!=typeof this[i]&&(e+=i+": "+this[i]+t);return e}},T=function(){return Date.now()},F=function(t){return Date.now()-t};P.gjkCalls=0,P.gjkIters=0,P.gjkMaxIters=0;var L=function(){this.proxyA=new D,this.proxyB=new D,this.transformA=null,this.transformB=null,this.useRadii=!1},q=function(){this.pointA=r.zero(),this.pointB=r.zero()},N=function(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0},k=function(t,e,i){++P.gjkCalls;var o=i.proxyA,s=i.proxyB,m=i.transformA,c=i.transformB,h=new O;h.readCache(e,o,m,s,c);for(var _=h.m_v,l=a.maxDistnceIterations,u=[],d=[],f=0,v=0;v<l;){f=h.m_count;for(var x=0;x<f;++x)u[x]=_[x].indexA,d[x]=_[x].indexB;if(h.solve(),3===h.m_count)break;(C=h.getClosestPoint()).lengthSquared();var A=h.getSearchDirection();if(A.lengthSquared()<n.EPSILON*n.EPSILON)break;var g=_[h.m_count];g.indexA=o.getSupport(p.mulTVec2(m.q,r.neg(A))),g.wA=y.mulVec2(m,o.getVertex(g.indexA)),g.indexB=s.getSupport(p.mulTVec2(c.q,A)),g.wB=y.mulVec2(c,s.getVertex(g.indexB)),g.w=r.sub(g.wB,g.wA),++v,++P.gjkIters;var b=!1;for(x=0;x<f;++x)if(g.indexA===u[x]&&g.indexB===d[x]){b=!0;break}if(b)break;++h.m_count}if(P.gjkMaxIters=n.max(P.gjkMaxIters,v),h.getWitnessPoints(t.pointA,t.pointB),t.distance=r.distance(t.pointA,t.pointB),t.iterations=v,h.writeCache(e),i.useRadii){var B=o.m_radius,V=s.m_radius;if(t.distance>B+V&&t.distance>n.EPSILON){t.distance-=B+V;var w=r.sub(t.pointB,t.pointA);w.normalize(),t.pointA.addMul(B,w),t.pointB.subMul(V,w)}else{var C=r.mid(t.pointA,t.pointB);t.pointA.setVec2(C),t.pointB.setVec2(C),t.distance=0}}},D=function(){function t(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}return t.prototype.getVertexCount=function(){return this.m_count},t.prototype.getVertex=function(t){return this.m_vertices[t]},t.prototype.getSupport=function(t){for(var e=0,i=r.dot(this.m_vertices[0],t),o=0;o<this.m_count;++o){var s=r.dot(this.m_vertices[o],t);s>i&&(e=o,i=s)}return e},t.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},t.prototype.set=function(t,e){t.computeDistanceProxy(this,e)},t}(),j=function(){function t(){this.wA=r.zero(),this.wB=r.zero(),this.w=r.zero()}return t.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=r.clone(t.wA),this.wB=r.clone(t.wB),this.w=r.clone(t.w),this.a=t.a},t}(),O=function(){function t(){this.m_v1=new j,this.m_v2=new j,this.m_v3=new j,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}return t.prototype.toString=function(){return 3===this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2===this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1===this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},t.prototype.readCache=function(t,e,i,o,s){this.m_count=t.count;for(var m=0;m<this.m_count;++m){(l=this.m_v[m]).indexA=t.indexA[m],l.indexB=t.indexB[m];var a=e.getVertex(l.indexA),c=o.getVertex(l.indexB);l.wA=y.mulVec2(i,a),l.wB=y.mulVec2(s,c),l.w=r.sub(l.wB,l.wA),l.a=0}if(this.m_count>1){var h=t.metric,_=this.getMetric();(_<.5*h||2*h<_||_<n.EPSILON)&&(this.m_count=0)}if(0===this.m_count){var l;(l=this.m_v[0]).indexA=0,l.indexB=0;a=e.getVertex(0),c=o.getVertex(0);l.wA=y.mulVec2(i,a),l.wB=y.mulVec2(s,c),l.w=r.sub(l.wB,l.wA),l.a=1,this.m_count=1}},t.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var e=0;e<this.m_count;++e)t.indexA[e]=this.m_v[e].indexA,t.indexB[e]=this.m_v[e].indexB},t.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return r.neg(this.m_v1.w);case 2:var t=r.sub(this.m_v2.w,this.m_v1.w);return r.crossVec2Vec2(t,r.neg(this.m_v1.w))>0?r.crossNumVec2(1,t):r.crossVec2Num(t,1);default:return r.zero()}},t.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return r.zero();case 1:return r.clone(this.m_v1.w);case 2:return r.combine(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:default:return r.zero()}},t.prototype.getWitnessPoints=function(t,e){switch(this.m_count){case 0:break;case 1:t.setVec2(this.m_v1.wA),e.setVec2(this.m_v1.wB);break;case 2:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),e.setCombine(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.addMul(this.m_v3.a,this.m_v3.wA),e.setVec2(t)}},t.prototype.getMetric=function(){switch(this.m_count){case 0:case 1:return 0;case 2:return r.distance(this.m_v1.w,this.m_v2.w);case 3:return r.crossVec2Vec2(r.sub(this.m_v2.w,this.m_v1.w),r.sub(this.m_v3.w,this.m_v1.w));default:return 0}},t.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3()}},t.prototype.solve2=function(){var t=this.m_v1.w,e=this.m_v2.w,i=r.sub(e,t),o=-r.dot(t,i);if(o<=0)return this.m_v1.a=1,void(this.m_count=1);var s=r.dot(e,i);if(s<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(s+o);this.m_v1.a=s*n,this.m_v2.a=o*n,this.m_count=2},t.prototype.solve3=function(){var t=this.m_v1.w,e=this.m_v2.w,i=this.m_v3.w,o=r.sub(e,t),s=r.dot(t,o),n=r.dot(e,o),m=-s,a=r.sub(i,t),c=r.dot(t,a),h=r.dot(i,a),_=-c,l=r.sub(i,e),u=r.dot(e,l),p=r.dot(i,l),y=-u,d=r.crossVec2Vec2(o,a),f=d*r.crossVec2Vec2(e,i),v=d*r.crossVec2Vec2(i,t),x=d*r.crossVec2Vec2(t,e);if(m<=0&&_<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&m>0&&x<=0){var A=1/(n+m);return this.m_v1.a=n*A,this.m_v2.a=m*A,void(this.m_count=2)}if(h>0&&_>0&&v<=0){var g=1/(h+_);return this.m_v1.a=h*g,this.m_v3.a=_*g,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&y<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(h<=0&&p<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(p>0&&y>0&&f<=0){var b=1/(p+y);return this.m_v2.a=p*b,this.m_v3.a=y*b,this.m_count=2,void this.m_v1.set(this.m_v3)}var B=1/(f+v+x);this.m_v1.a=f*B,this.m_v2.a=v*B,this.m_v3.a=x*B,this.m_count=3},t}(),R=function(t,e,i,o,s,r){var m=new L;m.proxyA.set(t,e),m.proxyB.set(i,o),m.transformA=s,m.transformB=r,m.useRadii=!0;var a=new N,c=new q;return k(c,a,m),c.distance<10*n.EPSILON};k.testOverlap=R,k.Input=L,k.Output=q,k.Proxy=D,k.Cache=N;var E,J=function(){this.proxyA=new D,this.proxyB=new D,this.sweepA=new d,this.sweepB=new d};t.TOIOutputState=void 0,(E=t.TOIOutputState||(t.TOIOutputState={}))[E.e_unknown=0]="e_unknown",E[E.e_failed=1]="e_failed",E[E.e_overlapped=2]="e_overlapped",E[E.e_touching=3]="e_touching",E[E.e_separated=4]="e_separated";var Y=function(){};P.toiTime=0,P.toiMaxTime=0,P.toiCalls=0,P.toiIters=0,P.toiMaxIters=0,P.toiRootIters=0,P.toiMaxRootIters=0;var W,H=function(e,i){var o=T();++P.toiCalls,e.state=t.TOIOutputState.e_unknown,e.t=i.tMax;var s=i.proxyA,r=i.proxyB,m=i.sweepA,c=i.sweepB;m.normalize(),c.normalize();var h=i.tMax,_=s.m_radius+r.m_radius,l=n.max(a.linearSlop,_-3*a.linearSlop),u=.25*a.linearSlop,p=0,d=a.maxTOIIterations,f=0,v=new N,x=new L;for(x.proxyA=i.proxyA,x.proxyB=i.proxyB,x.useRadii=!1;;){var A=y.identity(),g=y.identity();m.getTransform(A,p),c.getTransform(g,p),x.transformA=A,x.transformB=g;var b=new q;if(k(b,v,x),b.distance<=0){e.state=t.TOIOutputState.e_overlapped,e.t=0;break}if(b.distance<l+u){e.state=t.TOIOutputState.e_touching,e.t=p;break}var B=new Z;B.initialize(v,s,m,r,c,p);for(var V=!1,w=h,C=0;;){var M=B.findMinSeparation(w);if(M>l+u){e.state=t.TOIOutputState.e_separated,e.t=h,V=!0;break}if(M>l-u){p=w;break}var I=B.evaluate(p);if(I<l-u){e.state=t.TOIOutputState.e_failed,e.t=p,V=!0;break}if(I<=l+u){e.state=t.TOIOutputState.e_touching,e.t=p,V=!0;break}for(var S=0,z=p,D=w;;){var j=void 0;j=1&S?z+(l-I)*(D-z)/(M-I):.5*(z+D),++S,++P.toiRootIters;var O=B.evaluate(j);if(B.indexA,B.indexB,n.abs(O-l)<u){w=j;break}if(O>l?(z=j,I=O):(D=j,M=O),50===S)break}if(P.toiMaxRootIters=n.max(P.toiMaxRootIters,S),++C===a.maxPolygonVertices)break}if(++f,++P.toiIters,V)break;if(f===d){e.state=t.TOIOutputState.e_failed,e.t=p;break}}P.toiMaxIters=n.max(P.toiMaxIters,f);var R=F(o);P.toiMaxTime=n.max(P.toiMaxTime,R),P.toiTime+=R};!function(t){t[t.e_points=1]="e_points",t[t.e_faceA=2]="e_faceA",t[t.e_faceB=3]="e_faceB"}(W||(W={}));var Z=function(){function t(){this.m_proxyA=new D,this.m_proxyB=new D,this.m_localPoint=r.zero(),this.m_axis=r.zero()}return t.prototype.initialize=function(t,e,i,o,s,n){this.m_proxyA=e,this.m_proxyB=o;var m=t.count;this.m_sweepA=i,this.m_sweepB=s;var a=y.identity(),c=y.identity();if(this.m_sweepA.getTransform(a,n),this.m_sweepB.getTransform(c,n),1===m){this.m_type=W.e_points;var h=this.m_proxyA.getVertex(t.indexA[0]),_=this.m_proxyB.getVertex(t.indexB[0]),l=y.mulVec2(a,h),u=y.mulVec2(c,_);return this.m_axis.setCombine(1,u,-1,l),g=this.m_axis.normalize()}if(t.indexA[0]===t.indexA[1]){this.m_type=W.e_faceB;var d=o.getVertex(t.indexB[0]),f=o.getVertex(t.indexB[1]);this.m_axis=r.crossVec2Num(r.sub(f,d),1),this.m_axis.normalize();var v=p.mulVec2(c.q,this.m_axis);this.m_localPoint=r.mid(d,f);u=y.mulVec2(c,this.m_localPoint),h=e.getVertex(t.indexA[0]),l=y.mulVec2(a,h);return(g=r.dot(l,v)-r.dot(u,v))<0&&(this.m_axis=r.neg(this.m_axis),g=-g),g}this.m_type=W.e_faceA;var x=this.m_proxyA.getVertex(t.indexA[0]),A=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=r.crossVec2Num(r.sub(A,x),1),this.m_axis.normalize();v=p.mulVec2(a.q,this.m_axis);this.m_localPoint=r.mid(x,A);var g;l=y.mulVec2(a,this.m_localPoint),_=this.m_proxyB.getVertex(t.indexB[0]),u=y.mulVec2(c,_);return(g=r.dot(u,v)-r.dot(l,v))<0&&(this.m_axis=r.neg(this.m_axis),g=-g),g},t.prototype.compute=function(t,e){var i=y.identity(),o=y.identity();switch(this.m_sweepA.getTransform(i,e),this.m_sweepB.getTransform(o,e),this.m_type){case W.e_points:if(t){var s=p.mulTVec2(i.q,this.m_axis),n=p.mulTVec2(o.q,r.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(s),this.indexB=this.m_proxyB.getSupport(n)}var m=this.m_proxyA.getVertex(this.indexA),a=this.m_proxyB.getVertex(this.indexB),c=y.mulVec2(i,m),h=y.mulVec2(o,a);return r.dot(h,this.m_axis)-r.dot(c,this.m_axis);case W.e_faceA:var _=p.mulVec2(i.q,this.m_axis);c=y.mulVec2(i,this.m_localPoint);if(t){n=p.mulTVec2(o.q,r.neg(_));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(n)}a=this.m_proxyB.getVertex(this.indexB),h=y.mulVec2(o,a);return r.dot(h,_)-r.dot(c,_);case W.e_faceB:_=p.mulVec2(o.q,this.m_axis),h=y.mulVec2(o,this.m_localPoint);if(t){s=p.mulTVec2(i.q,r.neg(_));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(s)}m=this.m_proxyA.getVertex(this.indexA),c=y.mulVec2(i,m);return r.dot(c,_)-r.dot(h,_);default:return t&&(this.indexA=-1,this.indexB=-1),0}},t.prototype.findMinSeparation=function(t){return this.compute(!0,t)},t.prototype.evaluate=function(t){return this.compute(!1,t)},t}();new Z,H.Input=J,H.Output=Y;var X=function(){function t(){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}return t.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},t}(),K=new X,G=function(){function t(t){this.contact=t,this.normals=[],this.tangents=[]}return Object.defineProperty(t.prototype,"normalImpulses",{get:function(){var t=this.contact,e=this.normals;e.length=0;for(var i=0;i<t.v_points.length;++i)e.push(t.v_points[i].normalImpulse);return e},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"tangentImpulses",{get:function(){var t=this.contact,e=this.tangents;e.length=0;for(var i=0;i<t.v_points.length;++i)e.push(t.v_points[i].tangentImpulse);return e},enumerable:!1,configurable:!0}),t}(),U=function(){function e(t){this.m_world=t,this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}return e.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},e.prototype.addBody=function(t){this.m_bodies.push(t)},e.prototype.addContact=function(t){this.m_contacts.push(t)},e.prototype.addJoint=function(t){this.m_joints.push(t)},e.prototype.solveWorld=function(t){for(var e=this.m_world,i=e.m_bodyList;i;i=i.m_next)i.m_islandFlag=!1;for(var o=e.m_contactList;o;o=o.m_next)o.m_islandFlag=!1;for(var s=e.m_jointList;s;s=s.m_next)s.m_islandFlag=!1;for(var n=this.m_stack,r=e.m_bodyList;r;r=r.m_next)if(!r.m_islandFlag&&0!=r.isAwake()&&0!=r.isActive()&&!r.isStatic()){for(this.clear(),n.push(r),r.m_islandFlag=!0;n.length>0;){i=n.pop();if(this.addBody(i),i.setAwake(!0),!i.isStatic()){for(var m=i.m_contactList;m;m=m.next){var a=m.contact;if(!a.m_islandFlag&&(0!=a.isEnabled()&&0!=a.isTouching())){var c=a.m_fixtureA.m_isSensor,h=a.m_fixtureB.m_isSensor;if(!c&&!h)this.addContact(a),a.m_islandFlag=!0,(l=m.other).m_islandFlag||(n.push(l),l.m_islandFlag=!0)}}for(var _=i.m_jointList;_;_=_.next){var l;if(1!=_.joint.m_islandFlag)0!=(l=_.other).isActive()&&(this.addJoint(_.joint),_.joint.m_islandFlag=!0,l.m_islandFlag||(n.push(l),l.m_islandFlag=!0))}}}this.solveIsland(t);for(var u=0;u<this.m_bodies.length;++u){(i=this.m_bodies[u]).isStatic()&&(i.m_islandFlag=!1)}}},e.prototype.solveIsland=function(t){for(var e=this.m_world,i=e.m_gravity,o=e.m_allowSleep,s=t.dt,m=0;m<this.m_bodies.length;++m){var c=this.m_bodies[m],h=r.clone(c.m_sweep.c),_=c.m_sweep.a,l=r.clone(c.m_linearVelocity),u=c.m_angularVelocity;c.m_sweep.c0.setVec2(c.m_sweep.c),c.m_sweep.a0=c.m_sweep.a,c.isDynamic()&&(l.addMul(s*c.m_gravityScale,i),l.addMul(s*c.m_invMass,c.m_force),u+=s*c.m_invI*c.m_torque,l.mul(1/(1+s*c.m_linearDamping)),u*=1/(1+s*c.m_angularDamping)),c.c_position.c=h,c.c_position.a=_,c.c_velocity.v=l,c.c_velocity.w=u}for(m=0;m<this.m_contacts.length;++m){this.m_contacts[m].initConstraint(t)}for(m=0;m<this.m_contacts.length;++m){this.m_contacts[m].initVelocityConstraint(t)}if(t.warmStarting)for(m=0;m<this.m_contacts.length;++m){this.m_contacts[m].warmStartConstraint(t)}for(m=0;m<this.m_joints.length;++m){this.m_joints[m].initVelocityConstraints(t)}for(m=0;m<t.velocityIterations;++m){for(var p=0;p<this.m_joints.length;++p){this.m_joints[p].solveVelocityConstraints(t)}for(p=0;p<this.m_contacts.length;++p){this.m_contacts[p].solveVelocityConstraint(t)}}for(m=0;m<this.m_contacts.length;++m){this.m_contacts[m].storeConstraintImpulses(t)}for(m=0;m<this.m_bodies.length;++m){c=this.m_bodies[m],h=r.clone(c.c_position.c),_=c.c_position.a,l=r.clone(c.c_velocity.v),u=c.c_velocity.w;var y=r.mulNumVec2(s,l);if(r.lengthSquared(y)>a.maxTranslationSquared){var d=a.maxTranslation/y.length();l.mul(d)}var f=s*u;if(f*f>a.maxRotationSquared)u*=d=a.maxRotation/n.abs(f);h.addMul(s,l),_+=s*u,c.c_position.c.setVec2(h),c.c_position.a=_,c.c_velocity.v.setVec2(l),c.c_velocity.w=u}var v=!1;for(m=0;m<t.positionIterations;++m){var x=0;for(p=0;p<this.m_contacts.length;++p){var A=this.m_contacts[p].solvePositionConstraint(t);x=n.min(x,A)}var g=x>=-3*a.linearSlop,b=!0;for(p=0;p<this.m_joints.length;++p){var B=this.m_joints[p].solvePositionConstraints(t);b=b&&B}if(g&&b){v=!0;break}}for(m=0;m<this.m_bodies.length;++m){(c=this.m_bodies[m]).m_sweep.c.setVec2(c.c_position.c),c.m_sweep.a=c.c_position.a,c.m_linearVelocity.setVec2(c.c_velocity.v),c.m_angularVelocity=c.c_velocity.w,c.synchronizeTransform()}if(this.postSolveIsland(),o){var V=1/0,w=a.linearSleepToleranceSqr,C=a.angularSleepToleranceSqr;for(m=0;m<this.m_bodies.length;++m){(c=this.m_bodies[m]).isStatic()||(0==c.m_autoSleepFlag||c.m_angularVelocity*c.m_angularVelocity>C||r.lengthSquared(c.m_linearVelocity)>w?(c.m_sleepTime=0,V=0):(c.m_sleepTime+=s,V=n.min(V,c.m_sleepTime)))}if(V>=a.timeToSleep&&v)for(m=0;m<this.m_bodies.length;++m){(c=this.m_bodies[m]).setAwake(!1)}}},e.prototype.solveWorldTOI=function(e){var i=this.m_world;if(i.m_stepComplete){for(var o=i.m_bodyList;o;o=o.m_next)o.m_islandFlag=!1,o.m_sweep.alpha0=0;for(var s=i.m_contactList;s;s=s.m_next)s.m_toiFlag=!1,s.m_islandFlag=!1,s.m_toiCount=0,s.m_toi=1}for(;;){var r=null,m=1;for(s=i.m_contactList;s;s=s.m_next)if(0!=s.isEnabled()&&!(s.m_toiCount>a.maxSubSteps)){var c=1;if(s.m_toiFlag)c=s.m_toi;else{var h=s.getFixtureA(),_=s.getFixtureB();if(h.isSensor()||_.isSensor())continue;var l=h.getBody(),u=_.getBody(),p=l.isAwake()&&!l.isStatic(),y=u.isAwake()&&!u.isStatic();if(0==p&&0==y)continue;var d=l.isBullet()||!l.isDynamic(),f=u.isBullet()||!u.isDynamic();if(0==d&&0==f)continue;var v=l.m_sweep.alpha0;l.m_sweep.alpha0<u.m_sweep.alpha0?(v=u.m_sweep.alpha0,l.m_sweep.advance(v)):u.m_sweep.alpha0<l.m_sweep.alpha0&&(v=l.m_sweep.alpha0,u.m_sweep.advance(v));var x=s.getChildIndexA(),A=s.getChildIndexB();l.m_sweep,u.m_sweep;var g=new J;g.proxyA.set(h.getShape(),x),g.proxyB.set(_.getShape(),A),g.sweepA.set(l.m_sweep),g.sweepB.set(u.m_sweep),g.tMax=1;var b=new Y;H(b,g);var B=b.t;c=b.state==t.TOIOutputState.e_touching?n.min(v+(1-v)*B,1):1,s.m_toi=c,s.m_toiFlag=!0}c<m&&(r=s,m=c)}if(null==r||1-10*n.EPSILON<m){i.m_stepComplete=!0;break}var V=r.getFixtureA(),w=r.getFixtureB(),C=V.getBody(),M=w.getBody(),I=C.m_sweep.clone(),S=M.m_sweep.clone();if(C.advance(m),M.advance(m),r.update(i),r.m_toiFlag=!1,++r.m_toiCount,0!=r.isEnabled()&&0!=r.isTouching()){C.setAwake(!0),M.setAwake(!0),this.clear(),this.addBody(C),this.addBody(M),this.addContact(r),C.m_islandFlag=!0,M.m_islandFlag=!0,r.m_islandFlag=!0;for(var z=[C,M],P=0;P<z.length;++P){if((D=z[P]).isDynamic())for(var T=D.m_contactList;T;T=T.next){var F=T.contact;if(!F.m_islandFlag){var L=T.other;if(!L.isDynamic()||D.isBullet()||L.isBullet()){var q=F.m_fixtureA.m_isSensor,N=F.m_fixtureB.m_isSensor;if(!q&&!N){var k=L.m_sweep.clone();0==L.m_islandFlag&&L.advance(m),F.update(i),0!=F.isEnabled()&&0!=F.isTouching()?(F.m_islandFlag=!0,this.addContact(F),L.m_islandFlag||(L.m_islandFlag=!0,L.isStatic()||L.setAwake(!0),this.addBody(L))):(L.m_sweep.set(k),L.synchronizeTransform())}}}}}K.reset((1-m)*e.dt),K.dtRatio=1,K.positionIterations=20,K.velocityIterations=e.velocityIterations,K.warmStarting=!1,this.solveIslandTOI(K,C,M);for(P=0;P<this.m_bodies.length;++P){var D;if((D=this.m_bodies[P]).m_islandFlag=!1,D.isDynamic()){D.synchronizeFixtures();for(T=D.m_contactList;T;T=T.next)T.contact.m_toiFlag=!1,T.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else r.setEnabled(!1),C.m_sweep.set(I),M.m_sweep.set(S),C.synchronizeTransform(),M.synchronizeTransform()}},e.prototype.solveIslandTOI=function(t,e,i){this.m_world;for(var o=0;o<this.m_bodies.length;++o){(_=this.m_bodies[o]).c_position.c.setVec2(_.m_sweep.c),_.c_position.a=_.m_sweep.a,_.c_velocity.v.setVec2(_.m_linearVelocity),_.c_velocity.w=_.m_angularVelocity}for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initConstraint(t)}for(o=0;o<t.positionIterations;++o){for(var s=0,m=0;m<this.m_contacts.length;++m){var c=this.m_contacts[m].solvePositionConstraintTOI(t,e,i);s=n.min(s,c)}if(s>=-1.5*a.linearSlop)break}e.m_sweep.c0.setVec2(e.c_position.c),e.m_sweep.a0=e.c_position.a,i.m_sweep.c0.setVec2(i.c_position.c),i.m_sweep.a0=i.c_position.a;for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initVelocityConstraint(t)}for(o=0;o<t.velocityIterations;++o)for(m=0;m<this.m_contacts.length;++m){this.m_contacts[m].solveVelocityConstraint(t)}var h=t.dt;for(o=0;o<this.m_bodies.length;++o){var _=this.m_bodies[o],l=r.clone(_.c_position.c),u=_.c_position.a,p=r.clone(_.c_velocity.v),y=_.c_velocity.w,d=r.mulNumVec2(h,p);if(r.dot(d,d)>a.maxTranslationSquared){var f=a.maxTranslation/d.length();p.mul(f)}var v=h*y;if(v*v>a.maxRotationSquared)y*=f=a.maxRotation/n.abs(v);l.addMul(h,p),u+=h*y,_.c_position.c=l,_.c_position.a=u,_.c_velocity.v=p,_.c_velocity.w=y,_.m_sweep.c=l,_.m_sweep.a=u,_.m_linearVelocity=p,_.m_angularVelocity=y,_.synchronizeTransform()}this.postSolveIsland()},e.prototype.postSolveIsland=function(){for(var t=0;t<this.m_contacts.length;++t){var e=this.m_contacts[t];this.m_world.postSolve(e,e.m_impulse)}},e}();U.TimeStep=X;var Q,$,tt,et=function(){function t(t,e,i,o){"object"==typeof t&&null!==t?(this.ex=r.clone(t),this.ey=r.clone(e)):"number"==typeof t?(this.ex=r.neo(t,i),this.ey=r.neo(e,o)):(this.ex=r.zero(),this.ey=r.zero())}return t.prototype.toString=function(){return JSON.stringify(this)},t.isValid=function(t){return null!=t&&(r.isValid(t.ex)&&r.isValid(t.ey))},t.assert=function(t){},t.prototype.set=function(t,e,i,o){"number"==typeof t&&"number"==typeof e&&"number"==typeof i&&"number"==typeof o?(this.ex.setNum(t,i),this.ey.setNum(e,o)):"object"==typeof t&&"object"==typeof e?(this.ex.setVec2(t),this.ey.setVec2(e)):"object"==typeof t&&(this.ex.setVec2(t.ex),this.ey.setVec2(t.ey))},t.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},t.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},t.prototype.getInverse=function(){var e=this.ex.x,i=this.ey.x,o=this.ex.y,s=this.ey.y,n=e*s-i*o;0!==n&&(n=1/n);var r=new t;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*o,r.ey.y=n*e,r},t.prototype.solve=function(t){var e=this.ex.x,i=this.ey.x,o=this.ex.y,s=this.ey.y,n=e*s-i*o;0!==n&&(n=1/n);var m=r.zero();return m.x=n*(s*t.x-i*t.y),m.y=n*(e*t.y-o*t.x),m},t.mul=function(e,i){if(i&&"x"in i&&"y"in i){var o=e.ex.x*i.x+e.ey.x*i.y,s=e.ex.y*i.x+e.ey.y*i.y;return r.neo(o,s)}if(i&&"ex"in i&&"ey"in i)return new t(e.ex.x*i.ex.x+e.ey.x*i.ex.y,e.ex.x*i.ey.x+e.ey.x*i.ey.y,e.ex.y*i.ex.x+e.ey.y*i.ex.y,e.ex.y*i.ey.x+e.ey.y*i.ey.y)},t.mulVec2=function(t,e){var i=t.ex.x*e.x+t.ey.x*e.y,o=t.ex.y*e.x+t.ey.y*e.y;return r.neo(i,o)},t.mulMat22=function(e,i){return new t(e.ex.x*i.ex.x+e.ey.x*i.ex.y,e.ex.x*i.ey.x+e.ey.x*i.ey.y,e.ex.y*i.ex.x+e.ey.y*i.ex.y,e.ex.y*i.ey.x+e.ey.y*i.ey.y)},t.mulT=function(e,i){return i&&"x"in i&&"y"in i?r.neo(r.dot(i,e.ex),r.dot(i,e.ey)):i&&"ex"in i&&"ey"in i?new t(r.neo(r.dot(e.ex,i.ex),r.dot(e.ey,i.ex)),r.neo(r.dot(e.ex,i.ey),r.dot(e.ey,i.ey))):void 0},t.mulTVec2=function(t,e){return r.neo(r.dot(e,t.ex),r.dot(e,t.ey))},t.mulTMat22=function(e,i){return new t(r.neo(r.dot(e.ex,i.ex),r.dot(e.ey,i.ex)),r.neo(r.dot(e.ex,i.ey),r.dot(e.ey,i.ey)))},t.abs=function(e){return new t(r.abs(e.ex),r.abs(e.ey))},t.add=function(e,i){return new t(r.add(e.ex,i.ex),r.add(e.ey,i.ey))},t}();t.ManifoldType=void 0,(Q=t.ManifoldType||(t.ManifoldType={}))[Q.e_circles=0]="e_circles",Q[Q.e_faceA=1]="e_faceA",Q[Q.e_faceB=2]="e_faceB",t.ContactFeatureType=void 0,($=t.ContactFeatureType||(t.ContactFeatureType={}))[$.e_vertex=0]="e_vertex",$[$.e_face=1]="e_face",t.PointState=void 0,(tt=t.PointState||(t.PointState={}))[tt.nullState=0]="nullState",tt[tt.addState=1]="addState",tt[tt.persistState=2]="persistState",tt[tt.removeState=3]="removeState";var it=function(){function t(){this.v=r.zero(),this.id=new nt}return t.prototype.set=function(t){this.v.setVec2(t.v),this.id.set(t.id)},t}(),ot=function(){function e(){this.localNormal=r.zero(),this.localPoint=r.zero(),this.points=[new st,new st],this.pointCount=0}return e.prototype.getWorldManifold=function(e,i,o,s,m){if(0!=this.pointCount){var a=(e=e||new mt).normal,c=e.points,h=e.separations;switch(this.type){case t.ManifoldType.e_circles:a=r.neo(1,0);var _=y.mulVec2(i,this.localPoint),l=y.mulVec2(s,this.points[0].localPoint),u=r.sub(l,_);r.lengthSquared(u)>n.EPSILON*n.EPSILON&&(a.setVec2(u),a.normalize());var d=_.clone().addMul(o,a),f=l.clone().addMul(-m,a);c[0]=r.mid(d,f),h[0]=r.dot(r.sub(f,d),a),c.length=1,h.length=1;break;case t.ManifoldType.e_faceA:a=p.mulVec2(i.q,this.localNormal);for(var v=y.mulVec2(i,this.localPoint),x=0;x<this.pointCount;++x){var A=y.mulVec2(s,this.points[x].localPoint);d=r.clone(A).addMul(o-r.dot(r.sub(A,v),a),a),f=r.clone(A).subMul(m,a);c[x]=r.mid(d,f),h[x]=r.dot(r.sub(f,d),a)}c.length=this.pointCount,h.length=this.pointCount;break;case t.ManifoldType.e_faceB:a=p.mulVec2(s.q,this.localNormal);for(v=y.mulVec2(s,this.localPoint),x=0;x<this.pointCount;++x){A=y.mulVec2(i,this.points[x].localPoint),f=r.combine(1,A,m-r.dot(r.sub(A,v),a),a),d=r.combine(1,A,-o,a);c[x]=r.mid(d,f),h[x]=r.dot(r.sub(d,f),a)}c.length=this.pointCount,h.length=this.pointCount,a.mul(-1)}return e.normal=a,e.points=c,e.separations=h,e}},e.clipSegmentToLine=ct,e.ClipVertex=it,e.getPointStates=at,e.PointState=t.PointState,e}(),st=function(){this.localPoint=r.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new nt},nt=function(){function t(){this.cf=new rt}return Object.defineProperty(t.prototype,"key",{get:function(){return this.cf.indexA+4*this.cf.indexB+16*this.cf.typeA+64*this.cf.typeB},enumerable:!1,configurable:!0}),t.prototype.set=function(t){this.cf.set(t.cf)},t}(),rt=function(){function t(){}return t.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},t}(),mt=function(){this.points=[],this.separations=[]};function at(e,i,o,s){for(var n=0;n<o.pointCount;++n){var r=o.points[n].id;e[n]=t.PointState.removeState;for(var m=0;m<s.pointCount;++m)if(s.points[m].id.key==r.key){e[n]=t.PointState.persistState;break}}for(n=0;n<s.pointCount;++n){r=s.points[n].id;i[n]=t.PointState.addState;for(m=0;m<o.pointCount;++m)if(o.points[m].id.key==r.key){i[n]=t.PointState.persistState;break}}}function ct(e,i,o,s,n){var m=0,a=r.dot(o,i[0].v)-s,c=r.dot(o,i[1].v)-s;if(a<=0&&e[m++].set(i[0]),c<=0&&e[m++].set(i[1]),a*c<0){var h=a/(a-c);e[m].v.setCombine(1-h,i[0].v,h,i[1].v),e[m].id.cf.indexA=n,e[m].id.cf.indexB=i[0].id.cf.indexB,e[m].id.cf.typeA=t.ContactFeatureType.e_vertex,e[m].id.cf.typeB=t.ContactFeatureType.e_face,++m}return m}var ht=function(t){this.contact=t};function _t(t,e){return n.sqrt(t*e)}function lt(t,e){return t>e?t:e}var ut=[],pt=function(){this.rA=r.zero(),this.rB=r.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0},yt=function(){function e(t,e,i,o,s){this.m_manifold=new ot,this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.m_impulse=new G(this),this.v_points=[],this.v_normal=r.zero(),this.v_normalMass=new et,this.v_K=new et,this.p_localPoints=[],this.p_localNormal=r.zero(),this.p_localPoint=r.zero(),this.p_localCenterA=r.zero(),this.p_localCenterB=r.zero(),this.m_nodeA=new ht(this),this.m_nodeB=new ht(this),this.m_fixtureA=t,this.m_fixtureB=i,this.m_indexA=e,this.m_indexB=o,this.m_evaluateFcn=s,this.m_friction=_t(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=lt(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)}return e.prototype.initConstraint=function(t){var e=this.m_fixtureA,i=this.m_fixtureB,o=e.getShape(),s=i.getShape(),n=e.getBody(),m=i.getBody(),a=this.getManifold(),c=a.pointCount;this.v_invMassA=n.m_invMass,this.v_invMassB=m.m_invMass,this.v_invIA=n.m_invI,this.v_invIB=m.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=c,this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=n.m_invMass,this.p_invMassB=m.m_invMass,this.p_invIA=n.m_invI,this.p_invIB=m.m_invI,this.p_localCenterA=r.clone(n.m_sweep.localCenter),this.p_localCenterB=r.clone(m.m_sweep.localCenter),this.p_radiusA=o.m_radius,this.p_radiusB=s.m_radius,this.p_type=a.type,this.p_localNormal=r.clone(a.localNormal),this.p_localPoint=r.clone(a.localPoint),this.p_pointCount=c;for(var h=0;h<c;++h){var _=a.points[h],l=this.v_points[h]=new pt;t.warmStarting?(l.normalImpulse=t.dtRatio*_.normalImpulse,l.tangentImpulse=t.dtRatio*_.tangentImpulse):(l.normalImpulse=0,l.tangentImpulse=0),l.rA.setZero(),l.rB.setZero(),l.normalMass=0,l.tangentMass=0,l.velocityBias=0,this.p_localPoints[h]=r.clone(_.localPoint)}},e.prototype.getManifold=function(){return this.m_manifold},e.prototype.getWorldManifold=function(t){var e=this.m_fixtureA.getBody(),i=this.m_fixtureB.getBody(),o=this.m_fixtureA.getShape(),s=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,e.getTransform(),o.m_radius,i.getTransform(),s.m_radius)},e.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},e.prototype.isEnabled=function(){return this.m_enabledFlag},e.prototype.isTouching=function(){return this.m_touchingFlag},e.prototype.getNext=function(){return this.m_next},e.prototype.getFixtureA=function(){return this.m_fixtureA},e.prototype.getFixtureB=function(){return this.m_fixtureB},e.prototype.getChildIndexA=function(){return this.m_indexA},e.prototype.getChildIndexB=function(){return this.m_indexB},e.prototype.flagForFiltering=function(){this.m_filterFlag=!0},e.prototype.setFriction=function(t){this.m_friction=t},e.prototype.getFriction=function(){return this.m_friction},e.prototype.resetFriction=function(){this.m_friction=_t(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},e.prototype.setRestitution=function(t){this.m_restitution=t},e.prototype.getRestitution=function(){return this.m_restitution},e.prototype.resetRestitution=function(){this.m_restitution=lt(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},e.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},e.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},e.prototype.evaluate=function(t,e,i){this.m_evaluateFcn(t,e,this.m_fixtureA,this.m_indexA,i,this.m_fixtureB,this.m_indexB)},e.prototype.update=function(t){this.m_enabledFlag=!0;var e,i=!1,o=this.m_touchingFlag,s=this.m_fixtureA.isSensor(),n=this.m_fixtureB.isSensor(),r=s||n,m=this.m_fixtureA.getBody(),a=this.m_fixtureB.getBody(),c=m.getTransform(),h=a.getTransform();if(r){var _=this.m_fixtureA.getShape(),l=this.m_fixtureB.getShape();i=R(_,this.m_indexA,l,this.m_indexB,c,h),this.m_manifold.pointCount=0}else{e=this.m_manifold,this.m_manifold=new ot,this.evaluate(this.m_manifold,c,h),i=this.m_manifold.pointCount>0;for(var u=0;u<this.m_manifold.pointCount;++u){var p=this.m_manifold.points[u];p.normalImpulse=0,p.tangentImpulse=0;for(var y=0;y<e.pointCount;++y){var d=e.points[y];if(d.id.key==p.id.key){p.normalImpulse=d.normalImpulse,p.tangentImpulse=d.tangentImpulse;break}}}i!=o&&(m.setAwake(!0),a.setAwake(!0))}this.m_touchingFlag=i,!o&&i&&t&&t.beginContact(this),o&&!i&&t&&t.endContact(this),!r&&i&&t&&t.preSolve(this,e)},e.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t)},e.prototype.solvePositionConstraintTOI=function(t,e,i){return this._solvePositionConstraint(t,e,i)},e.prototype._solvePositionConstraint=function(e,i,o){var s=!!i&&!!o,m=this.m_fixtureA,c=this.m_fixtureB,h=m.getBody(),_=c.getBody();h.c_velocity,_.c_velocity;var l=h.c_position,u=_.c_position,d=r.clone(this.p_localCenterA),f=r.clone(this.p_localCenterB),v=0,x=0;s&&h!=i&&h!=o||(v=this.p_invMassA,x=this.p_invIA);var A=0,g=0;s&&_!=i&&_!=o||(A=this.p_invMassB,g=this.p_invIB);for(var b=r.clone(l.c),B=l.a,V=r.clone(u.c),w=u.a,C=0,M=0;M<this.p_pointCount;++M){var I=y.identity(),S=y.identity();I.q.setAngle(B),S.q.setAngle(w),I.p=r.sub(b,p.mulVec2(I.q,d)),S.p=r.sub(V,p.mulVec2(S.q,f));var z=void 0,P=void 0,T=void 0;switch(this.p_type){case t.ManifoldType.e_circles:var F=y.mulVec2(I,this.p_localPoint),L=y.mulVec2(S,this.p_localPoints[0]);(z=r.sub(L,F)).normalize(),P=r.combine(.5,F,.5,L),T=r.dot(r.sub(L,F),z)-this.p_radiusA-this.p_radiusB;break;case t.ManifoldType.e_faceA:z=p.mulVec2(I.q,this.p_localNormal);var q=y.mulVec2(I,this.p_localPoint),N=y.mulVec2(S,this.p_localPoints[M]);T=r.dot(r.sub(N,q),z)-this.p_radiusA-this.p_radiusB,P=N;break;case t.ManifoldType.e_faceB:z=p.mulVec2(S.q,this.p_localNormal);q=y.mulVec2(S,this.p_localPoint),N=y.mulVec2(I,this.p_localPoints[M]);T=r.dot(r.sub(N,q),z)-this.p_radiusA-this.p_radiusB,P=N,z.mul(-1)}var k=r.sub(P,b),D=r.sub(P,V);C=n.min(C,T);var j=s?a.toiBaugarte:a.baumgarte,O=a.linearSlop,R=a.maxLinearCorrection,E=n.clamp(j*(T+O),-R,0),J=r.crossVec2Vec2(k,z),Y=r.crossVec2Vec2(D,z),W=v+A+x*J*J+g*Y*Y,H=W>0?-E/W:0,Z=r.mulNumVec2(H,z);b.subMul(v,Z),B-=x*r.crossVec2Vec2(k,Z),V.addMul(A,Z),w+=g*r.crossVec2Vec2(D,Z)}return l.c.setVec2(b),l.a=B,u.c.setVec2(V),u.a=w,C},e.prototype.initVelocityConstraint=function(t){var e=this.m_fixtureA,i=this.m_fixtureB,o=e.getBody(),s=i.getBody(),n=o.c_velocity,m=s.c_velocity,c=o.c_position,h=s.c_position,_=this.p_radiusA,l=this.p_radiusB,u=this.getManifold(),d=this.v_invMassA,f=this.v_invMassB,v=this.v_invIA,x=this.v_invIB,A=r.clone(this.p_localCenterA),g=r.clone(this.p_localCenterB),b=r.clone(c.c),B=c.a,V=r.clone(n.v),w=n.w,C=r.clone(h.c),M=h.a,I=r.clone(m.v),S=m.w,z=y.identity(),P=y.identity();z.q.setAngle(B),P.q.setAngle(M),z.p.setCombine(1,b,-1,p.mulVec2(z.q,A)),P.p.setCombine(1,C,-1,p.mulVec2(P.q,g));var T=u.getWorldManifold(null,z,_,P,l);this.v_normal.setVec2(T.normal);for(var F=0;F<this.v_pointCount;++F){var L=this.v_points[F];L.rA.setVec2(r.sub(T.points[F],b)),L.rB.setVec2(r.sub(T.points[F],C));var q=r.crossVec2Vec2(L.rA,this.v_normal),N=r.crossVec2Vec2(L.rB,this.v_normal),k=d+f+v*q*q+x*N*N;L.normalMass=k>0?1/k:0;var D=r.crossVec2Num(this.v_normal,1),j=r.crossVec2Vec2(L.rA,D),O=r.crossVec2Vec2(L.rB,D),R=d+f+v*j*j+x*O*O;L.tangentMass=R>0?1/R:0,L.velocityBias=0;var E=r.dot(this.v_normal,I)+r.dot(this.v_normal,r.crossNumVec2(S,L.rB))-r.dot(this.v_normal,V)-r.dot(this.v_normal,r.crossNumVec2(w,L.rA));E<-a.velocityThreshold&&(L.velocityBias=-this.v_restitution*E)}if(2==this.v_pointCount&&t.blockSolve){var J=this.v_points[0],Y=this.v_points[1],W=r.crossVec2Vec2(J.rA,this.v_normal),H=r.crossVec2Vec2(J.rB,this.v_normal),Z=r.crossVec2Vec2(Y.rA,this.v_normal),X=r.crossVec2Vec2(Y.rB,this.v_normal),K=d+f+v*W*W+x*H*H,G=d+f+v*Z*Z+x*X*X,U=d+f+v*W*Z+x*H*X;K*K<1e3*(K*G-U*U)?(this.v_K.ex.setNum(K,U),this.v_K.ey.setNum(U,G),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}c.c.setVec2(b),c.a=B,n.v.setVec2(V),n.w=w,h.c.setVec2(C),h.a=M,m.v.setVec2(I),m.w=S},e.prototype.warmStartConstraint=function(t){var e=this.m_fixtureA,i=this.m_fixtureB,o=e.getBody(),s=i.getBody(),n=o.c_velocity,m=s.c_velocity;o.c_position,s.c_position;for(var a=this.v_invMassA,c=this.v_invIA,h=this.v_invMassB,_=this.v_invIB,l=r.clone(n.v),u=n.w,p=r.clone(m.v),y=m.w,d=this.v_normal,f=r.crossVec2Num(d,1),v=0;v<this.v_pointCount;++v){var x=this.v_points[v],A=r.combine(x.normalImpulse,d,x.tangentImpulse,f);u-=c*r.crossVec2Vec2(x.rA,A),l.subMul(a,A),y+=_*r.crossVec2Vec2(x.rB,A),p.addMul(h,A)}n.v.setVec2(l),n.w=u,m.v.setVec2(p),m.w=y},e.prototype.storeConstraintImpulses=function(t){for(var e=this.m_manifold,i=0;i<this.v_pointCount;++i)e.points[i].normalImpulse=this.v_points[i].normalImpulse,e.points[i].tangentImpulse=this.v_points[i].tangentImpulse},e.prototype.solveVelocityConstraint=function(t){var e=this.m_fixtureA.m_body,i=this.m_fixtureB.m_body,o=e.c_velocity;e.c_position;var s=i.c_velocity;i.c_position;for(var m=this.v_invMassA,a=this.v_invIA,c=this.v_invMassB,h=this.v_invIB,_=r.clone(o.v),l=o.w,u=r.clone(s.v),p=s.w,y=this.v_normal,d=r.crossVec2Num(y,1),f=this.v_friction,v=0;v<this.v_pointCount;++v){var x=this.v_points[v];(w=r.zero()).addCombine(1,u,1,r.crossNumVec2(p,x.rB)),w.subCombine(1,_,1,r.crossNumVec2(l,x.rA));var A=r.dot(w,d)-this.v_tangentSpeed,g=x.tangentMass*-A,b=f*x.normalImpulse;g=(C=n.clamp(x.tangentImpulse+g,-b,b))-x.tangentImpulse,x.tangentImpulse=C;var B=r.mulNumVec2(g,d);_.subMul(m,B),l-=a*r.crossVec2Vec2(x.rA,B),u.addMul(c,B),p+=h*r.crossVec2Vec2(x.rB,B)}if(1==this.v_pointCount||0==t.blockSolve)for(var V=0;V<this.v_pointCount;++V){var w;x=this.v_points[V];(w=r.zero()).addCombine(1,u,1,r.crossNumVec2(p,x.rB)),w.subCombine(1,_,1,r.crossNumVec2(l,x.rA));var C,M=r.dot(w,y);g=-x.normalMass*(M-x.velocityBias);g=(C=n.max(x.normalImpulse+g,0))-x.normalImpulse,x.normalImpulse=C;B=r.mulNumVec2(g,y);_.subMul(m,B),l-=a*r.crossVec2Vec2(x.rA,B),u.addMul(c,B),p+=h*r.crossVec2Vec2(x.rB,B)}else{var I=this.v_points[0],S=this.v_points[1],z=r.neo(I.normalImpulse,S.normalImpulse),P=r.zero().add(u).add(r.crossNumVec2(p,I.rB)).sub(_).sub(r.crossNumVec2(l,I.rA)),T=r.zero().add(u).add(r.crossNumVec2(p,S.rB)).sub(_).sub(r.crossNumVec2(l,S.rA)),F=r.dot(P,y),L=r.dot(T,y),q=r.neo(F-I.velocityBias,L-S.velocityBias);for(q.sub(et.mulVec2(this.v_K,z));;){var N=et.mulVec2(this.v_normalMass,q).neg();if(N.x>=0&&N.y>=0){var k=r.sub(N,z),D=r.mulNumVec2(k.x,y),j=r.mulNumVec2(k.y,y);_.subCombine(m,D,m,j),l-=a*(r.crossVec2Vec2(I.rA,D)+r.crossVec2Vec2(S.rA,j)),u.addCombine(c,D,c,j),p+=h*(r.crossVec2Vec2(I.rB,D)+r.crossVec2Vec2(S.rB,j)),I.normalImpulse=N.x,S.normalImpulse=N.y;break}if(N.x=-I.normalMass*q.x,N.y=0,F=0,L=this.v_K.ex.y*N.x+q.y,N.x>=0&&L>=0){k=r.sub(N,z),D=r.mulNumVec2(k.x,y),j=r.mulNumVec2(k.y,y);_.subCombine(m,D,m,j),l-=a*(r.crossVec2Vec2(I.rA,D)+r.crossVec2Vec2(S.rA,j)),u.addCombine(c,D,c,j),p+=h*(r.crossVec2Vec2(I.rB,D)+r.crossVec2Vec2(S.rB,j)),I.normalImpulse=N.x,S.normalImpulse=N.y;break}if(N.x=0,N.y=-S.normalMass*q.y,F=this.v_K.ey.x*N.y+q.x,L=0,N.y>=0&&F>=0){k=r.sub(N,z),D=r.mulNumVec2(k.x,y),j=r.mulNumVec2(k.y,y);_.subCombine(m,D,m,j),l-=a*(r.crossVec2Vec2(I.rA,D)+r.crossVec2Vec2(S.rA,j)),u.addCombine(c,D,c,j),p+=h*(r.crossVec2Vec2(I.rB,D)+r.crossVec2Vec2(S.rB,j)),I.normalImpulse=N.x,S.normalImpulse=N.y;break}if(N.x=0,N.y=0,F=q.x,L=q.y,F>=0&&L>=0){k=r.sub(N,z),D=r.mulNumVec2(k.x,y),j=r.mulNumVec2(k.y,y);_.subCombine(m,D,m,j),l-=a*(r.crossVec2Vec2(I.rA,D)+r.crossVec2Vec2(S.rA,j)),u.addCombine(c,D,c,j),p+=h*(r.crossVec2Vec2(I.rB,D)+r.crossVec2Vec2(S.rB,j)),I.normalImpulse=N.x,S.normalImpulse=N.y;break}break}}o.v.setVec2(_),o.w=l,s.v.setVec2(u),s.w=p},e.addType=function(t,e,i){ut[t]=ut[t]||{},ut[t][e]=i},e.create=function(t,i,o,s){var n,r,m=t.getType(),a=o.getType();if(r=ut[m]&&ut[m][a])n=new e(t,i,o,s,r);else{if(!(r=ut[a]&&ut[a][m]))return null;n=new e(o,s,t,i,r)}t=n.getFixtureA(),o=n.getFixtureB(),i=n.getChildIndexA(),s=n.getChildIndexB();var c=t.getBody(),h=o.getBody();return n.m_nodeA.contact=n,n.m_nodeA.other=h,n.m_nodeA.prev=null,n.m_nodeA.next=c.m_contactList,null!=c.m_contactList&&(c.m_contactList.prev=n.m_nodeA),c.m_contactList=n.m_nodeA,n.m_nodeB.contact=n,n.m_nodeB.other=c,n.m_nodeB.prev=null,n.m_nodeB.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=n.m_nodeB),h.m_contactList=n.m_nodeB,0==t.isSensor()&&0==o.isSensor()&&(c.setAwake(!0),h.setAwake(!0)),n},e.destroy=function(t,e){var i=t.m_fixtureA,o=t.m_fixtureB,s=i.getBody(),n=o.getBody();t.isTouching()&&e.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA==s.m_contactList&&(s.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB==n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&0==i.isSensor()&&0==o.isSensor()&&(s.setAwake(!0),n.setAwake(!0)),i.getType(),o.getType()},e}(),dt={gravity:r.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3},ft=function(){function t(e){if(!(this instanceof t))return new t(e);this.s_step=new X,e&&r.isValid(e)&&(e={gravity:e}),e=s(e,dt),this.m_solver=new U(this),this.m_broadPhase=new u,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=e.allowSleep,this.m_gravity=r.clone(e.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=e.warmStarting,this.m_continuousPhysics=e.continuousPhysics,this.m_subStepping=e.subStepping,this.m_blockSolve=e.blockSolve,this.m_velocityIterations=e.velocityIterations,this.m_positionIterations=e.positionIterations,this.m_t=0}return t.prototype._serialize=function(){for(var t=[],e=[],i=this.getBodyList();i;i=i.getNext())t.push(i);for(var o=this.getJointList();o;o=o.getNext())"function"==typeof o._serialize&&e.push(o);return{gravity:this.m_gravity,bodies:t,joints:e}},t._deserialize=function(e,i,o){if(!e)return new t;var s=new t(e.gravity);if(e.bodies)for(var n=e.bodies.length-1;n>=0;n-=1)s._addBody(o(I,e.bodies[n],s));if(e.joints)for(n=e.joints.length-1;n>=0;n--)s.createJoint(o(z,e.joints[n],s));return s},t.prototype.getBodyList=function(){return this.m_bodyList},t.prototype.getJointList=function(){return this.m_jointList},t.prototype.getContactList=function(){return this.m_contactList},t.prototype.getBodyCount=function(){return this.m_bodyCount},t.prototype.getJointCount=function(){return this.m_jointCount},t.prototype.getContactCount=function(){return this.m_contactCount},t.prototype.setGravity=function(t){this.m_gravity=t},t.prototype.getGravity=function(){return this.m_gravity},t.prototype.isLocked=function(){return this.m_locked},t.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var e=this.m_bodyList;e;e=e.m_next)e.setAwake(!0)},t.prototype.getAllowSleeping=function(){return this.m_allowSleep},t.prototype.setWarmStarting=function(t){this.m_warmStarting=t},t.prototype.getWarmStarting=function(){return this.m_warmStarting},t.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},t.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},t.prototype.setSubStepping=function(t){this.m_subStepping=t},t.prototype.getSubStepping=function(){return this.m_subStepping},t.prototype.setAutoClearForces=function(t){this.m_clearForces=t},t.prototype.getAutoClearForces=function(){return this.m_clearForces},t.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},t.prototype.queryAABB=function(t,e){var i=this.m_broadPhase;this.m_broadPhase.query(t,(function(t){var o=i.getUserData(t);return e(o.fixture)}))},t.prototype.rayCast=function(t,e,i){var o=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:e},(function(t,e){var s=o.getUserData(e),n=s.fixture,m=s.childIndex,a={};if(n.rayCast(a,t,m)){var c=a.fraction,h=r.add(r.mulNumVec2(1-c,t.p1),r.mulNumVec2(c,t.p2));return i(n,h,a.normal,c)}return t.maxFraction}))},t.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},t.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},t.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},t.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},t.prototype.shiftOrigin=function(t){if(!this.m_locked){for(var e=this.m_bodyList;e;e=e.m_next)e.m_xf.p.sub(t),e.m_sweep.c0.sub(t),e.m_sweep.c.sub(t);for(var i=this.m_jointList;i;i=i.m_next)i.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},t.prototype._addBody=function(t){this.isLocked()||(t.m_prev=null,t.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=t),this.m_bodyList=t,++this.m_bodyCount)},t.prototype.createBody=function(t,e){if(this.isLocked())return null;var i={};t&&(r.isValid(t)?i={position:t,angle:e}:"object"==typeof t&&(i=t));var o=new I(this,i);return this._addBody(o),o},t.prototype.createDynamicBody=function(t,e){var i={};return t&&(r.isValid(t)?i={position:t,angle:e}:"object"==typeof t&&(i=t)),i.type="dynamic",this.createBody(i)},t.prototype.createKinematicBody=function(t,e){var i={};return t&&(r.isValid(t)?i={position:t,angle:e}:"object"==typeof t&&(i=t)),i.type="kinematic",this.createBody(i)},t.prototype.destroyBody=function(t){if(!this.isLocked()){if(t.m_destroyed)return!1;for(var e=t.m_jointList;e;){var i=e;e=e.next,this.publish("remove-joint",i.joint),this.destroyJoint(i.joint),t.m_jointList=e}t.m_jointList=null;for(var o=t.m_contactList;o;){var s=o;o=o.next,this.destroyContact(s.contact),t.m_contactList=o}t.m_contactList=null;for(var n=t.m_fixtureList;n;){var r=n;n=n.m_next,this.publish("remove-fixture",r),r.destroyProxies(this.m_broadPhase),t.m_fixtureList=n}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,this.publish("remove-body",t),!0}},t.prototype.createJoint=function(t){if(this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var e=t.m_bodyB.getContactList();e;e=e.next)e.other==t.m_bodyA&&e.contact.flagForFiltering();return t},t.prototype.destroyJoint=function(t){if(!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var e=t.m_bodyA,i=t.m_bodyB;if(e.setAwake(!0),i.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==e.m_jointList&&(e.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==i.m_jointList&&(i.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,--this.m_jointCount,0==t.m_collideConnected)for(var o=i.getContactList();o;)o.other==e&&o.contact.flagForFiltering(),o=o.next;this.publish("remove-joint",t)}},t.prototype.step=function(t,e,i){if(this.publish("pre-step",t),(0|e)!==e&&(e=0),e=e||this.m_velocityIterations,i=i||this.m_positionIterations,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,this.s_step.reset(t),this.s_step.velocityIterations=e,this.s_step.positionIterations=i,this.s_step.warmStarting=this.m_warmStarting,this.s_step.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(this.s_step);for(var o=this.m_bodyList;o;o=o.getNext())0!=o.m_islandFlag&&(o.isStatic()||o.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(this.s_step),this.m_clearForces&&this.clearForces(),this.m_locked=!1,this.publish("post-step",t)},t.prototype.findNewContacts=function(){var t=this;this.m_broadPhase.updatePairs((function(e,i){return t.createContact(e,i)}))},t.prototype.createContact=function(t,e){var i=t.fixture,o=e.fixture,s=t.childIndex,n=e.childIndex,r=i.getBody(),m=o.getBody();if(r!=m){for(var a=m.getContactList();a;){if(a.other==r){var c=a.contact.getFixtureA(),h=a.contact.getFixtureB(),_=a.contact.getChildIndexA(),l=a.contact.getChildIndexB();if(c==i&&h==o&&_==s&&l==n)return;if(c==o&&h==i&&_==n&&l==s)return}a=a.next}if(0!=m.shouldCollide(r)&&0!=o.shouldCollide(i)){var u=yt.create(i,s,o,n);null!=u&&(u.m_prev=null,null!=this.m_contactList&&(u.m_next=this.m_contactList,this.m_contactList.m_prev=u),this.m_contactList=u,++this.m_contactCount)}}},t.prototype.updateContacts=function(){for(var t,e=this.m_contactList;t=e;){e=t.getNext();var i=t.getFixtureA(),o=t.getFixtureB(),s=t.getChildIndexA(),n=t.getChildIndexB(),r=i.getBody(),m=o.getBody();if(t.m_filterFlag){if(0==m.shouldCollide(r)){this.destroyContact(t);continue}if(0==o.shouldCollide(i)){this.destroyContact(t);continue}t.m_filterFlag=!1}var a=r.isAwake()&&!r.isStatic(),c=m.isAwake()&&!m.isStatic();if(0!=a||0!=c){var h=i.m_proxies[s].proxyId,_=o.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(h,_)?t.update(this):this.destroyContact(t)}}},t.prototype.destroyContact=function(t){yt.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},t.prototype.on=function(t,e){return"string"!=typeof t||"function"!=typeof e||(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(e)),this},t.prototype.off=function(t,e){if("string"!=typeof t||"function"!=typeof e)return this;var i=this._listeners&&this._listeners[t];if(!i||!i.length)return this;var o=i.indexOf(e);return o>=0&&i.splice(o,1),this},t.prototype.publish=function(t,e,i,o){var s=this._listeners&&this._listeners[t];if(!s||!s.length)return 0;for(var n=0;n<s.length;n++)s[n].call(this,e,i,o);return s.length},t.prototype.beginContact=function(t){this.publish("begin-contact",t)},t.prototype.endContact=function(t){this.publish("end-contact",t)},t.prototype.preSolve=function(t,e){this.publish("pre-solve",t,e)},t.prototype.postSolve=function(t,e){this.publish("post-solve",t,e)},t}(),vt=function(){function t(e,i,o){if(!(this instanceof t))return new t(e,i,o);void 0===e?(this.x=0,this.y=0,this.z=0):"object"==typeof e?(this.x=e.x,this.y=e.y,this.z=e.z):(this.x=e,this.y=i,this.z=o)}return t.prototype._serialize=function(){return{x:this.x,y:this.y,z:this.z}},t._deserialize=function(e){var i=Object.create(t.prototype);return i.x=e.x,i.y=e.y,i.z=e.z,i},t.neo=function(e,i,o){var s=Object.create(t.prototype);return s.x=e,s.y=i,s.z=o,s},t.zero=function(){var e=Object.create(t.prototype);return e.x=0,e.y=0,e.z=0,e},t.clone=function(e){return t.neo(e.x,e.y,e.z)},t.prototype.toString=function(){return JSON.stringify(this)},t.isValid=function(t){return null!=t&&(n.isFinite(t.x)&&n.isFinite(t.y)&&n.isFinite(t.z))},t.assert=function(t){},t.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},t.prototype.set=function(t,e,i){return this.x=t,this.y=e,this.z=i,this},t.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},t.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},t.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},t.areEqual=function(t,e){return t===e||"object"==typeof t&&null!==t&&"object"==typeof e&&null!==e&&t.x===e.x&&t.y===e.y&&t.z===e.z},t.dot=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},t.cross=function(e,i){return new t(e.y*i.z-e.z*i.y,e.z*i.x-e.x*i.z,e.x*i.y-e.y*i.x)},t.add=function(e,i){return new t(e.x+i.x,e.y+i.y,e.z+i.z)},t.sub=function(e,i){return new t(e.x-i.x,e.y-i.y,e.z-i.z)},t.mul=function(e,i){return new t(i*e.x,i*e.y,i*e.z)},t.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},t.neg=function(e){return new t(-e.x,-e.y,-e.z)},t}(),xt=function(t){function e(i,o){var s=this;return s instanceof e?((s=t.call(this)||this).m_type=e.TYPE,s.m_radius=a.polygonRadius,s.m_vertex1=i?r.clone(i):r.zero(),s.m_vertex2=o?r.clone(o):r.zero(),s.m_vertex0=r.zero(),s.m_vertex3=r.zero(),s.m_hasVertex0=!1,s.m_hasVertex3=!1,s):new e(i,o)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,vertex1:this.m_vertex1,vertex2:this.m_vertex2,vertex0:this.m_vertex0,vertex3:this.m_vertex3,hasVertex0:this.m_hasVertex0,hasVertex3:this.m_hasVertex3}},e._deserialize=function(t){var i=new e(t.vertex1,t.vertex2);return i.m_hasVertex0&&i.setPrevVertex(t.vertex0),i.m_hasVertex3&&i.setNextVertex(t.vertex3),i},e.prototype._reset=function(){},e.prototype.getRadius=function(){return this.m_radius},e.prototype.getType=function(){return this.m_type},e.prototype.setNext=function(t){return this.setNextVertex(t)},e.prototype.setNextVertex=function(t){return t?(this.m_vertex3.setVec2(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},e.prototype.getNextVertex=function(){return this.m_vertex3},e.prototype.setPrev=function(t){return this.setPrevVertex(t)},e.prototype.setPrevVertex=function(t){return t?(this.m_vertex0.setVec2(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},e.prototype.getPrevVertex=function(){return this.m_vertex0},e.prototype._set=function(t,e){return this.m_vertex1.setVec2(t),this.m_vertex2.setVec2(e),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},e.prototype._clone=function(){var t=new e;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.setVec2(this.m_vertex1),t.m_vertex2.setVec2(this.m_vertex2),t.m_vertex0.setVec2(this.m_vertex0),t.m_vertex3.setVec2(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},e.prototype.getChildCount=function(){return 1},e.prototype.testPoint=function(t,e){return!1},e.prototype.rayCast=function(t,e,i,o){var s=p.mulTVec2(i.q,r.sub(e.p1,i.p)),n=p.mulTVec2(i.q,r.sub(e.p2,i.p)),m=r.sub(n,s),a=this.m_vertex1,c=this.m_vertex2,h=r.sub(c,a),_=r.neo(h.y,-h.x);_.normalize();var l=r.dot(_,r.sub(a,s)),u=r.dot(_,m);if(0==u)return!1;var y=l/u;if(y<0||e.maxFraction<y)return!1;var d=r.add(s,r.mulNumVec2(y,m)),f=r.sub(c,a),v=r.dot(f,f);if(0==v)return!1;var x=r.dot(r.sub(d,a),f)/v;return!(x<0||1<x)&&(t.fraction=y,t.normal=l>0?p.mulVec2(i.q,_).neg():p.mulVec2(i.q,_),!0)},e.prototype.computeAABB=function(t,e,i){var o=y.mulVec2(e,this.m_vertex1),s=y.mulVec2(e,this.m_vertex2);t.combinePoints(o,s),t.extend(this.m_radius)},e.prototype.computeMass=function(t,e){t.mass=0,t.center.setCombine(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},e.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius},e.TYPE="edge",e}(x),At=xt,gt=function(t){function e(i,o){var s=this;return s instanceof e?((s=t.call(this)||this).m_type=e.TYPE,s.m_radius=a.polygonRadius,s.m_vertices=[],s.m_count=0,s.m_prevVertex=null,s.m_nextVertex=null,s.m_hasPrevVertex=!1,s.m_hasNextVertex=!1,s.m_isLoop=!!o,i&&i.length&&(o?s._createLoop(i):s._createChain(i)),s):new e(i,o)}return i(e,t),e.prototype._serialize=function(){var t={type:this.m_type,vertices:this.m_vertices,isLoop:this.m_isLoop,hasPrevVertex:this.m_hasPrevVertex,hasNextVertex:this.m_hasNextVertex,prevVertex:null,nextVertex:null};return this.m_prevVertex&&(t.prevVertex=this.m_prevVertex),this.m_nextVertex&&(t.nextVertex=this.m_nextVertex),t},e._deserialize=function(t,i,o){var s=[];if(t.vertices)for(var n=0;n<t.vertices.length;n++)s.push(o(r,t.vertices[n]));var m=new e(s,t.isLoop);return t.prevVertex&&m.setPrevVertex(t.prevVertex),t.nextVertex&&m.setNextVertex(t.nextVertex),m},e.prototype.getType=function(){return this.m_type},e.prototype.getRadius=function(){return this.m_radius},e.prototype._createLoop=function(t){for(var e=1;e<t.length;++e)t[e-1],t[e];this.m_vertices=[],this.m_count=t.length+1;for(e=0;e<t.length;++e)this.m_vertices[e]=r.clone(t[e]);return this.m_vertices[t.length]=r.clone(t[0]),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},e.prototype._createChain=function(t){for(var e=1;e<t.length;++e)t[e-1],t[e];this.m_count=t.length;for(e=0;e<t.length;++e)this.m_vertices[e]=r.clone(t[e]);return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},e.prototype._reset=function(){this.m_isLoop?this._createLoop(this.m_vertices):this._createChain(this.m_vertices)},e.prototype.setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},e.prototype.getPrevVertex=function(){return this.m_prevVertex},e.prototype.setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},e.prototype.getNextVertex=function(){return this.m_nextVertex},e.prototype._clone=function(){var t=new e;return t._createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},e.prototype.getChildCount=function(){return this.m_count-1},e.prototype.getChildEdge=function(t,e){t.m_type=xt.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[e],t.m_vertex2=this.m_vertices[e+1],e>0?(t.m_vertex0=this.m_vertices[e-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),e<this.m_count-2?(t.m_vertex3=this.m_vertices[e+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},e.prototype.getVertex=function(t){return t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},e.prototype.isLoop=function(){return this.m_isLoop},e.prototype.testPoint=function(t,e){return!1},e.prototype.rayCast=function(t,e,i,o){return new xt(this.getVertex(o),this.getVertex(o+1)).rayCast(t,e,i,0)},e.prototype.computeAABB=function(t,e,i){var o=y.mulVec2(e,this.getVertex(i)),s=y.mulVec2(e,this.getVertex(i+1));t.combinePoints(o,s)},e.prototype.computeMass=function(t,e){t.mass=0,t.center=r.zero(),t.I=0},e.prototype.computeDistanceProxy=function(t,e){t.m_buffer[0]=this.getVertex(e),t.m_buffer[1]=this.getVertex(e+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius},e.TYPE="chain",e}(x),bt=gt,Bt=function(t){function e(i){var o=this;return o instanceof e?((o=t.call(this)||this).m_type=e.TYPE,o.m_radius=a.polygonRadius,o.m_centroid=r.zero(),o.m_vertices=[],o.m_normals=[],o.m_count=0,i&&i.length&&o._set(i),o):new e(i)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,vertices:this.m_vertices}},e._deserialize=function(t,i,o){var s=[];if(t.vertices)for(var n=0;n<t.vertices.length;n++)s.push(o(r,t.vertices[n]));return new e(s)},e.prototype.getType=function(){return this.m_type},e.prototype.getRadius=function(){return this.m_radius},e.prototype.getVertex=function(t){return this.m_vertices[t]},e.prototype._clone=function(){var t=new e;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.setVec2(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},e.prototype.getChildCount=function(){return 1},e.prototype._reset=function(){this._set(this.m_vertices)},e.prototype._set=function(t){if(t.length<3)this._setAsBox(1,1);else{for(var e=n.min(t.length,a.maxPolygonVertices),i=[],o=0;o<e;++o){for(var s=t[o],m=!0,c=0;c<i.length;++c)if(r.distanceSquared(s,i[c])<.25*a.linearSlopSquared){m=!1;break}m&&i.push(r.clone(s))}if((e=i.length)<3)this._setAsBox(1,1);else{var h=0,_=i[0].x;for(o=1;o<e;++o){var l=i[o].x;(l>_||l===_&&i[o].y<i[h].y)&&(h=o,_=l)}for(var u=[],p=0,y=h;;){u[p]=y;var d=0;for(c=1;c<e;++c)if(d!==y){var f=r.sub(i[d],i[u[p]]),v=(s=r.sub(i[c],i[u[p]]),r.crossVec2Vec2(f,s));v<0&&(d=c),0===v&&s.lengthSquared()>f.lengthSquared()&&(d=c)}else d=c;if(++p,y=d,d===h)break}if(p<3)this._setAsBox(1,1);else{this.m_count=p,this.m_vertices=[];for(o=0;o<p;++o)this.m_vertices[o]=i[u[o]];for(o=0;o<p;++o){var x=o,A=o+1<p?o+1:0,g=r.sub(this.m_vertices[A],this.m_vertices[x]);this.m_normals[o]=r.crossVec2Num(g,1),this.m_normals[o].normalize()}this.m_centroid=function(t,e){for(var i=r.zero(),o=0,s=r.zero(),n=1/3,m=0;m<e;++m){var a=s,c=t[m],h=m+1<e?t[m+1]:t[0],_=r.sub(c,a),l=r.sub(h,a),u=.5*r.crossVec2Vec2(_,l);o+=u,i.addMul(u*n,a),i.addMul(u*n,c),i.addMul(u*n,h)}return i.mul(1/o),i}(this.m_vertices,p)}}}},e.prototype._setAsBox=function(t,e,i,o){if(this.m_vertices[0]=r.neo(t,-e),this.m_vertices[1]=r.neo(t,e),this.m_vertices[2]=r.neo(-t,e),this.m_vertices[3]=r.neo(-t,-e),this.m_normals[0]=r.neo(1,0),this.m_normals[1]=r.neo(0,1),this.m_normals[2]=r.neo(-1,0),this.m_normals[3]=r.neo(0,-1),this.m_count=4,r.isValid(i)){o=o||0,this.m_centroid.setVec2(i);var s=y.identity();s.p.setVec2(i),s.q.setAngle(o);for(var n=0;n<this.m_count;++n)this.m_vertices[n]=y.mulVec2(s,this.m_vertices[n]),this.m_normals[n]=p.mulVec2(s.q,this.m_normals[n])}},e.prototype.testPoint=function(t,e){for(var i=p.mulTVec2(t.q,r.sub(e,t.p)),o=0;o<this.m_count;++o){if(r.dot(this.m_normals[o],r.sub(i,this.m_vertices[o]))>0)return!1}return!0},e.prototype.rayCast=function(t,e,i,o){for(var s=p.mulTVec2(i.q,r.sub(e.p1,i.p)),n=p.mulTVec2(i.q,r.sub(e.p2,i.p)),m=r.sub(n,s),a=0,c=e.maxFraction,h=-1,_=0;_<this.m_count;++_){var l=r.dot(this.m_normals[_],r.sub(this.m_vertices[_],s)),u=r.dot(this.m_normals[_],m);if(0==u){if(l<0)return!1}else u<0&&l<a*u?(a=l/u,h=_):u>0&&l<c*u&&(c=l/u);if(c<a)return!1}return h>=0&&(t.fraction=a,t.normal=p.mulVec2(i.q,this.m_normals[h]),!0)},e.prototype.computeAABB=function(t,e,i){for(var o=1/0,s=1/0,r=-1/0,m=-1/0,a=0;a<this.m_count;++a){var c=y.mulVec2(e,this.m_vertices[a]);o=n.min(o,c.x),r=n.max(r,c.x),s=n.min(s,c.y),m=n.max(m,c.y)}t.lowerBound.setNum(o,s),t.upperBound.setNum(r,m),t.extend(this.m_radius)},e.prototype.computeMass=function(t,e){for(var i=r.zero(),o=0,s=0,n=r.zero(),m=0;m<this.m_count;++m)n.add(this.m_vertices[m]);n.mul(1/this.m_count);var a=1/3;for(m=0;m<this.m_count;++m){var c=r.sub(this.m_vertices[m],n),h=m+1<this.m_count?r.sub(this.m_vertices[m+1],n):r.sub(this.m_vertices[0],n),_=r.crossVec2Vec2(c,h),l=.5*_;o+=l,i.addCombine(l*a,c,l*a,h);var u=c.x,p=c.y,y=h.x,d=h.y;s+=.25*a*_*(u*u+y*u+y*y+(p*p+d*p+d*d))}t.mass=e*o,i.mul(1/o),t.center.setCombine(1,i,1,n),t.I=e*s,t.I+=t.mass*(r.dot(t.center,t.center)-r.dot(i,i))},e.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var e=t,i=t<this.m_count-1?e+1:0,o=this.m_vertices[e],s=r.sub(this.m_vertices[i],o),n=0;n<this.m_count;++n)if(n!=e&&n!=i){var m=r.sub(this.m_vertices[n],o);if(r.crossVec2Vec2(s,m)<0)return!1}return!0},e.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius},e.TYPE="polygon",e}(x);var Vt=Bt,wt=function(t){function e(i,o,s,n){var r=this;return r instanceof e?((r=t.call(this)||this)._setAsBox(i,o,s,n),r):new e(i,o,s,n)}return i(e,t),e.TYPE="polygon",e}(Bt),Ct=wt,Mt=function(t){function e(i,o){var s=this;return s instanceof e?((s=t.call(this)||this).m_type=e.TYPE,s.m_p=r.zero(),s.m_radius=1,"object"==typeof i&&r.isValid(i)?(s.m_p.setVec2(i),"number"==typeof o&&(s.m_radius=o)):"number"==typeof i&&(s.m_radius=i),s):new e(i,o)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,p:this.m_p,radius:this.m_radius}},e._deserialize=function(t){return new e(t.p,t.radius)},e.prototype._reset=function(){},e.prototype.getType=function(){return this.m_type},e.prototype.getRadius=function(){return this.m_radius},e.prototype.getCenter=function(){return this.m_p},e.prototype.getVertex=function(t){return this.m_p},e.prototype._clone=function(){var t=new e;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},e.prototype.getChildCount=function(){return 1},e.prototype.testPoint=function(t,e){var i=r.add(t.p,p.mulVec2(t.q,this.m_p)),o=r.sub(e,i);return r.dot(o,o)<=this.m_radius*this.m_radius},e.prototype.rayCast=function(t,e,i,o){var s=r.add(i.p,p.mulVec2(i.q,this.m_p)),m=r.sub(e.p1,s),a=r.dot(m,m)-this.m_radius*this.m_radius,c=r.sub(e.p2,e.p1),h=r.dot(m,c),_=r.dot(c,c),l=h*h-_*a;if(l<0||_<n.EPSILON)return!1;var u=-(h+n.sqrt(l));return 0<=u&&u<=e.maxFraction*_&&(u/=_,t.fraction=u,t.normal=r.add(m,r.mulNumVec2(u,c)),t.normal.normalize(),!0)},e.prototype.computeAABB=function(t,e,i){var o=r.add(e.p,p.mulVec2(e.q,this.m_p));t.lowerBound.setNum(o.x-this.m_radius,o.y-this.m_radius),t.upperBound.setNum(o.x+this.m_radius,o.y+this.m_radius)},e.prototype.computeMass=function(t,e){t.mass=e*n.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+r.dot(this.m_p,this.m_p))},e.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius},e.TYPE="circle",e}(x),It=Mt,St={frequencyHz:0,dampingRatio:0},zt=function(t){function e(i,o,m,a,c){var h=this;if(!(h instanceof e))return new e(i,o,m,a,c);if(m&&a&&"m_type"in a&&"x"in m&&"y"in m){var _=m;m=a,a=_}return i=s(i,St),o=(h=t.call(this,i,o,m)||this).m_bodyA,m=h.m_bodyB,h.m_type=e.TYPE,h.m_localAnchorA=r.clone(a?o.getLocalPoint(a):i.localAnchorA||r.zero()),h.m_localAnchorB=r.clone(c?m.getLocalPoint(c):i.localAnchorB||r.zero()),h.m_length=n.isFinite(i.length)?i.length:r.distance(o.getWorldPoint(h.m_localAnchorA),m.getWorldPoint(h.m_localAnchorB)),h.m_frequencyHz=i.frequencyHz,h.m_dampingRatio=i.dampingRatio,h.m_impulse=0,h.m_gamma=0,h.m_bias=0,h}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,length:this.m_length,impulse:this.m_impulse,gamma:this.m_gamma,bias:this.m_bias}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB),t.length>0?this.m_length=+t.length:t.length<0||(t.anchorA||t.anchorA||t.anchorA||t.anchorA)&&(this.m_length=r.distance(this.m_bodyA.getWorldPoint(this.m_localAnchorA),this.m_bodyB.getWorldPoint(this.m_localAnchorB)))},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setLength=function(t){this.m_length=t},e.prototype.getLength=function(){return this.m_length},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(this.m_impulse,this.m_u).mul(t)},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,m=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,h=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,l=p.neo(i),u=p.neo(c);this.m_rA=p.mulVec2(l,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=p.mulVec2(u,r.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=r.sub(r.add(m,this.m_rB),r.add(e,this.m_rA));var y=this.m_u.length();y>a.linearSlop?this.m_u.mul(1/y):this.m_u.setNum(0,0);var d=r.crossVec2Vec2(this.m_rA,this.m_u),f=r.crossVec2Vec2(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*d*d+this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=0!=v?1/v:0,this.m_frequencyHz>0){var x=y-this.m_length,A=2*n.PI*this.m_frequencyHz,g=2*this.m_mass*this.m_dampingRatio*A,b=this.m_mass*A*A,B=t.dt;this.m_gamma=B*(g+B*b),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*b*this.m_gamma,v+=this.m_gamma,this.m_mass=0!=v?1/v:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var V=r.mulNumVec2(this.m_impulse,this.m_u);o.subMul(this.m_invMassA,V),s-=this.m_invIA*r.crossVec2Vec2(this.m_rA,V),h.addMul(this.m_invMassB,V),_+=this.m_invIB*r.crossVec2Vec2(this.m_rB,V)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.setVec2(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.setVec2(h),this.m_bodyB.c_velocity.w=_},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=r.add(e,r.crossNumVec2(i,this.m_rA)),m=r.add(o,r.crossNumVec2(s,this.m_rB)),a=r.dot(this.m_u,m)-r.dot(this.m_u,n),c=-this.m_mass*(a+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=c;var h=r.mulNumVec2(c,this.m_u);e.subMul(this.m_invMassA,h),i-=this.m_invIA*r.crossVec2Vec2(this.m_rA,h),o.addMul(this.m_invMassB,h),s+=this.m_invIB*r.crossVec2Vec2(this.m_rB,h),this.m_bodyA.c_velocity.v.setVec2(e),this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v.setVec2(o),this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,m=p.neo(i),c=p.neo(s),h=p.mulSub(m,this.m_localAnchorA,this.m_localCenterA),_=p.mulSub(c,this.m_localAnchorB,this.m_localCenterB),l=r.sub(r.add(o,_),r.add(e,h)),u=l.normalize()-this.m_length;u=n.clamp(u,-a.maxLinearCorrection,a.maxLinearCorrection);var y=-this.m_mass*u,d=r.mulNumVec2(y,l);return e.subMul(this.m_invMassA,d),i-=this.m_invIA*r.crossVec2Vec2(h,d),o.addMul(this.m_invMassB,d),s+=this.m_invIB*r.crossVec2Vec2(_,d),this.m_bodyA.c_position.c.setVec2(e),this.m_bodyA.c_position.a=i,this.m_bodyB.c_position.c.setVec2(o),this.m_bodyB.c_position.a=s,n.abs(u)<a.linearSlop},e.TYPE="distance-joint",e}(z),Pt={maxForce:0,maxTorque:0},Tt=function(t){function e(i,o,n,m){var a=this;return a instanceof e?(i=s(i,Pt),o=(a=t.call(this,i,o,n)||this).m_bodyA,n=a.m_bodyB,a.m_type=e.TYPE,a.m_localAnchorA=r.clone(m?o.getLocalPoint(m):i.localAnchorA||r.zero()),a.m_localAnchorB=r.clone(m?n.getLocalPoint(m):i.localAnchorB||r.zero()),a.m_linearImpulse=r.zero(),a.m_angularImpulse=0,a.m_maxForce=i.maxForce,a.m_maxTorque=i.maxTorque,a):new e(i,o,n,m)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,maxForce:this.m_maxForce,maxTorque:this.m_maxTorque,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB)},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setMaxForce=function(t){this.m_maxForce=t},e.prototype.getMaxForce=function(){return this.m_maxForce},e.prototype.setMaxTorque=function(t){this.m_maxTorque=t},e.prototype.getMaxTorque=function(){return this.m_maxTorque},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(t,this.m_linearImpulse)},e.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.a,i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,a=p.neo(e),c=p.neo(s);this.m_rA=p.mulVec2(a,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=p.mulVec2(c,r.sub(this.m_localAnchorB,this.m_localCenterB));var h=this.m_invMassA,_=this.m_invMassB,l=this.m_invIA,u=this.m_invIB,y=new et;if(y.ex.x=h+_+l*this.m_rA.y*this.m_rA.y+u*this.m_rB.y*this.m_rB.y,y.ex.y=-l*this.m_rA.x*this.m_rA.y-u*this.m_rB.x*this.m_rB.y,y.ey.x=y.ex.y,y.ey.y=h+_+l*this.m_rA.x*this.m_rA.x+u*this.m_rB.x*this.m_rB.x,this.m_linearMass=y.getInverse(),this.m_angularMass=l+u,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var d=r.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);i.subMul(h,d),o-=l*(r.crossVec2Vec2(this.m_rA,d)+this.m_angularImpulse),n.addMul(_,d),m+=u*(r.crossVec2Vec2(this.m_rB,d)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=m},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,m=this.m_invMassA,a=this.m_invMassB,c=this.m_invIA,h=this.m_invIB,_=t.dt,l=s-i,u=-this.m_angularMass*l,p=this.m_angularImpulse,y=_*this.m_maxTorque;this.m_angularImpulse=n.clamp(this.m_angularImpulse+u,-y,y),i-=c*(u=this.m_angularImpulse-p),s+=h*u;l=r.sub(r.add(o,r.crossNumVec2(s,this.m_rB)),r.add(e,r.crossNumVec2(i,this.m_rA))),u=r.neg(et.mulVec2(this.m_linearMass,l)),p=this.m_linearImpulse;this.m_linearImpulse.add(u);y=_*this.m_maxForce;this.m_linearImpulse.lengthSquared()>y*y&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(y)),u=r.sub(this.m_linearImpulse,p),e.subMul(m,u),i-=c*r.crossVec2Vec2(this.m_rA,u),o.addMul(a,u),s+=h*r.crossVec2Vec2(this.m_rB,u),this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){return!0},e.TYPE="friction-joint",e}(z),Ft=function(){function t(t,e,i){"object"==typeof t&&null!==t?(this.ex=vt.clone(t),this.ey=vt.clone(e),this.ez=vt.clone(i)):(this.ex=vt.zero(),this.ey=vt.zero(),this.ez=vt.zero())}return t.prototype.toString=function(){return JSON.stringify(this)},t.isValid=function(t){return null!=t&&(vt.isValid(t.ex)&&vt.isValid(t.ey)&&vt.isValid(t.ez))},t.assert=function(t){},t.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},t.prototype.solve33=function(t){var e=vt.dot(this.ex,vt.cross(this.ey,this.ez));0!==e&&(e=1/e);var i=new vt;return i.x=e*vt.dot(t,vt.cross(this.ey,this.ez)),i.y=e*vt.dot(this.ex,vt.cross(t,this.ez)),i.z=e*vt.dot(this.ex,vt.cross(this.ey,t)),i},t.prototype.solve22=function(t){var e=this.ex.x,i=this.ey.x,o=this.ex.y,s=this.ey.y,n=e*s-i*o;0!==n&&(n=1/n);var m=r.zero();return m.x=n*(s*t.x-i*t.y),m.y=n*(e*t.y-o*t.x),m},t.prototype.getInverse22=function(t){var e=this.ex.x,i=this.ey.x,o=this.ex.y,s=this.ey.y,n=e*s-i*o;0!==n&&(n=1/n),t.ex.x=n*s,t.ey.x=-n*i,t.ex.z=0,t.ex.y=-n*o,t.ey.y=n*e,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},t.prototype.getSymInverse33=function(t){var e=vt.dot(this.ex,vt.cross(this.ey,this.ez));0!==e&&(e=1/e);var i=this.ex.x,o=this.ey.x,s=this.ez.x,n=this.ey.y,r=this.ez.y,m=this.ez.z;t.ex.x=e*(n*m-r*r),t.ex.y=e*(s*r-o*m),t.ex.z=e*(o*r-s*n),t.ey.x=t.ex.y,t.ey.y=e*(i*m-s*s),t.ey.z=e*(s*o-i*r),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=e*(i*n-o*o)},t.mul=function(t,e){if(e&&"z"in e&&"y"in e&&"x"in e){var i=t.ex.x*e.x+t.ey.x*e.y+t.ez.x*e.z,o=t.ex.y*e.x+t.ey.y*e.y+t.ez.y*e.z,s=t.ex.z*e.x+t.ey.z*e.y+t.ez.z*e.z;return new vt(i,o,s)}if(e&&"y"in e&&"x"in e){i=t.ex.x*e.x+t.ey.x*e.y,o=t.ex.y*e.x+t.ey.y*e.y;return r.neo(i,o)}},t.mulVec3=function(t,e){var i=t.ex.x*e.x+t.ey.x*e.y+t.ez.x*e.z,o=t.ex.y*e.x+t.ey.y*e.y+t.ez.y*e.z,s=t.ex.z*e.x+t.ey.z*e.y+t.ez.z*e.z;return new vt(i,o,s)},t.mulVec2=function(t,e){var i=t.ex.x*e.x+t.ey.x*e.y,o=t.ex.y*e.x+t.ey.y*e.y;return r.neo(i,o)},t.add=function(e,i){return new t(vt.add(e.ex,i.ex),vt.add(e.ey,i.ey),vt.add(e.ez,i.ez))},t}(),Lt={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1},qt=function(t){function e(i,o,m,a){var c=this;return c instanceof e?(i=s(i,Lt),(c=t.call(this,i,o,m)||this).m_mass=new Ft,c.m_limitState=0,o=c.m_bodyA,m=c.m_bodyB,c.m_type=e.TYPE,c.m_localAnchorA=r.clone(a?o.getLocalPoint(a):i.localAnchorA||r.zero()),c.m_localAnchorB=r.clone(a?m.getLocalPoint(a):i.localAnchorB||r.zero()),c.m_referenceAngle=n.isFinite(i.referenceAngle)?i.referenceAngle:m.getAngle()-o.getAngle(),c.m_impulse=new vt,c.m_motorImpulse=0,c.m_lowerAngle=i.lowerAngle,c.m_upperAngle=i.upperAngle,c.m_maxMotorTorque=i.maxMotorTorque,c.m_motorSpeed=i.motorSpeed,c.m_enableLimit=i.enableLimit,c.m_enableMotor=i.enableMotor,c):new e(i,o,m,a)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,lowerAngle:this.m_lowerAngle,upperAngle:this.m_upperAngle,maxMotorTorque:this.m_maxMotorTorque,motorSpeed:this.m_motorSpeed,enableLimit:this.m_enableLimit,enableMotor:this.m_enableMotor,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,referenceAngle:this.m_referenceAngle}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB)},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},e.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},e.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},e.prototype.isLimitEnabled=function(){return this.m_enableLimit},e.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},e.prototype.getLowerLimit=function(){return this.m_lowerAngle},e.prototype.getUpperLimit=function(){return this.m_upperAngle},e.prototype.setLimits=function(t,e){t==this.m_lowerAngle&&e==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=e)},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.a,i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,h=p.neo(e),_=p.neo(s);this.m_rA=p.mulVec2(h,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=p.mulVec2(_,r.sub(this.m_localAnchorB,this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,f=y+d===0;if(this.m_mass.ex.x=l+u+this.m_rA.y*this.m_rA.y*y+this.m_rB.y*this.m_rB.y*d,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*y-this.m_rB.y*this.m_rB.x*d,this.m_mass.ez.x=-this.m_rA.y*y-this.m_rB.y*d,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=l+u+this.m_rA.x*this.m_rA.x*y+this.m_rB.x*this.m_rB.x*d,this.m_mass.ez.y=this.m_rA.x*y+this.m_rB.x*d,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=y+d,this.m_motorMass=y+d,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||f)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==f){var v=s-e-this.m_referenceAngle;n.abs(this.m_upperAngle-this.m_lowerAngle)<2*a.angularSlop?this.m_limitState=3:v<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):v>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=0,this.m_impulse.z=0)}else this.m_limitState=0;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var x=r.neo(this.m_impulse.x,this.m_impulse.y);i.subMul(l,x),o-=y*(r.crossVec2Vec2(this.m_rA,x)+this.m_motorImpulse+this.m_impulse.z),m.addMul(u,x),c+=d*(r.crossVec2Vec2(this.m_rB,x)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=c},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,m=this.m_invMassA,a=this.m_invMassB,c=this.m_invIA,h=this.m_invIB,_=c+h===0;if(this.m_enableMotor&&3!=this.m_limitState&&0==_){var l=s-i-this.m_motorSpeed,u=-this.m_motorMass*l,p=this.m_motorImpulse,y=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=n.clamp(this.m_motorImpulse+u,-y,y),i-=c*(u=this.m_motorImpulse-p),s+=h*u}if(this.m_enableLimit&&0!=this.m_limitState&&0==_){var d=r.zero();d.addCombine(1,o,1,r.crossNumVec2(s,this.m_rB)),d.subCombine(1,e,1,r.crossNumVec2(i,this.m_rA));var f=s-i;l=new vt(d.x,d.y,f),u=vt.neg(this.m_mass.solve33(l));if(3==this.m_limitState)this.m_impulse.add(u);else if(1==this.m_limitState){if(this.m_impulse.z+u.z<0){var v=r.combine(-1,d,this.m_impulse.z,r.neo(this.m_mass.ez.x,this.m_mass.ez.y)),x=this.m_mass.solve22(v);u.x=x.x,u.y=x.y,u.z=-this.m_impulse.z,this.m_impulse.x+=x.x,this.m_impulse.y+=x.y,this.m_impulse.z=0}else this.m_impulse.add(u)}else if(2==this.m_limitState){if(this.m_impulse.z+u.z>0){v=r.combine(-1,d,this.m_impulse.z,r.neo(this.m_mass.ez.x,this.m_mass.ez.y)),x=this.m_mass.solve22(v);u.x=x.x,u.y=x.y,u.z=-this.m_impulse.z,this.m_impulse.x+=x.x,this.m_impulse.y+=x.y,this.m_impulse.z=0}else this.m_impulse.add(u)}var A=r.neo(u.x,u.y);e.subMul(m,A),i-=c*(r.crossVec2Vec2(this.m_rA,A)+u.z),o.addMul(a,A),s+=h*(r.crossVec2Vec2(this.m_rB,A)+u.z)}else{(l=r.zero()).addCombine(1,o,1,r.crossNumVec2(s,this.m_rB)),l.subCombine(1,e,1,r.crossNumVec2(i,this.m_rA));u=this.m_mass.solve22(r.neg(l));this.m_impulse.x+=u.x,this.m_impulse.y+=u.y,e.subMul(m,u),i-=c*r.crossVec2Vec2(this.m_rA,u),o.addMul(a,u),s+=h*r.crossVec2Vec2(this.m_rB,u)}this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var e,i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,s=this.m_bodyB.c_position.c,m=this.m_bodyB.c_position.a,c=p.neo(o),h=p.neo(m),_=0,l=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&0!=this.m_limitState&&0==l){var u=m-o-this.m_referenceAngle,y=0;if(3==this.m_limitState){var d=n.clamp(u-this.m_lowerAngle,-a.maxAngularCorrection,a.maxAngularCorrection);y=-this.m_motorMass*d,_=n.abs(d)}else if(1==this.m_limitState){_=-(d=u-this.m_lowerAngle),d=n.clamp(d+a.angularSlop,-a.maxAngularCorrection,0),y=-this.m_motorMass*d}else if(2==this.m_limitState){_=d=u-this.m_upperAngle,d=n.clamp(d-a.angularSlop,0,a.maxAngularCorrection),y=-this.m_motorMass*d}o-=this.m_invIA*y,m+=this.m_invIB*y}c.setAngle(o),h.setAngle(m);var f=p.mulVec2(c,r.sub(this.m_localAnchorA,this.m_localCenterA)),v=p.mulVec2(h,r.sub(this.m_localAnchorB,this.m_localCenterB));(d=r.zero()).addCombine(1,s,1,v),d.subCombine(1,i,1,f),e=d.length();var x=this.m_invMassA,A=this.m_invMassB,g=this.m_invIA,b=this.m_invIB,B=new et;B.ex.x=x+A+g*f.y*f.y+b*v.y*v.y,B.ex.y=-g*f.x*f.y-b*v.x*v.y,B.ey.x=B.ex.y,B.ey.y=x+A+g*f.x*f.x+b*v.x*v.x;var V=r.neg(B.solve(d));return i.subMul(x,V),o-=g*r.crossVec2Vec2(f,V),s.addMul(A,V),m+=b*r.crossVec2Vec2(v,V),this.m_bodyA.c_position.c.setVec2(i),this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c.setVec2(s),this.m_bodyB.c_position.a=m,e<=a.linearSlop&&_<=a.angularSlop},e.TYPE="revolute-joint",e}(z),Nt={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0},kt=function(t){function e(i,o,m,a,c){var h=this;return h instanceof e?(i=s(i,Nt),o=(h=t.call(this,i,o,m)||this).m_bodyA,m=h.m_bodyB,h.m_type=e.TYPE,h.m_localAnchorA=r.clone(a?o.getLocalPoint(a):i.localAnchorA||r.zero()),h.m_localAnchorB=r.clone(a?m.getLocalPoint(a):i.localAnchorB||r.zero()),h.m_localXAxisA=r.clone(c?o.getLocalVector(c):i.localAxisA||r.neo(1,0)),h.m_localXAxisA.normalize(),h.m_localYAxisA=r.crossNumVec2(1,h.m_localXAxisA),h.m_referenceAngle=n.isFinite(i.referenceAngle)?i.referenceAngle:m.getAngle()-o.getAngle(),h.m_impulse=new vt,h.m_motorMass=0,h.m_motorImpulse=0,h.m_lowerTranslation=i.lowerTranslation,h.m_upperTranslation=i.upperTranslation,h.m_maxMotorForce=i.maxMotorForce,h.m_motorSpeed=i.motorSpeed,h.m_enableLimit=i.enableLimit,h.m_enableMotor=i.enableMotor,h.m_limitState=0,h.m_axis=r.zero(),h.m_perp=r.zero(),h.m_K=new Ft,h):new e(i,o,m,a,c)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,lowerTranslation:this.m_lowerTranslation,upperTranslation:this.m_upperTranslation,maxMotorForce:this.m_maxMotorForce,motorSpeed:this.m_motorSpeed,enableLimit:this.m_enableLimit,enableMotor:this.m_enableMotor,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,localAxisA:this.m_localXAxisA,referenceAngle:this.m_referenceAngle}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),t.localAxisA=r.clone(t.localAxisA),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB),t.localAxisA&&(this.m_localXAxisA.setVec2(t.localAxisA),this.m_localYAxisA.setVec2(r.crossNumVec2(1,t.localAxisA)))},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getLocalAxisA=function(){return this.m_localXAxisA},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),e=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=r.sub(e,t),o=this.m_bodyA.getWorldVector(this.m_localXAxisA);return r.dot(i,o)},e.prototype.getJointSpeed=function(){var t=this.m_bodyA,e=this.m_bodyB,i=p.mulVec2(t.m_xf.q,r.sub(this.m_localAnchorA,t.m_sweep.localCenter)),o=p.mulVec2(e.m_xf.q,r.sub(this.m_localAnchorB,e.m_sweep.localCenter)),s=r.add(t.m_sweep.c,i),n=r.add(e.m_sweep.c,o),m=r.sub(n,s),a=p.mulVec2(t.m_xf.q,this.m_localXAxisA),c=t.m_linearVelocity,h=e.m_linearVelocity,_=t.m_angularVelocity,l=e.m_angularVelocity;return r.dot(m,r.crossNumVec2(_,a))+r.dot(a,r.sub(r.addCrossNumVec2(h,l,o),r.addCrossNumVec2(c,_,i)))},e.prototype.isLimitEnabled=function(){return this.m_enableLimit},e.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},e.prototype.getLowerLimit=function(){return this.m_lowerTranslation},e.prototype.getUpperLimit=function(){return this.m_upperTranslation},e.prototype.setLimits=function(t,e){t==this.m_lowerTranslation&&e==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=e,this.m_impulse.z=0)},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},e.prototype.getMaxMotorForce=function(){return this.m_maxMotorForce},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis).mul(t)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,m=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,h=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,l=p.neo(i),u=p.neo(c),y=p.mulVec2(l,r.sub(this.m_localAnchorA,this.m_localCenterA)),d=p.mulVec2(u,r.sub(this.m_localAnchorB,this.m_localCenterB)),f=r.zero();f.addCombine(1,m,1,d),f.subCombine(1,e,1,y);var v=this.m_invMassA,x=this.m_invMassB,A=this.m_invIA,g=this.m_invIB;this.m_axis=p.mulVec2(l,this.m_localXAxisA),this.m_a1=r.crossVec2Vec2(r.add(f,y),this.m_axis),this.m_a2=r.crossVec2Vec2(d,this.m_axis),this.m_motorMass=v+x+A*this.m_a1*this.m_a1+g*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=p.mulVec2(l,this.m_localYAxisA),this.m_s1=r.crossVec2Vec2(r.add(f,y),this.m_perp),this.m_s2=r.crossVec2Vec2(d,this.m_perp),r.crossVec2Vec2(y,this.m_perp);var b=v+x+A*this.m_s1*this.m_s1+g*this.m_s2*this.m_s2,B=A*this.m_s1+g*this.m_s2,V=A*this.m_s1*this.m_a1+g*this.m_s2*this.m_a2,w=A+g;0==w&&(w=1);var C=A*this.m_a1+g*this.m_a2,M=v+x+A*this.m_a1*this.m_a1+g*this.m_a2*this.m_a2;if(this.m_K.ex.set(b,B,V),this.m_K.ey.set(B,w,C),this.m_K.ez.set(V,C,M),this.m_enableLimit){var I=r.dot(this.m_axis,f);n.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*a.linearSlop?this.m_limitState=3:I<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):I>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=0,this.m_impulse.z=0)}else this.m_limitState=0,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var S=r.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),z=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,P=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;o.subMul(v,S),s-=A*z,h.addMul(x,S),_+=g*P}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.setVec2(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.setVec2(h),this.m_bodyB.c_velocity.w=_},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,m=this.m_invMassA,a=this.m_invMassB,c=this.m_invIA,h=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var _=r.dot(this.m_axis,r.sub(o,e))+this.m_a2*s-this.m_a1*i,l=this.m_motorMass*(this.m_motorSpeed-_),u=this.m_motorImpulse,p=t.dt*this.m_maxMotorForce;this.m_motorImpulse=n.clamp(this.m_motorImpulse+l,-p,p),l=this.m_motorImpulse-u;var y=r.mulNumVec2(l,this.m_axis),d=l*this.m_a1,f=l*this.m_a2;e.subMul(m,y),i-=c*d,o.addMul(a,y),s+=h*f}var v=r.zero();if(v.x+=r.dot(this.m_perp,o)+this.m_s2*s,v.x-=r.dot(this.m_perp,e)+this.m_s1*i,v.y=s-i,this.m_enableLimit&&0!=this.m_limitState){var x=0;x+=r.dot(this.m_axis,o)+this.m_a2*s,x-=r.dot(this.m_axis,e)+this.m_a1*i;_=new vt(v.x,v.y,x);var A=vt.clone(this.m_impulse),g=this.m_K.solve33(vt.neg(_));this.m_impulse.add(g),1==this.m_limitState?this.m_impulse.z=n.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=n.min(this.m_impulse.z,0));var b=r.combine(-1,v,-(this.m_impulse.z-A.z),r.neo(this.m_K.ez.x,this.m_K.ez.y)),B=r.add(this.m_K.solve22(b),r.neo(A.x,A.y));this.m_impulse.x=B.x,this.m_impulse.y=B.y,g=vt.sub(this.m_impulse,A);y=r.combine(g.x,this.m_perp,g.z,this.m_axis),d=g.x*this.m_s1+g.y+g.z*this.m_a1,f=g.x*this.m_s2+g.y+g.z*this.m_a2;e.subMul(m,y),i-=c*d,o.addMul(a,y),s+=h*f}else{g=this.m_K.solve22(r.neg(v));this.m_impulse.x+=g.x,this.m_impulse.y+=g.y;y=r.mulNumVec2(g.x,this.m_perp),d=g.x*this.m_s1+g.y,f=g.x*this.m_s2+g.y;e.subMul(m,y),i-=c*d,o.addMul(a,y),s+=h*f}this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,m=p.neo(i),c=p.neo(s),h=this.m_invMassA,_=this.m_invMassB,l=this.m_invIA,u=this.m_invIB,y=p.mulVec2(m,r.sub(this.m_localAnchorA,this.m_localCenterA)),d=p.mulVec2(c,r.sub(this.m_localAnchorB,this.m_localCenterB)),f=r.sub(r.add(o,d),r.add(e,y)),v=p.mulVec2(m,this.m_localXAxisA),x=r.crossVec2Vec2(r.add(f,y),v),A=r.crossVec2Vec2(d,v),g=p.mulVec2(m,this.m_localYAxisA),b=r.crossVec2Vec2(r.add(f,y),g),B=r.crossVec2Vec2(d,g),V=new vt,w=r.zero();w.x=r.dot(g,f),w.y=s-i-this.m_referenceAngle;var C=n.abs(w.x),M=n.abs(w.y),I=a.linearSlop,S=a.maxLinearCorrection,z=!1,P=0;if(this.m_enableLimit){var T=r.dot(v,f);n.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*I?(P=n.clamp(T,-S,S),C=n.max(C,n.abs(T)),z=!0):T<=this.m_lowerTranslation?(P=n.clamp(T-this.m_lowerTranslation+I,-S,0),C=n.max(C,this.m_lowerTranslation-T),z=!0):T>=this.m_upperTranslation&&(P=n.clamp(T-this.m_upperTranslation-I,0,S),C=n.max(C,T-this.m_upperTranslation),z=!0)}if(z){var F=h+_+l*b*b+u*B*B,L=l*b+u*B,q=l*b*x+u*B*A;0==(j=l+u)&&(j=1);var N=l*x+u*A,k=h+_+l*x*x+u*A*A;(O=new Ft).ex.set(F,L,q),O.ey.set(L,j,N),O.ez.set(q,N,k);var D=new vt;D.x=w.x,D.y=w.y,D.z=P,V=O.solve33(vt.neg(D))}else{var j,O;F=h+_+l*b*b+u*B*B,L=l*b+u*B;0==(j=l+u)&&(j=1),(O=new et).ex.setNum(F,L),O.ey.setNum(L,j);var R=O.solve(r.neg(w));V.x=R.x,V.y=R.y,V.z=0}var E=r.combine(V.x,g,V.z,v),J=V.x*b+V.y+V.z*x,Y=V.x*B+V.y+V.z*A;return e.subMul(h,E),i-=l*J,o.addMul(_,E),s+=u*Y,this.m_bodyA.c_position.c=e,this.m_bodyA.c_position.a=i,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,C<=a.linearSlop&&M<=a.angularSlop},e.TYPE="prismatic-joint",e}(z),Dt={ratio:1},jt=function(t){function e(i,o,m,a,c,h){var _,l,u=this;if(!(u instanceof e))return new e(i,o,m,a,c,h);i=s(i,Dt),o=(u=t.call(this,i,o,m)||this).m_bodyA,m=u.m_bodyB,u.m_type=e.TYPE,u.m_joint1=a||i.joint1,u.m_joint2=c||i.joint2,u.m_ratio=n.isFinite(h)?h:i.ratio,u.m_type1=u.m_joint1.getType(),u.m_type2=u.m_joint2.getType(),u.m_bodyC=u.m_joint1.getBodyA(),u.m_bodyA=u.m_joint1.getBodyB();var y=u.m_bodyA.m_xf,d=u.m_bodyA.m_sweep.a,f=u.m_bodyC.m_xf,v=u.m_bodyC.m_sweep.a;if(u.m_type1===qt.TYPE){var x=u.m_joint1;u.m_localAnchorC=x.m_localAnchorA,u.m_localAnchorA=x.m_localAnchorB,u.m_referenceAngleA=x.m_referenceAngle,u.m_localAxisC=r.zero(),_=d-v-u.m_referenceAngleA}else{var A=u.m_joint1;u.m_localAnchorC=A.m_localAnchorA,u.m_localAnchorA=A.m_localAnchorB,u.m_referenceAngleA=A.m_referenceAngle,u.m_localAxisC=A.m_localXAxisA;var g=u.m_localAnchorC,b=p.mulTVec2(f.q,r.add(p.mulVec2(y.q,u.m_localAnchorA),r.sub(y.p,f.p)));_=r.dot(b,u.m_localAxisC)-r.dot(g,u.m_localAxisC)}u.m_bodyD=u.m_joint2.getBodyA(),u.m_bodyB=u.m_joint2.getBodyB();var B=u.m_bodyB.m_xf,V=u.m_bodyB.m_sweep.a,w=u.m_bodyD.m_xf,C=u.m_bodyD.m_sweep.a;if(u.m_type2===qt.TYPE){x=u.m_joint2;u.m_localAnchorD=x.m_localAnchorA,u.m_localAnchorB=x.m_localAnchorB,u.m_referenceAngleB=x.m_referenceAngle,u.m_localAxisD=r.zero(),l=V-C-u.m_referenceAngleB}else{A=u.m_joint2;u.m_localAnchorD=A.m_localAnchorA,u.m_localAnchorB=A.m_localAnchorB,u.m_referenceAngleB=A.m_referenceAngle,u.m_localAxisD=A.m_localXAxisA;var M=u.m_localAnchorD,I=p.mulTVec2(w.q,r.add(p.mulVec2(B.q,u.m_localAnchorB),r.sub(B.p,w.p)));l=r.dot(I,u.m_localAxisD)-r.dot(M,u.m_localAxisD)}return u.m_constant=_+u.m_ratio*l,u.m_impulse=0,u}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,joint1:this.m_joint1,joint2:this.m_joint2,ratio:this.m_ratio}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),t.joint1=s(z,t.joint1,i),t.joint2=s(z,t.joint2,i),new e(t)},e.prototype.getJoint1=function(){return this.m_joint1},e.prototype.getJoint2=function(){return this.m_joint2},e.prototype.setRatio=function(t){this.m_ratio=t},e.prototype.getRatio=function(){return this.m_ratio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(this.m_impulse,this.m_JvAC).mul(t)},e.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},e.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var e=this.m_bodyA.c_position.a,i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,a=this.m_bodyC.c_position.a,c=this.m_bodyC.c_velocity.v,h=this.m_bodyC.c_velocity.w,_=this.m_bodyD.c_position.a,l=this.m_bodyD.c_velocity.v,u=this.m_bodyD.c_velocity.w,y=p.neo(e),d=p.neo(s),f=p.neo(a),v=p.neo(_);if(this.m_mass=0,this.m_type1==qt.TYPE)this.m_JvAC=r.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var x=p.mulVec2(f,this.m_localAxisC),A=p.mulSub(f,this.m_localAnchorC,this.m_lcC),g=p.mulSub(y,this.m_localAnchorA,this.m_lcA);this.m_JvAC=x,this.m_JwC=r.crossVec2Vec2(A,x),this.m_JwA=r.crossVec2Vec2(g,x),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==qt.TYPE)this.m_JvBD=r.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{x=p.mulVec2(v,this.m_localAxisD);var b=p.mulSub(v,this.m_localAnchorD,this.m_lcD),B=p.mulSub(d,this.m_localAnchorB,this.m_lcB);this.m_JvBD=r.mulNumVec2(this.m_ratio,x),this.m_JwD=this.m_ratio*r.crossVec2Vec2(b,x),this.m_JwB=this.m_ratio*r.crossVec2Vec2(B,x),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(i.addMul(this.m_mA*this.m_impulse,this.m_JvAC),o+=this.m_iA*this.m_impulse*this.m_JwA,n.addMul(this.m_mB*this.m_impulse,this.m_JvBD),m+=this.m_iB*this.m_impulse*this.m_JwB,c.subMul(this.m_mC*this.m_impulse,this.m_JvAC),h-=this.m_iC*this.m_impulse*this.m_JwC,l.subMul(this.m_mD*this.m_impulse,this.m_JvBD),u-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.setVec2(i),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.setVec2(n),this.m_bodyB.c_velocity.w=m,this.m_bodyC.c_velocity.v.setVec2(c),this.m_bodyC.c_velocity.w=h,this.m_bodyD.c_velocity.v.setVec2(l),this.m_bodyD.c_velocity.w=u},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,m=this.m_bodyC.c_velocity.w,a=this.m_bodyD.c_velocity.v,c=this.m_bodyD.c_velocity.w,h=r.dot(this.m_JvAC,e)-r.dot(this.m_JvAC,n)+r.dot(this.m_JvBD,o)-r.dot(this.m_JvBD,a);h+=this.m_JwA*i-this.m_JwC*m+(this.m_JwB*s-this.m_JwD*c);var _=-this.m_mass*h;this.m_impulse+=_,e.addMul(this.m_mA*_,this.m_JvAC),i+=this.m_iA*_*this.m_JwA,o.addMul(this.m_mB*_,this.m_JvBD),s+=this.m_iB*_*this.m_JwB,n.subMul(this.m_mC*_,this.m_JvAC),m-=this.m_iC*_*this.m_JwC,a.subMul(this.m_mD*_,this.m_JvBD),c-=this.m_iD*_*this.m_JwD,this.m_bodyA.c_velocity.v.setVec2(e),this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v.setVec2(o),this.m_bodyB.c_velocity.w=s,this.m_bodyC.c_velocity.v.setVec2(n),this.m_bodyC.c_velocity.w=m,this.m_bodyD.c_velocity.v.setVec2(a),this.m_bodyD.c_velocity.w=c},e.prototype.solvePositionConstraints=function(t){var e,i,o,s,n,m,c,h,_=this.m_bodyA.c_position.c,l=this.m_bodyA.c_position.a,u=this.m_bodyB.c_position.c,y=this.m_bodyB.c_position.a,d=this.m_bodyC.c_position.c,f=this.m_bodyC.c_position.a,v=this.m_bodyD.c_position.c,x=this.m_bodyD.c_position.a,A=p.neo(l),g=p.neo(y),b=p.neo(f),B=p.neo(x),V=0;if(this.m_type1==qt.TYPE)o=r.zero(),n=1,c=1,V+=this.m_iA+this.m_iC,e=l-f-this.m_referenceAngleA;else{var w=p.mulVec2(b,this.m_localAxisC),C=p.mulSub(b,this.m_localAnchorC,this.m_lcC),M=p.mulSub(A,this.m_localAnchorA,this.m_lcA);o=w,c=r.crossVec2Vec2(C,w),n=r.crossVec2Vec2(M,w),V+=this.m_mC+this.m_mA+this.m_iC*c*c+this.m_iA*n*n;var I=r.sub(this.m_localAnchorC,this.m_lcC),S=p.mulTVec2(b,r.add(M,r.sub(_,d)));e=r.dot(r.sub(S,I),this.m_localAxisC)}if(this.m_type2==qt.TYPE)s=r.zero(),m=this.m_ratio,h=this.m_ratio,V+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),i=y-x-this.m_referenceAngleB;else{w=p.mulVec2(B,this.m_localAxisD);var z=p.mulSub(B,this.m_localAnchorD,this.m_lcD),P=p.mulSub(g,this.m_localAnchorB,this.m_lcB);s=r.mulNumVec2(this.m_ratio,w),h=this.m_ratio*r.crossVec2Vec2(z,w),m=this.m_ratio*r.crossVec2Vec2(P,w),V+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*h*h+this.m_iB*m*m;var T=r.sub(this.m_localAnchorD,this.m_lcD),F=p.mulTVec2(B,r.add(P,r.sub(u,v)));i=r.dot(F,this.m_localAxisD)-r.dot(T,this.m_localAxisD)}var L=e+this.m_ratio*i-this.m_constant,q=0;return V>0&&(q=-L/V),_.addMul(this.m_mA*q,o),l+=this.m_iA*q*n,u.addMul(this.m_mB*q,s),y+=this.m_iB*q*m,d.subMul(this.m_mC*q,o),f-=this.m_iC*q*c,v.subMul(this.m_mD*q,s),x-=this.m_iD*q*h,this.m_bodyA.c_position.c.setVec2(_),this.m_bodyA.c_position.a=l,this.m_bodyB.c_position.c.setVec2(u),this.m_bodyB.c_position.a=y,this.m_bodyC.c_position.c.setVec2(d),this.m_bodyC.c_position.a=f,this.m_bodyD.c_position.c.setVec2(v),this.m_bodyD.c_position.a=x,0<a.linearSlop},e.TYPE="gear-joint",e}(z),Ot={maxForce:1,maxTorque:1,correctionFactor:.3},Rt=function(t){function e(i,o,m){var a=this;return a instanceof e?(i=s(i,Ot),o=(a=t.call(this,i,o,m)||this).m_bodyA,m=a.m_bodyB,a.m_type=e.TYPE,a.m_linearOffset=n.isFinite(i.linearOffset)?i.linearOffset:o.getLocalPoint(m.getPosition()),a.m_angularOffset=n.isFinite(i.angularOffset)?i.angularOffset:m.getAngle()-o.getAngle(),a.m_linearImpulse=r.zero(),a.m_angularImpulse=0,a.m_maxForce=i.maxForce,a.m_maxTorque=i.maxTorque,a.m_correctionFactor=i.correctionFactor,a):new e(i,o,m)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,maxForce:this.m_maxForce,maxTorque:this.m_maxTorque,correctionFactor:this.m_correctionFactor,linearOffset:this.m_linearOffset,angularOffset:this.m_angularOffset}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){},e.prototype.setMaxForce=function(t){this.m_maxForce=t},e.prototype.getMaxForce=function(){return this.m_maxForce},e.prototype.setMaxTorque=function(t){this.m_maxTorque=t},e.prototype.getMaxTorque=function(){return this.m_maxTorque},e.prototype.setCorrectionFactor=function(t){this.m_correctionFactor=t},e.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},e.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},e.prototype.getLinearOffset=function(){return this.m_linearOffset},e.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},e.prototype.getAngularOffset=function(){return this.m_angularOffset},e.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},e.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},e.prototype.getReactionForce=function(t){return r.mulNumVec2(t,this.m_linearImpulse)},e.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,m=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,h=p.neo(i),_=p.neo(m);this.m_rA=p.mulVec2(h,r.neg(this.m_localCenterA)),this.m_rB=p.mulVec2(_,r.neg(this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,f=new et;if(f.ex.x=l+u+y*this.m_rA.y*this.m_rA.y+d*this.m_rB.y*this.m_rB.y,f.ex.y=-y*this.m_rA.x*this.m_rA.y-d*this.m_rB.x*this.m_rB.y,f.ey.x=f.ex.y,f.ey.y=l+u+y*this.m_rA.x*this.m_rA.x+d*this.m_rB.x*this.m_rB.x,this.m_linearMass=f.getInverse(),this.m_angularMass=y+d,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=r.zero(),this.m_linearError.addCombine(1,n,1,this.m_rB),this.m_linearError.subCombine(1,e,1,this.m_rA),this.m_linearError.sub(p.mulVec2(h,this.m_linearOffset)),this.m_angularError=m-i-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var v=r.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);o.subMul(l,v),s-=y*(r.crossVec2Vec2(this.m_rA,v)+this.m_angularImpulse),a.addMul(u,v),c+=d*(r.crossVec2Vec2(this.m_rB,v)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=c},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,m=this.m_invMassA,a=this.m_invMassB,c=this.m_invIA,h=this.m_invIB,_=t.dt,l=t.inv_dt,u=s-i+l*this.m_correctionFactor*this.m_angularError,p=-this.m_angularMass*u,y=this.m_angularImpulse,d=_*this.m_maxTorque;this.m_angularImpulse=n.clamp(this.m_angularImpulse+p,-d,d),i-=c*(p=this.m_angularImpulse-y),s+=h*p,(u=r.zero()).addCombine(1,o,1,r.crossNumVec2(s,this.m_rB)),u.subCombine(1,e,1,r.crossNumVec2(i,this.m_rA)),u.addMul(l*this.m_correctionFactor,this.m_linearError);p=r.neg(et.mulVec2(this.m_linearMass,u)),y=r.clone(this.m_linearImpulse);this.m_linearImpulse.add(p);d=_*this.m_maxForce;this.m_linearImpulse.clamp(d),p=r.sub(this.m_linearImpulse,y),e.subMul(m,p),i-=c*r.crossVec2Vec2(this.m_rA,p),o.addMul(a,p),s+=h*r.crossVec2Vec2(this.m_rB,p),this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){return!0},e.TYPE="motor-joint",e}(z),Et={maxForce:0,frequencyHz:5,dampingRatio:.7},Jt=function(t){function e(i,o,n,m){var a=this;return a instanceof e?(i=s(i,Et),o=(a=t.call(this,i,o,n)||this).m_bodyA,n=a.m_bodyB,a.m_type=e.TYPE,r.isValid(m)?a.m_targetA=r.clone(m):r.isValid(i.target)?a.m_targetA=r.clone(i.target):a.m_targetA=r.zero(),a.m_localAnchorB=y.mulTVec2(n.getTransform(),a.m_targetA),a.m_maxForce=i.maxForce,a.m_impulse=r.zero(),a.m_frequencyHz=i.frequencyHz,a.m_dampingRatio=i.dampingRatio,a.m_beta=0,a.m_gamma=0,a.m_rB=r.zero(),a.m_localCenterB=r.zero(),a.m_invMassB=0,a.m_invIB=0,a.m_mass=new et,a.m_C=r.zero(),a):new e(i,o,n,m)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,target:this.m_targetA,maxForce:this.m_maxForce,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,_localAnchorB:this.m_localAnchorB}},e._deserialize=function(t,i,s){(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),t.target=r.clone(t.target);var n=new e(t);return t._localAnchorB&&(n.m_localAnchorB=t._localAnchorB),n},e.prototype.setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=r.clone(t)},e.prototype.getTarget=function(){return this.m_targetA},e.prototype.setMaxForce=function(t){this.m_maxForce=t},e.prototype.getMaxForce=function(){return this.m_maxForce},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return r.clone(this.m_targetA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(t,this.m_impulse)},e.prototype.getReactionTorque=function(t){return 0*t},e.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},e.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyB.c_position,i=this.m_bodyB.c_velocity,o=e.c,s=e.a,m=i.v,a=i.w,c=p.neo(s),h=this.m_bodyB.getMass(),_=2*n.PI*this.m_frequencyHz,l=2*h*this.m_dampingRatio*_,u=h*(_*_),y=t.dt;this.m_gamma=y*(l+y*u),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=y*u*this.m_gamma,this.m_rB=p.mulVec2(c,r.sub(this.m_localAnchorB,this.m_localCenterB));var d=new et;d.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,d.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,d.ey.x=d.ex.y,d.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=d.getInverse(),this.m_C.setVec2(o),this.m_C.addCombine(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),a*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),m.addMul(this.m_invMassB,this.m_impulse),a+=this.m_invIB*r.crossVec2Vec2(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),i.v.setVec2(m),i.w=a},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyB.c_velocity,i=r.clone(e.v),o=e.w,s=r.crossNumVec2(o,this.m_rB);s.add(i),s.addCombine(1,this.m_C,this.m_gamma,this.m_impulse),s.neg();var n=et.mulVec2(this.m_mass,s),m=r.clone(this.m_impulse);this.m_impulse.add(n);var a=t.dt*this.m_maxForce;this.m_impulse.clamp(a),n=r.sub(this.m_impulse,m),i.addMul(this.m_invMassB,n),o+=this.m_invIB*r.crossVec2Vec2(this.m_rB,n),e.v.setVec2(i),e.w=o},e.prototype.solvePositionConstraints=function(t){return!0},e.TYPE="mouse-joint",e}(z),Yt={collideConnected:!0},Wt=function(t){function e(i,o,m,a,c,h,_,l){var u=this;return u instanceof e?(i=s(i,Yt),o=(u=t.call(this,i,o,m)||this).m_bodyA,m=u.m_bodyB,u.m_type=e.TYPE,u.m_groundAnchorA=a||(i.groundAnchorA||r.neo(-1,1)),u.m_groundAnchorB=c||(i.groundAnchorB||r.neo(1,1)),u.m_localAnchorA=h?o.getLocalPoint(h):i.localAnchorA||r.neo(-1,0),u.m_localAnchorB=_?m.getLocalPoint(_):i.localAnchorB||r.neo(1,0),u.m_lengthA=n.isFinite(i.lengthA)?i.lengthA:r.distance(h,a),u.m_lengthB=n.isFinite(i.lengthB)?i.lengthB:r.distance(_,c),u.m_ratio=n.isFinite(l)?l:i.ratio,u.m_constant=u.m_lengthA+u.m_ratio*u.m_lengthB,u.m_impulse=0,u):new e(i,o,m,a,c,h,_,l)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,groundAnchorA:this.m_groundAnchorA,groundAnchorB:this.m_groundAnchorB,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,lengthA:this.m_lengthA,lengthB:this.m_lengthB,ratio:this.m_ratio}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype.getGroundAnchorA=function(){return this.m_groundAnchorA},e.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},e.prototype.getLengthA=function(){return this.m_lengthA},e.prototype.getLengthB=function(){return this.m_lengthB},e.prototype.getRatio=function(){return this.m_ratio},e.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),e=this.m_groundAnchorA;return r.distance(t,e)},e.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),e=this.m_groundAnchorB;return r.distance(t,e)},e.prototype.shiftOrigin=function(t){this.m_groundAnchorA.sub(t),this.m_groundAnchorB.sub(t)},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(this.m_impulse,this.m_uB).mul(t)},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,m=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=p.neo(i),l=p.neo(m);this.m_rA=p.mulVec2(_,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=p.mulVec2(l,r.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=r.sub(r.add(e,this.m_rA),this.m_groundAnchorA),this.m_uB=r.sub(r.add(n,this.m_rB),this.m_groundAnchorB);var u=this.m_uA.length(),y=this.m_uB.length();u>10*a.linearSlop?this.m_uA.mul(1/u):this.m_uA.setZero(),y>10*a.linearSlop?this.m_uB.mul(1/y):this.m_uB.setZero();var d=r.crossVec2Vec2(this.m_rA,this.m_uA),f=r.crossVec2Vec2(this.m_rB,this.m_uB),v=this.m_invMassA+this.m_invIA*d*d,x=this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=v+this.m_ratio*this.m_ratio*x,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var A=r.mulNumVec2(-this.m_impulse,this.m_uA),g=r.mulNumVec2(-this.m_ratio*this.m_impulse,this.m_uB);o.addMul(this.m_invMassA,A),s+=this.m_invIA*r.crossVec2Vec2(this.m_rA,A),c.addMul(this.m_invMassB,g),h+=this.m_invIB*r.crossVec2Vec2(this.m_rB,g)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=c,this.m_bodyB.c_velocity.w=h},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=r.add(e,r.crossNumVec2(i,this.m_rA)),m=r.add(o,r.crossNumVec2(s,this.m_rB)),a=-r.dot(this.m_uA,n)-this.m_ratio*r.dot(this.m_uB,m),c=-this.m_mass*a;this.m_impulse+=c;var h=r.mulNumVec2(-c,this.m_uA),_=r.mulNumVec2(-this.m_ratio*c,this.m_uB);e.addMul(this.m_invMassA,h),i+=this.m_invIA*r.crossVec2Vec2(this.m_rA,h),o.addMul(this.m_invMassB,_),s+=this.m_invIB*r.crossVec2Vec2(this.m_rB,_),this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,m=p.neo(i),c=p.neo(s),h=p.mulVec2(m,r.sub(this.m_localAnchorA,this.m_localCenterA)),_=p.mulVec2(c,r.sub(this.m_localAnchorB,this.m_localCenterB)),l=r.sub(r.add(e,this.m_rA),this.m_groundAnchorA),u=r.sub(r.add(o,this.m_rB),this.m_groundAnchorB),y=l.length(),d=u.length();y>10*a.linearSlop?l.mul(1/y):l.setZero(),d>10*a.linearSlop?u.mul(1/d):u.setZero();var f=r.crossVec2Vec2(h,l),v=r.crossVec2Vec2(_,u),x=this.m_invMassA+this.m_invIA*f*f,A=this.m_invMassB+this.m_invIB*v*v,g=x+this.m_ratio*this.m_ratio*A;g>0&&(g=1/g);var b=this.m_constant-y-this.m_ratio*d,B=n.abs(b),V=-g*b,w=r.mulNumVec2(-V,l),C=r.mulNumVec2(-this.m_ratio*V,u);return e.addMul(this.m_invMassA,w),i+=this.m_invIA*r.crossVec2Vec2(h,w),o.addMul(this.m_invMassB,C),s+=this.m_invIB*r.crossVec2Vec2(_,C),this.m_bodyA.c_position.c=e,this.m_bodyA.c_position.a=i,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,B<a.linearSlop},e.TYPE="pulley-joint",e}(z),Ht={maxLength:0},Zt=function(t){function e(i,o,n,m){var a=this;return a instanceof e?(i=s(i,Ht),o=(a=t.call(this,i,o,n)||this).m_bodyA,n=a.m_bodyB,a.m_type=e.TYPE,a.m_localAnchorA=m?o.getLocalPoint(m):i.localAnchorA||r.neo(-1,0),a.m_localAnchorB=m?n.getLocalPoint(m):i.localAnchorB||r.neo(1,0),a.m_maxLength=i.maxLength,a.m_mass=0,a.m_impulse=0,a.m_length=0,a.m_state=0,a):new e(i,o,n,m)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,maxLength:this.m_maxLength}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setMaxLength=function(t){this.m_maxLength=t},e.prototype.getMaxLength=function(){return this.m_maxLength},e.prototype.getLimitState=function(){return this.m_state},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.mulNumVec2(this.m_impulse,this.m_u).mul(t)},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,m=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=p.neo(i),l=p.neo(m);this.m_rA=p.mulSub(_,this.m_localAnchorA,this.m_localCenterA),this.m_rB=p.mulSub(l,this.m_localAnchorB,this.m_localCenterB),this.m_u=r.zero(),this.m_u.addCombine(1,n,1,this.m_rB),this.m_u.subCombine(1,e,1,this.m_rA),this.m_length=this.m_u.length();var u=this.m_length-this.m_maxLength;if(this.m_state=u>0?2:0,!(this.m_length>a.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var y=r.crossVec2Vec2(this.m_rA,this.m_u),d=r.crossVec2Vec2(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*d*d;if(this.m_mass=0!=f?1/f:0,t.warmStarting){this.m_impulse*=t.dtRatio;var v=r.mulNumVec2(this.m_impulse,this.m_u);o.subMul(this.m_invMassA,v),s-=this.m_invIA*r.crossVec2Vec2(this.m_rA,v),c.addMul(this.m_invMassB,v),h+=this.m_invIB*r.crossVec2Vec2(this.m_rB,v)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.setVec2(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.setVec2(c),this.m_bodyB.c_velocity.w=h},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,m=r.addCrossNumVec2(e,i,this.m_rA),a=r.addCrossNumVec2(o,s,this.m_rB),c=this.m_length-this.m_maxLength,h=r.dot(this.m_u,r.sub(a,m));c<0&&(h+=t.inv_dt*c);var _=-this.m_mass*h,l=this.m_impulse;this.m_impulse=n.min(0,this.m_impulse+_),_=this.m_impulse-l;var u=r.mulNumVec2(_,this.m_u);e.subMul(this.m_invMassA,u),i-=this.m_invIA*r.crossVec2Vec2(this.m_rA,u),o.addMul(this.m_invMassB,u),s+=this.m_invIB*r.crossVec2Vec2(this.m_rB,u),this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,m=p.neo(i),c=p.neo(s),h=p.mulSub(m,this.m_localAnchorA,this.m_localCenterA),_=p.mulSub(c,this.m_localAnchorB,this.m_localCenterB),l=r.zero();l.addCombine(1,o,1,_),l.subCombine(1,e,1,h);var u=l.normalize(),y=u-this.m_maxLength;y=n.clamp(y,0,a.maxLinearCorrection);var d=-this.m_mass*y,f=r.mulNumVec2(d,l);return e.subMul(this.m_invMassA,f),i-=this.m_invIA*r.crossVec2Vec2(h,f),o.addMul(this.m_invMassB,f),s+=this.m_invIB*r.crossVec2Vec2(_,f),this.m_bodyA.c_position.c.setVec2(e),this.m_bodyA.c_position.a=i,this.m_bodyB.c_position.c.setVec2(o),this.m_bodyB.c_position.a=s,u-this.m_maxLength<a.linearSlop},e.TYPE="rope-joint",e}(z),Xt={frequencyHz:0,dampingRatio:0},Kt=function(t){function e(i,o,m,a){var c=this;return c instanceof e?(i=s(i,Xt),o=(c=t.call(this,i,o,m)||this).m_bodyA,m=c.m_bodyB,c.m_type=e.TYPE,c.m_localAnchorA=r.clone(a?o.getLocalPoint(a):i.localAnchorA||r.zero()),c.m_localAnchorB=r.clone(a?m.getLocalPoint(a):i.localAnchorB||r.zero()),c.m_referenceAngle=n.isFinite(i.referenceAngle)?i.referenceAngle:m.getAngle()-o.getAngle(),c.m_frequencyHz=i.frequencyHz,c.m_dampingRatio=i.dampingRatio,c.m_impulse=new vt,c.m_bias=0,c.m_gamma=0,c.m_rA,c.m_rB,c.m_localCenterA,c.m_localCenterB,c.m_invMassA,c.m_invMassB,c.m_invIA,c.m_invIB,c.m_mass=new Ft,c):new e(i,o,m,a)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,referenceAngle:this.m_referenceAngle}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB)},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_bodyA.c_position.a,i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,c=p.neo(e),h=p.neo(s);this.m_rA=p.mulVec2(c,r.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=p.mulVec2(h,r.sub(this.m_localAnchorB,this.m_localCenterB));var _=this.m_invMassA,l=this.m_invMassB,u=this.m_invIA,y=this.m_invIB,d=new Ft;if(d.ex.x=_+l+this.m_rA.y*this.m_rA.y*u+this.m_rB.y*this.m_rB.y*y,d.ey.x=-this.m_rA.y*this.m_rA.x*u-this.m_rB.y*this.m_rB.x*y,d.ez.x=-this.m_rA.y*u-this.m_rB.y*y,d.ex.y=d.ey.x,d.ey.y=_+l+this.m_rA.x*this.m_rA.x*u+this.m_rB.x*this.m_rB.x*y,d.ez.y=this.m_rA.x*u+this.m_rB.x*y,d.ex.z=d.ez.x,d.ey.z=d.ez.y,d.ez.z=u+y,this.m_frequencyHz>0){d.getInverse22(this.m_mass);var f=u+y,v=f>0?1/f:0,x=s-e-this.m_referenceAngle,A=2*n.PI*this.m_frequencyHz,g=2*v*this.m_dampingRatio*A,b=v*A*A,B=t.dt;this.m_gamma=B*(g+B*b),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*b*this.m_gamma,f+=this.m_gamma,this.m_mass.ez.z=0!=f?1/f:0}else 0==d.ez.z?(d.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(d.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var V=r.neo(this.m_impulse.x,this.m_impulse.y);i.subMul(_,V),o-=u*(r.crossVec2Vec2(this.m_rA,V)+this.m_impulse.z),m.addMul(l,V),a+=y*(r.crossVec2Vec2(this.m_rB,V)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=a},e.prototype.solveVelocityConstraints=function(t){var e=this.m_bodyA.c_velocity.v,i=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,m=this.m_invMassB,a=this.m_invIA,c=this.m_invIB;if(this.m_frequencyHz>0){var h=s-i,_=-this.m_mass.ez.z*(h+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=_,i-=a*_,s+=c*_,(p=r.zero()).addCombine(1,o,1,r.crossNumVec2(s,this.m_rB)),p.subCombine(1,e,1,r.crossNumVec2(i,this.m_rA));var l=r.neg(Ft.mulVec2(this.m_mass,p));this.m_impulse.x+=l.x,this.m_impulse.y+=l.y;var u=r.clone(l);e.subMul(n,u),i-=a*r.crossVec2Vec2(this.m_rA,u),o.addMul(m,u),s+=c*r.crossVec2Vec2(this.m_rB,u)}else{var p;(p=r.zero()).addCombine(1,o,1,r.crossNumVec2(s,this.m_rB)),p.subCombine(1,e,1,r.crossNumVec2(i,this.m_rA));h=s-i;var y=new vt(p.x,p.y,h),d=vt.neg(Ft.mulVec3(this.m_mass,y));this.m_impulse.add(d);u=r.neo(d.x,d.y);e.subMul(n,u),i-=a*(r.crossVec2Vec2(this.m_rA,u)+d.z),o.addMul(m,u),s+=c*(r.crossVec2Vec2(this.m_rB,u)+d.z)}this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=i,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var e,i,o=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,m=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,h=p.neo(s),_=p.neo(c),l=this.m_invMassA,u=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,f=p.mulVec2(h,r.sub(this.m_localAnchorA,this.m_localCenterA)),v=p.mulVec2(_,r.sub(this.m_localAnchorB,this.m_localCenterB)),x=new Ft;if(x.ex.x=l+u+f.y*f.y*y+v.y*v.y*d,x.ey.x=-f.y*f.x*y-v.y*v.x*d,x.ez.x=-f.y*y-v.y*d,x.ex.y=x.ey.x,x.ey.y=l+u+f.x*f.x*y+v.x*v.x*d,x.ez.y=f.x*y+v.x*d,x.ex.z=x.ez.x,x.ey.z=x.ez.y,x.ez.z=y+d,this.m_frequencyHz>0){(g=r.zero()).addCombine(1,m,1,v),g.subCombine(1,o,1,f),e=g.length(),i=0;var A=r.neg(x.solve22(g));o.subMul(l,A),s-=y*r.crossVec2Vec2(f,A),m.addMul(u,A),c+=d*r.crossVec2Vec2(v,A)}else{var g;(g=r.zero()).addCombine(1,m,1,v),g.subCombine(1,o,1,f);var b=c-s-this.m_referenceAngle;e=g.length(),i=n.abs(b);var B=new vt(g.x,g.y,b),V=new vt;if(x.ez.z>0)V=vt.neg(x.solve33(B));else{var w=r.neg(x.solve22(g));V.set(w.x,w.y,0)}A=r.neo(V.x,V.y);o.subMul(l,A),s-=y*(r.crossVec2Vec2(f,A)+V.z),m.addMul(u,A),c+=d*(r.crossVec2Vec2(v,A)+V.z)}return this.m_bodyA.c_position.c=o,this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c=m,this.m_bodyB.c_position.a=c,e<=a.linearSlop&&i<=a.angularSlop},e.TYPE="weld-joint",e}(z),Gt={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7},Ut=function(t){function e(i,o,n,m,a){var c=this;return c instanceof e?(i=s(i,Gt),(c=t.call(this,i,o,n)||this).m_ax=r.zero(),c.m_ay=r.zero(),o=c.m_bodyA,n=c.m_bodyB,c.m_type=e.TYPE,c.m_localAnchorA=r.clone(m?o.getLocalPoint(m):i.localAnchorA||r.zero()),c.m_localAnchorB=r.clone(m?n.getLocalPoint(m):i.localAnchorB||r.zero()),c.m_localXAxisA=r.clone(a?o.getLocalVector(a):i.localAxisA||i.localAxis||r.neo(1,0)),c.m_localYAxisA=r.crossNumVec2(1,c.m_localXAxisA),c.m_mass=0,c.m_impulse=0,c.m_motorMass=0,c.m_motorImpulse=0,c.m_springMass=0,c.m_springImpulse=0,c.m_maxMotorTorque=i.maxMotorTorque,c.m_motorSpeed=i.motorSpeed,c.m_enableMotor=i.enableMotor,c.m_frequencyHz=i.frequencyHz,c.m_dampingRatio=i.dampingRatio,c.m_bias=0,c.m_gamma=0,c):new e(i,o,n,m,a)}return i(e,t),e.prototype._serialize=function(){return{type:this.m_type,bodyA:this.m_bodyA,bodyB:this.m_bodyB,collideConnected:this.m_collideConnected,enableMotor:this.m_enableMotor,maxMotorTorque:this.m_maxMotorTorque,motorSpeed:this.m_motorSpeed,frequencyHz:this.m_frequencyHz,dampingRatio:this.m_dampingRatio,localAnchorA:this.m_localAnchorA,localAnchorB:this.m_localAnchorB,localAxisA:this.m_localXAxisA}},e._deserialize=function(t,i,s){return(t=o({},t)).bodyA=s(I,t.bodyA,i),t.bodyB=s(I,t.bodyB,i),new e(t)},e.prototype._setAnchors=function(t){t.anchorA?this.m_localAnchorA.setVec2(this.m_bodyA.getLocalPoint(t.anchorA)):t.localAnchorA&&this.m_localAnchorA.setVec2(t.localAnchorA),t.anchorB?this.m_localAnchorB.setVec2(this.m_bodyB.getLocalPoint(t.anchorB)):t.localAnchorB&&this.m_localAnchorB.setVec2(t.localAnchorB),t.localAxisA&&(this.m_localXAxisA.setVec2(t.localAxisA),this.m_localYAxisA.setVec2(r.crossNumVec2(1,t.localAxisA)))},e.prototype.getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getLocalAxisA=function(){return this.m_localXAxisA},e.prototype.getJointTranslation=function(){var t=this.m_bodyA,e=this.m_bodyB,i=t.getWorldPoint(this.m_localAnchorA),o=e.getWorldPoint(this.m_localAnchorB),s=r.sub(o,i),n=t.getWorldVector(this.m_localXAxisA);return r.dot(s,n)},e.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},e.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},e.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},e.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},e.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},e.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return r.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax).mul(t)},e.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var e=this.m_invMassA,i=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,m=this.m_bodyA.c_position.c,a=this.m_bodyA.c_position.a,c=this.m_bodyA.c_velocity.v,h=this.m_bodyA.c_velocity.w,_=this.m_bodyB.c_position.c,l=this.m_bodyB.c_position.a,u=this.m_bodyB.c_velocity.v,y=this.m_bodyB.c_velocity.w,d=p.neo(a),f=p.neo(l),v=p.mulVec2(d,r.sub(this.m_localAnchorA,this.m_localCenterA)),x=p.mulVec2(f,r.sub(this.m_localAnchorB,this.m_localCenterB)),A=r.zero();if(A.addCombine(1,_,1,x),A.subCombine(1,m,1,v),this.m_ay=p.mulVec2(d,this.m_localYAxisA),this.m_sAy=r.crossVec2Vec2(r.add(A,v),this.m_ay),this.m_sBy=r.crossVec2Vec2(x,this.m_ay),this.m_mass=e+i+o*this.m_sAy*this.m_sAy+s*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=p.mulVec2(d,this.m_localXAxisA),this.m_sAx=r.crossVec2Vec2(r.add(A,v),this.m_ax),this.m_sBx=r.crossVec2Vec2(x,this.m_ax);var g=e+i+o*this.m_sAx*this.m_sAx+s*this.m_sBx*this.m_sBx;if(g>0){this.m_springMass=1/g;var b=r.dot(A,this.m_ax),B=2*n.PI*this.m_frequencyHz,V=2*this.m_springMass*this.m_dampingRatio*B,w=this.m_springMass*B*B,C=t.dt;this.m_gamma=C*(V+C*w),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=b*C*w*this.m_gamma,this.m_springMass=g+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=o+s,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var M=r.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),I=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,S=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;c.subMul(this.m_invMassA,M),h-=this.m_invIA*I,u.addMul(this.m_invMassB,M),y+=this.m_invIB*S}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.setVec2(c),this.m_bodyA.c_velocity.w=h,this.m_bodyB.c_velocity.v.setVec2(u),this.m_bodyB.c_velocity.w=y},e.prototype.solveVelocityConstraints=function(t){var e=this.m_invMassA,i=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,m=this.m_bodyA.c_velocity.v,a=this.m_bodyA.c_velocity.w,c=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=r.dot(this.m_ax,c)-r.dot(this.m_ax,m)+this.m_sBx*h-this.m_sAx*a,l=-this.m_springMass*(_+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=l;var u=r.mulNumVec2(l,this.m_ax),p=l*this.m_sAx,y=l*this.m_sBx;m.subMul(e,u),a-=o*p,c.addMul(i,u);_=(h+=s*y)-a-this.m_motorSpeed,l=-this.m_motorMass*_;var d=this.m_motorImpulse,f=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=n.clamp(this.m_motorImpulse+l,-f,f),a-=o*(l=this.m_motorImpulse-d),h+=s*l;_=r.dot(this.m_ay,c)-r.dot(this.m_ay,m)+this.m_sBy*h-this.m_sAy*a,l=-this.m_mass*_;this.m_impulse+=l;u=r.mulNumVec2(l,this.m_ay),p=l*this.m_sAy,y=l*this.m_sBy;m.subMul(e,u),a-=o*p,c.addMul(i,u),h+=s*y,this.m_bodyA.c_velocity.v.setVec2(m),this.m_bodyA.c_velocity.w=a,this.m_bodyB.c_velocity.v.setVec2(c),this.m_bodyB.c_velocity.w=h},e.prototype.solvePositionConstraints=function(t){var e=this.m_bodyA.c_position.c,i=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,m=p.neo(i),c=p.neo(s),h=p.mulVec2(m,r.sub(this.m_localAnchorA,this.m_localCenterA)),_=p.mulVec2(c,r.sub(this.m_localAnchorB,this.m_localCenterB)),l=r.zero();l.addCombine(1,o,1,_),l.subCombine(1,e,1,h);var u,y=p.mulVec2(m,this.m_localYAxisA),d=r.crossVec2Vec2(r.add(l,h),y),f=r.crossVec2Vec2(_,y),v=r.dot(l,y),x=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;u=0!=x?-v/x:0;var A=r.mulNumVec2(u,y),g=u*d,b=u*f;return e.subMul(this.m_invMassA,A),i-=this.m_invIA*g,o.addMul(this.m_invMassB,A),s+=this.m_invIB*b,this.m_bodyA.c_position.c.setVec2(e),this.m_bodyA.c_position.a=i,this.m_bodyB.c_position.c.setVec2(o),this.m_bodyB.c_position.a=s,n.abs(v)<=a.linearSlop},e.TYPE="wheel-joint",e}(z),Qt=0;function $t(t){var e,i=(t=t||{}).rootClass||ft,s=t.preSerialize||function(t){return t},n=t.postSerialize||function(t,e){return t},m=t.preDeserialize||function(t){return t},a=t.postDeserialize||function(t,e){return t},c={World:ft,Body:I,Joint:z,Fixture:b,Shape:x},h=o({Vec2:r,Vec3:vt},c),_=((e={})[I.STATIC]=I,e[I.DYNAMIC]=I,e[I.KINEMATIC]=I,e[gt.TYPE]=gt,e[wt.TYPE]=wt,e[xt.TYPE]=xt,e[Bt.TYPE]=Bt,e[Mt.TYPE]=Mt,e[zt.TYPE]=zt,e[Tt.TYPE]=Tt,e[jt.TYPE]=jt,e[Rt.TYPE]=Rt,e[Jt.TYPE]=Jt,e[kt.TYPE]=kt,e[Wt.TYPE]=Wt,e[qt.TYPE]=qt,e[Zt.TYPE]=Zt,e[Kt.TYPE]=Kt,e[Ut.TYPE]=Ut,e);this.toJson=function(t){var e=[],i=[t],o={};function r(t,s){if(t.__sid=t.__sid||++Qt,!o[t.__sid]){i.push(t);var n={refIndex:e.length+i.length,refType:s};o[t.__sid]=n}return o[t.__sid]}function m(t,e){if("object"!=typeof t||null===t)return t;if("function"==typeof t._serialize){if(t!==e)for(var i in c)if(t instanceof c[i])return r(t,i);t=function(t){var e=(t=s(t))._serialize();return n(e,t)}(t)}if(Array.isArray(t)){for(var o=[],a=0;a<t.length;a++)o[a]=m(t[a]);t=o}else{o={};for(var a in t)t.hasOwnProperty(a)&&(o[a]=m(t[a]));t=o}return t}for(;i.length;){var a=i.shift(),h=m(a,a);e.push(h)}return e},this.fromJson=function(t){var e={};function o(t,e,i){var o=function(t,e){return e&&e._deserialize||(e=_[t.type]),e&&e._deserialize}(e,t);if(o){var n=o(e=m(e),i,s);return n=a(n,e)}}function s(i,s,n){if(!s.refIndex)return i&&i._deserialize&&o(i,s,n);i=h[s.refType]||i;var r=s.refIndex;if(!e[r]){var m=o(i,t[r],n);e[r]=m}return e[r]}return i._deserialize(t[0],null,s)}}var te=new $t;$t.toJson=te.toJson,$t.fromJson=te.fromJson,yt.addType(Mt.TYPE,Mt.TYPE,(function(t,e,i,o,s,n,r){ee(t,i.getShape(),e,n.getShape(),s)}));var ee=function(e,i,o,s,n){e.pointCount=0;var m=y.mulVec2(o,i.m_p),a=y.mulVec2(n,s.m_p),c=r.distanceSquared(a,m),h=i.m_radius+s.m_radius;c>h*h||(e.type=t.ManifoldType.e_circles,e.localPoint.setVec2(i.m_p),e.localNormal.setZero(),e.pointCount=1,e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex)};yt.addType(xt.TYPE,Mt.TYPE,(function(t,e,i,o,s,n,r){var m=i.getShape(),a=n.getShape();ie(t,m,e,a,s)})),yt.addType(gt.TYPE,Mt.TYPE,(function(t,e,i,o,s,n,r){var m=i.getShape(),a=new xt;m.getChildEdge(a,o);var c=a,h=n.getShape();ie(t,c,e,h,s)}));var ie=function(e,i,o,s,n){e.pointCount=0;var m=y.mulTVec2(o,y.mulVec2(n,s.m_p)),a=i.m_vertex1,c=i.m_vertex2,h=r.sub(c,a),_=r.dot(h,r.sub(c,m)),l=r.dot(h,r.sub(m,a)),u=i.m_radius+s.m_radius;if(l<=0){var p=r.clone(a),d=r.sub(m,p);if(r.dot(d,d)>u*u)return;if(i.m_hasVertex0){var f=i.m_vertex0,v=a,x=r.sub(v,f);if(r.dot(x,r.sub(v,m))>0)return}return e.type=t.ManifoldType.e_circles,e.localNormal.setZero(),e.localPoint.setVec2(p),e.pointCount=1,e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,void(e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex)}if(_<=0){var A=r.clone(c),g=r.sub(m,A);if(r.dot(g,g)>u*u)return;if(i.m_hasVertex3){var b=i.m_vertex3,B=c,V=r.sub(b,B);if(r.dot(V,r.sub(m,B))>0)return}return e.type=t.ManifoldType.e_circles,e.localNormal.setZero(),e.localPoint.setVec2(A),e.pointCount=1,e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=1,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,void(e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex)}var w=r.dot(h,h),C=r.combine(_/w,a,l/w,c),M=r.sub(m,C);if(!(r.dot(M,M)>u*u)){var I=r.neo(-h.y,h.x);r.dot(I,r.sub(m,a))<0&&I.setNum(-I.x,-I.y),I.normalize(),e.type=t.ManifoldType.e_faceA,e.localNormal=I,e.localPoint.setVec2(a),e.pointCount=1,e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_face,e.points[0].id.cf.indexB=0,e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex}};function oe(t,e,i,o,s){for(var n=t.m_count,m=i.m_count,a=t.m_normals,c=t.m_vertices,h=i.m_vertices,_=y.mulTXf(o,e),l=0,u=-1/0,d=0;d<n;++d){for(var f=p.mulVec2(_.q,a[d]),v=y.mulVec2(_,c[d]),x=1/0,A=0;A<m;++A){var g=r.dot(f,h[A])-r.dot(f,v);g<x&&(x=g)}x>u&&(u=x,l=d)}s.maxSeparation=u,s.bestIndex=l}yt.addType(Bt.TYPE,Bt.TYPE,(function(t,e,i,o,s,n,r){ne(t,i.getShape(),e,n.getShape(),s)}));var se={maxSeparation:0,bestIndex:0},ne=function(e,i,o,s,n){e.pointCount=0;var m=i.m_radius+s.m_radius;oe(i,o,s,n,se);var c=se.bestIndex,h=se.maxSeparation;if(!(h>m)){oe(s,n,i,o,se);var _=se.bestIndex,l=se.maxSeparation;if(!(l>m)){var u,d,f,v,x,A;l>h+.1*a.linearSlop?(u=s,d=i,f=n,v=o,x=_,e.type=t.ManifoldType.e_faceB,A=1):(u=i,d=s,f=o,v=n,x=c,e.type=t.ManifoldType.e_faceA,A=0);var g=[new it,new it];!function(e,i,o,s,n,m){for(var a=i.m_normals,c=n.m_count,h=n.m_vertices,_=n.m_normals,l=p.mulTVec2(m.q,p.mulVec2(o.q,a[s])),u=0,d=1/0,f=0;f<c;++f){var v=r.dot(l,_[f]);v<d&&(d=v,u=f)}var x=u,A=x+1<c?x+1:0;e[0].v=y.mulVec2(m,h[x]),e[0].id.cf.indexA=s,e[0].id.cf.indexB=x,e[0].id.cf.typeA=t.ContactFeatureType.e_face,e[0].id.cf.typeB=t.ContactFeatureType.e_vertex,e[1].v=y.mulVec2(m,h[A]),e[1].id.cf.indexA=s,e[1].id.cf.indexB=A,e[1].id.cf.typeA=t.ContactFeatureType.e_face,e[1].id.cf.typeB=t.ContactFeatureType.e_vertex}(g,u,f,x,d,v);var b=u.m_count,B=u.m_vertices,V=x,w=x+1<b?x+1:0,C=B[V],M=B[w],I=r.sub(M,C);I.normalize();var S=r.crossVec2Num(I,1),z=r.combine(.5,C,.5,M),P=p.mulVec2(f.q,I),T=r.crossVec2Num(P,1);C=y.mulVec2(f,C),M=y.mulVec2(f,M);var F=r.dot(T,C),L=-r.dot(P,C)+m,q=r.dot(P,M)+m,N=[new it,new it],k=[new it,new it];if(!(ct(N,g,r.neg(P),L,V)<2||ct(k,N,P,q,w)<2)){e.localNormal=S,e.localPoint=z;for(var D=0,j=0;j<k.length;++j){if(r.dot(T,k[j].v)-F<=m){var O=e.points[D];if(O.localPoint.setVec2(y.mulTVec2(v,k[j].v)),O.id=k[j].id,A){var R=O.id.cf,E=R.indexA,J=R.indexB,Y=R.typeA,W=R.typeB;R.indexA=J,R.indexB=E,R.typeA=W,R.typeB=Y}++D}}e.pointCount=D}}}};yt.addType(Bt.TYPE,Mt.TYPE,(function(t,e,i,o,s,n,r){ae(t,i.getShape(),e,n.getShape(),s)}));var re,me,ae=function(e,i,o,s,m){e.pointCount=0;for(var a=y.mulVec2(m,s.m_p),c=y.mulTVec2(o,a),h=0,_=-1/0,l=i.m_radius+s.m_radius,u=i.m_count,p=i.m_vertices,d=i.m_normals,f=0;f<u;++f){var v=r.dot(d[f],r.sub(c,p[f]));if(v>l)return;v>_&&(_=v,h=f)}var x=h,A=x+1<u?x+1:0,g=p[x],b=p[A];if(_<n.EPSILON)return e.pointCount=1,e.type=t.ManifoldType.e_faceA,e.localNormal.setVec2(d[h]),e.localPoint.setCombine(.5,g,.5,b),e.points[0].localPoint=s.m_p,e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,void(e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex);var B=r.dot(r.sub(c,g),r.sub(b,g)),V=r.dot(r.sub(c,b),r.sub(g,b));if(B<=0){if(r.distanceSquared(c,g)>l*l)return;e.pointCount=1,e.type=t.ManifoldType.e_faceA,e.localNormal.setCombine(1,c,-1,g),e.localNormal.normalize(),e.localPoint=g,e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex}else if(V<=0){if(r.distanceSquared(c,b)>l*l)return;e.pointCount=1,e.type=t.ManifoldType.e_faceA,e.localNormal.setCombine(1,c,-1,b),e.localNormal.normalize(),e.localPoint.setVec2(b),e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex}else{var w=r.mid(g,b);if(r.dot(c,d[x])-r.dot(w,d[x])>l)return;e.pointCount=1,e.type=t.ManifoldType.e_faceA,e.localNormal.setVec2(d[x]),e.localPoint.setVec2(w),e.points[0].localPoint.setVec2(s.m_p),e.points[0].id.cf.indexA=0,e.points[0].id.cf.typeA=t.ContactFeatureType.e_vertex,e.points[0].id.cf.indexB=0,e.points[0].id.cf.typeB=t.ContactFeatureType.e_vertex}};yt.addType(xt.TYPE,Bt.TYPE,(function(t,e,i,o,s,n,r){de(t,i.getShape(),e,n.getShape(),s)})),yt.addType(gt.TYPE,Bt.TYPE,(function(t,e,i,o,s,n,r){var m=i.getShape(),a=new xt;m.getChildEdge(a,o),de(t,a,e,n.getShape(),s)})),function(t){t[t.e_unknown=-1]="e_unknown",t[t.e_edgeA=1]="e_edgeA",t[t.e_edgeB=2]="e_edgeB"}(re||(re={})),function(t){t[t.e_isolated=0]="e_isolated",t[t.e_concave=1]="e_concave",t[t.e_convex=2]="e_convex"}(me||(me={}));var ce=function(){},he=function(){this.vertices=[],this.normals=[],this.count=0},_e=function(){this.normal=r.zero(),this.sideNormal1=r.zero(),this.sideNormal2=r.zero()},le=new ce,ue=new ce,pe=new he,ye=new _e,de=function(e,i,o,s,m){var c=y.mulTXf(o,m),h=y.mulVec2(c,s.m_centroid),_=i.m_vertex0,l=i.m_vertex1,u=i.m_vertex2,d=i.m_vertex3,f=i.m_hasVertex0,v=i.m_hasVertex3,x=r.sub(u,l);x.normalize();var A,g,b,B=r.neo(x.y,-x.x),V=r.dot(B,r.sub(h,l)),w=0,C=0,M=!1,I=!1;if(f){var S=r.sub(l,_);S.normalize(),A=r.neo(S.y,-S.x),M=r.crossVec2Vec2(S,x)>=0,w=r.dot(A,h)-r.dot(A,_)}if(v){var z=r.sub(d,u);z.normalize(),g=r.neo(z.y,-z.x),I=r.crossVec2Vec2(x,z)>0,C=r.dot(g,h)-r.dot(g,u)}var P=r.zero(),T=r.zero(),F=r.zero();f&&v?M&&I?(b=w>=0||V>=0||C>=0)?(P.setVec2(B),T.setVec2(A),F.setVec2(g)):(P.setMul(-1,B),T.setMul(-1,B),F.setMul(-1,B)):M?(b=w>=0||V>=0&&C>=0)?(P.setVec2(B),T.setVec2(A),F.setVec2(B)):(P.setMul(-1,B),T.setMul(-1,g),F.setMul(-1,B)):I?(b=C>=0||w>=0&&V>=0)?(P.setVec2(B),T.setVec2(B),F.setVec2(g)):(P.setMul(-1,B),T.setMul(-1,B),F.setMul(-1,A)):(b=w>=0&&V>=0&&C>=0)?(P.setVec2(B),T.setVec2(B),F.setVec2(B)):(P.setMul(-1,B),T.setMul(-1,g),F.setMul(-1,A)):f?M?(b=w>=0||V>=0)?(P.setVec2(B),T.setVec2(A),F.setMul(-1,B)):(P.setMul(-1,B),T.setVec2(B),F.setMul(-1,B)):(b=w>=0&&V>=0)?(P.setVec2(B),T.setVec2(B),F.setMul(-1,B)):(P.setMul(-1,B),T.setVec2(B),F.setMul(-1,A)):v?I?(b=V>=0||C>=0)?(P.setVec2(B),T.setMul(-1,B),F.setVec2(g)):(P.setMul(-1,B),T.setMul(-1,B),F.setVec2(B)):(b=V>=0&&C>=0)?(P.setVec2(B),T.setMul(-1,B),F.setVec2(B)):(P.setMul(-1,B),T.setMul(-1,g),F.setVec2(B)):(b=V>=0)?(P.setVec2(B),T.setMul(-1,B),F.setMul(-1,B)):(P.setMul(-1,B),T.setVec2(B),F.setVec2(B)),pe.count=s.m_count;for(var L=0;L<s.m_count;++L)pe.vertices[L]=y.mulVec2(c,s.m_vertices[L]),pe.normals[L]=p.mulVec2(c.q,s.m_normals[L]);var q=2*a.polygonRadius;e.pointCount=0,le.type=re.e_edgeA,le.index=b?0:1,le.separation=1/0;for(L=0;L<pe.count;++L){(k=r.dot(P,r.sub(pe.vertices[L],l)))<le.separation&&(le.separation=k)}if(le.type!=re.e_unknown&&!(le.separation>q)){ue.type=re.e_unknown,ue.index=-1,ue.separation=-1/0;var N=r.neo(-P.y,P.x);for(L=0;L<pe.count;++L){var k,D=r.neg(pe.normals[L]),j=r.dot(D,r.sub(pe.vertices[L],l)),O=r.dot(D,r.sub(pe.vertices[L],u));if((k=n.min(j,O))>q){ue.type=re.e_edgeB,ue.index=L,ue.separation=k;break}if(r.dot(D,N)>=0){if(r.dot(r.sub(D,F),P)<-a.angularSlop)continue}else if(r.dot(r.sub(D,T),P)<-a.angularSlop)continue;k>ue.separation&&(ue.type=re.e_edgeB,ue.index=L,ue.separation=k)}if(!(ue.type!=re.e_unknown&&ue.separation>q)){var R;R=ue.type==re.e_unknown?le:ue.separation>.98*le.separation+.001?ue:le;var E=[new it,new it];if(R.type==re.e_edgeA){e.type=t.ManifoldType.e_faceA;var J=0,Y=r.dot(P,pe.normals[0]);for(L=1;L<pe.count;++L){var W=r.dot(P,pe.normals[L]);W<Y&&(Y=W,J=L)}var H=J,Z=H+1<pe.count?H+1:0;E[0].v=pe.vertices[H],E[0].id.cf.indexA=0,E[0].id.cf.indexB=H,E[0].id.cf.typeA=t.ContactFeatureType.e_face,E[0].id.cf.typeB=t.ContactFeatureType.e_vertex,E[1].v=pe.vertices[Z],E[1].id.cf.indexA=0,E[1].id.cf.indexB=Z,E[1].id.cf.typeA=t.ContactFeatureType.e_face,E[1].id.cf.typeB=t.ContactFeatureType.e_vertex,b?(ye.i1=0,ye.i2=1,ye.v1=l,ye.v2=u,ye.normal.setVec2(B)):(ye.i1=1,ye.i2=0,ye.v1=u,ye.v2=l,ye.normal.setMul(-1,B))}else e.type=t.ManifoldType.e_faceB,E[0].v=l,E[0].id.cf.indexA=0,E[0].id.cf.indexB=R.index,E[0].id.cf.typeA=t.ContactFeatureType.e_vertex,E[0].id.cf.typeB=t.ContactFeatureType.e_face,E[1].v=u,E[1].id.cf.indexA=0,E[1].id.cf.indexB=R.index,E[1].id.cf.typeA=t.ContactFeatureType.e_vertex,E[1].id.cf.typeB=t.ContactFeatureType.e_face,ye.i1=R.index,ye.i2=ye.i1+1<pe.count?ye.i1+1:0,ye.v1=pe.vertices[ye.i1],ye.v2=pe.vertices[ye.i2],ye.normal.setVec2(pe.normals[ye.i1]);ye.sideNormal1.setNum(ye.normal.y,-ye.normal.x),ye.sideNormal2.setMul(-1,ye.sideNormal1),ye.sideOffset1=r.dot(ye.sideNormal1,ye.v1),ye.sideOffset2=r.dot(ye.sideNormal2,ye.v2);var X=[new it,new it],K=[new it,new it];if(!(ct(X,E,ye.sideNormal1,ye.sideOffset1,ye.i1)<a.maxManifoldPoints||ct(K,X,ye.sideNormal2,ye.sideOffset2,ye.i2)<a.maxManifoldPoints)){R.type==re.e_edgeA?(e.localNormal=r.clone(ye.normal),e.localPoint=r.clone(ye.v1)):(e.localNormal=r.clone(s.m_normals[ye.i1]),e.localPoint=r.clone(s.m_vertices[ye.i1]));var G=0;for(L=0;L<a.maxManifoldPoints;++L){if(r.dot(ye.normal,r.sub(K[L].v,ye.v1))<=q){var U=e.points[G];R.type==re.e_edgeA?(U.localPoint=y.mulTVec2(c,K[L].v),U.id=K[L].id):(U.localPoint=K[L].v,U.id.cf.typeA=K[L].id.cf.typeB,U.id.cf.typeB=K[L].id.cf.typeA,U.id.cf.indexA=K[L].id.cf.indexB,U.id.cf.indexB=K[L].id.cf.indexA),++G}}e.pointCount=G}}}},fe=n,ve={CollidePolygons:ne,Settings:a,Sweep:d,Manifold:ot,Distance:k,TimeOfImpact:H,DynamicTree:_,stats:P},xe=Object.freeze({__proto__:null,Math:fe,internal:ve,Serializer:$t,math:n,Vec2:r,Vec3:vt,Mat22:et,Mat33:Ft,Transform:y,Rot:p,AABB:m,Shape:x,FixtureProxy:g,Fixture:b,MassData:M,Body:I,ContactEdge:ht,mixFriction:_t,mixRestitution:lt,VelocityConstraintPoint:pt,Contact:yt,JointEdge:S,Joint:z,World:ft,CircleShape:Mt,Circle:It,EdgeShape:xt,Edge:At,PolygonShape:Bt,Polygon:Vt,ChainShape:gt,Chain:bt,BoxShape:wt,Box:Ct,CollideCircles:ee,CollideEdgeCircle:ie,CollidePolygons:ne,CollidePolygonCircle:ae,CollideEdgePolygon:de,DistanceJoint:zt,FrictionJoint:Tt,GearJoint:jt,MotorJoint:Rt,MouseJoint:Jt,PrismaticJoint:kt,PulleyJoint:Wt,RevoluteJoint:qt,RopeJoint:Zt,WeldJoint:Kt,WheelJoint:Ut,Settings:a,Sweep:d,get ManifoldType(){return t.ManifoldType},get ContactFeatureType(){return t.ContactFeatureType},get PointState(){return t.PointState},ClipVertex:it,Manifold:ot,ManifoldPoint:st,ContactID:nt,ContactFeature:rt,WorldManifold:mt,getPointStates:at,clipSegmentToLine:ct,DistanceInput:L,DistanceOutput:q,SimplexCache:N,Distance:k,DistanceProxy:D,testOverlap:R,TOIInput:J,get TOIOutputState(){return t.TOIOutputState},TOIOutput:Y,TimeOfImpact:H,TreeNode:h,DynamicTree:_,stats:P});t.AABB=m,t.Body=I,t.Box=Ct,t.BoxShape=wt,t.Chain=bt,t.ChainShape=gt,t.Circle=It,t.CircleShape=Mt,t.ClipVertex=it,t.CollideCircles=ee,t.CollideEdgeCircle=ie,t.CollideEdgePolygon=de,t.CollidePolygonCircle=ae,t.CollidePolygons=ne,t.Contact=yt,t.ContactEdge=ht,t.ContactFeature=rt,t.ContactID=nt,t.Distance=k,t.DistanceInput=L,t.DistanceJoint=zt,t.DistanceOutput=q,t.DistanceProxy=D,t.DynamicTree=_,t.Edge=At,t.EdgeShape=xt,t.Fixture=b,t.FixtureProxy=g,t.FrictionJoint=Tt,t.GearJoint=jt,t.Joint=z,t.JointEdge=S,t.Manifold=ot,t.ManifoldPoint=st,t.MassData=M,t.Mat22=et,t.Mat33=Ft,t.Math=fe,t.MotorJoint=Rt,t.MouseJoint=Jt,t.Polygon=Vt,t.PolygonShape=Bt,t.PrismaticJoint=kt,t.PulleyJoint=Wt,t.RevoluteJoint=qt,t.RopeJoint=Zt,t.Rot=p,t.Serializer=$t,t.Settings=a,t.Shape=x,t.SimplexCache=N,t.Sweep=d,t.TOIInput=J,t.TOIOutput=Y,t.TimeOfImpact=H,t.Transform=y,t.TreeNode=h,t.Vec2=r,t.Vec3=vt,t.VelocityConstraintPoint=pt,t.WeldJoint=Kt,t.WheelJoint=Ut,t.World=ft,t.WorldManifold=mt,t.clipSegmentToLine=ct,t.default=xe,t.getPointStates=at,t.internal=ve,t.math=n,t.mixFriction=_t,t.mixRestitution=lt,t.stats=P,t.testOverlap=R,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=planck.min.js.map
